/* THIS FILE IS AUTOGENERATED FROM /builddir/build/BUILD/VirtualBox-4.2.0_RC3/src/VBox/GuestHost/OpenGL/packer/pack_arrays.c BY pack_swap.py */


/* Copyright (c) 2001, Stanford University
 * All rights reserved
 *
 * See the file LICENSE.txt for information on redistributing this software.
 */

#include "packer.h"
#include "cr_opcodes.h"
#include "cr_error.h"
#include "iprt/types.h"

#define UNUSED(x) ((void)(x))
/**
 * \mainpage Packer
 *
 * \section PackerIntroduction Introduction
 *
 * Chromium consists of all the top-level files in the cr
 * directory.  The packer module basically takes care of API dispatch,
 * and OpenGL state management.
 *
 */

void PACK_APIENTRY crPackVertexPointerSWAP( GLint size, GLenum type, GLsizei stride, const GLvoid *pointer )
{
	/* Packing this command is only useful if we have server-side vertex
	 * arrays - GL_ARB_vertex_buffer_object.  Note that pointer will really
	 * be an offset into a server-side buffer.
     * @todo Because of that we'd only transfer lowest 32bit as there're no 4gb+VBOs (yet?).
     * Look at glgets regarding max vertices in arrays.
	 */
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	int packet_length = 24;
	CR_GET_BUFFERED_POINTER( pc, packet_length );
	WRITE_DATA( 0, GLint, SWAP32(packet_length) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_VERTEXPOINTER_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLint, SWAP32(size) );
	WRITE_DATA( 12, GLenum, SWAP32(type) );
	WRITE_DATA( 16, GLsizei, SWAP32(stride) );
	WRITE_DATA( 20, GLuint, SWAP32((GLuint) ((uintptr_t) pointer)) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
    CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColorPointerSWAP( GLint size, GLenum type, GLsizei stride, const GLvoid *pointer )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	int packet_length = 24;
	CR_GET_BUFFERED_POINTER( pc, packet_length );
	WRITE_DATA( 0, GLint, SWAP32(packet_length) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_COLORPOINTER_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLint, SWAP32(size) );
	WRITE_DATA( 12, GLenum, SWAP32(type) );
	WRITE_DATA( 16, GLsizei, SWAP32(stride) );
	WRITE_DATA( 20, GLuint, SWAP32((GLuint) ((uintptr_t) pointer)) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
    CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackNormalPointerSWAP( GLenum type, GLsizei stride, const GLvoid *pointer )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	int packet_length = 20;
	CR_GET_BUFFERED_POINTER( pc, packet_length );
	WRITE_DATA( 0, GLint, SWAP32(packet_length) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_NORMALPOINTER_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(type) );
	WRITE_DATA( 12, GLsizei, SWAP32(stride) );
	WRITE_DATA( 16, GLuint, SWAP32((GLuint) ((uintptr_t) pointer)) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
    CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoordPointerSWAP( GLint size, GLenum type, GLsizei stride, const GLvoid *pointer )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	int packet_length = 24;
	CR_GET_BUFFERED_POINTER( pc, packet_length );
	WRITE_DATA( 0, GLint, SWAP32(packet_length) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_TEXCOORDPOINTER_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLint, SWAP32(size) );
	WRITE_DATA( 12, GLenum, SWAP32(type) );
	WRITE_DATA( 16, GLsizei, SWAP32(stride) );
	WRITE_DATA( 20, GLuint, SWAP32((GLuint) ((uintptr_t) pointer)) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
    CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEdgeFlagPointerSWAP( GLsizei stride, const GLvoid *pointer )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	int packet_length = 16;
	CR_GET_BUFFERED_POINTER( pc, packet_length );
	WRITE_DATA( 0, GLint, SWAP32(packet_length) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_EDGEFLAGPOINTER_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLsizei, SWAP32(stride) );
	WRITE_DATA( 12, GLuint, SWAP32((GLuint) ((uintptr_t) pointer)) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
    CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIndexPointerSWAP( GLenum type, GLsizei stride, const GLvoid *pointer )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	int packet_length = 20;
	CR_GET_BUFFERED_POINTER( pc, packet_length );
	WRITE_DATA( 0, GLint, SWAP32(packet_length) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_INDEXPOINTER_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(type) );
	WRITE_DATA( 12, GLsizei, SWAP32(stride) );
	WRITE_DATA( 16, GLuint, SWAP32((GLuint) ((uintptr_t) pointer)) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
    CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColorPointerEXTSWAP( GLint size, GLenum type, GLsizei stride, const GLvoid *pointer )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	int packet_length = 24;
	CR_GET_BUFFERED_POINTER( pc, packet_length );
	WRITE_DATA( 0, GLint, SWAP32(packet_length) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_SECONDARYCOLORPOINTEREXT_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLint, SWAP32(size) );
	WRITE_DATA( 12, GLenum, SWAP32(type) );
	WRITE_DATA( 16, GLsizei, SWAP32(stride) );
	WRITE_DATA( 20, GLuint, SWAP32((GLuint) ((uintptr_t) pointer)) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
    CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFogCoordPointerEXTSWAP( GLenum type, GLsizei stride, const GLvoid * pointer )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	int packet_length = 20;
	CR_GET_BUFFERED_POINTER( pc, packet_length );
	WRITE_DATA( 0, GLint, SWAP32(packet_length) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_FOGCOORDPOINTEREXT_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(type) );
	WRITE_DATA( 12, GLsizei, SWAP32(stride) );
	WRITE_DATA( 16, GLuint, SWAP32((GLuint) ((uintptr_t) pointer)) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
    CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttribPointerARBSWAP( GLuint index, GLint size, GLenum type, GLboolean normalized, GLsizei stride, const GLvoid *pointer )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	int packet_length = 32;
	CR_GET_BUFFERED_POINTER( pc, packet_length );
	WRITE_DATA( 0, GLint, SWAP32(packet_length) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_VERTEXATTRIBPOINTERARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLint, SWAP32(index) );
	WRITE_DATA( 12, GLint, SWAP32(size) );
	WRITE_DATA( 16, GLenum, SWAP32(type) );
	WRITE_DATA( 20, GLboolean, normalized );
	WRITE_DATA( 24, GLsizei, SWAP32(stride) );
	WRITE_DATA( 28, GLuint, SWAP32((GLuint) ((uintptr_t) pointer)) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
    CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttribPointerNVSWAP( GLuint index, GLint size, GLenum type, GLsizei stride, const GLvoid *pointer )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	int packet_length = 28;
	CR_GET_BUFFERED_POINTER( pc, packet_length );
	WRITE_DATA( 0, GLint, SWAP32(packet_length) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_VERTEXATTRIBPOINTERNV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLint, SWAP32(index) );
	WRITE_DATA( 12, GLint, SWAP32(size) );
	WRITE_DATA( 16, GLenum, SWAP32(type) );
	WRITE_DATA( 20, GLsizei, SWAP32(stride) );
	WRITE_DATA( 24, GLuint, SWAP32((GLuint) ((uintptr_t) pointer)) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
    CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackInterleavedArraysSWAP( GLenum format, GLsizei stride, const GLvoid *pointer )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	int packet_length = 20;
	CR_GET_BUFFERED_POINTER( pc, packet_length );
	WRITE_DATA( 0, GLint, SWAP32(packet_length) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_INTERLEAVEDARRAYS_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(format) );
	WRITE_DATA( 12, GLsizei, SWAP32(stride) );
	WRITE_DATA( 16, GLuint, SWAP32((GLuint) ((uintptr_t) pointer)) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
    CR_UNLOCK_PACKER_CONTEXT(pc);
}


void PACK_APIENTRY crPackVertexArrayRangeNVSWAP( GLsizei length, const GLvoid *pointer )
{
	UNUSED( length );
	UNUSED( pointer );
	crWarning( "Unimplemented crPackVertexArrayRangeNVSWAP" );
}
