/* Copyright (c) 2001, Stanford University
	All rights reserved.

	See the file LICENSE.txt for information on redistributing this software. */
	

/* DO NOT EDIT - THIS FILE GENERATED BY THE packer.py SCRIPT */

/* For each of the OpenGL functions we have a packer function which
 * packs the function's opcode and arguments into a buffer.
 */

#include "packer.h"
#include "cr_opcodes.h"


void PACK_APIENTRY crPackAccum( GLenum op, GLfloat value )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, 16 );
	WRITE_DATA( 4, GLenum, CR_ACCUM_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, op );
	WRITE_DATA( 12, GLfloat, value );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackAccumSWAP( GLenum op, GLfloat value )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(16) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_ACCUM_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(op) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(value) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackActiveStencilFaceEXT( GLenum face )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, 12 );
	WRITE_DATA( 4, GLenum, CR_ACTIVESTENCILFACEEXT_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, face );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackActiveStencilFaceEXTSWAP( GLenum face )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(12) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_ACTIVESTENCILFACEEXT_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(face) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackActiveTextureARB( GLenum texture )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, 12 );
	WRITE_DATA( 4, GLenum, CR_ACTIVETEXTUREARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, texture );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackActiveTextureARBSWAP( GLenum texture )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(12) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_ACTIVETEXTUREARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(texture) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackAlphaFunc( GLenum func, GLclampf ref )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLenum, func );
	WRITE_DATA( 4, GLclampf, ref );
	WRITE_OPCODE( pc, CR_ALPHAFUNC_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackAlphaFuncSWAP( GLenum func, GLclampf ref )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLenum, SWAP32(func) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(ref) );
	WRITE_OPCODE( pc, CR_ALPHAFUNC_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackArrayElement( GLint i )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLint, i );
	WRITE_OPCODE( pc, CR_ARRAYELEMENT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackArrayElementSWAP( GLint i )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLint, SWAP32(i) );
	WRITE_OPCODE( pc, CR_ARRAYELEMENT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackAttachShader( GLuint program, GLuint shader )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, 16 );
	WRITE_DATA( 4, GLenum, CR_ATTACHSHADER_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, program );
	WRITE_DATA( 12, GLuint, shader );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackAttachShaderSWAP( GLuint program, GLuint shader )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(16) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_ATTACHSHADER_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(program) );
	WRITE_DATA( 12, GLuint, SWAP32(shader) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBarrierCreateCR( GLuint name, GLuint count )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, 16 );
	WRITE_DATA( 4, GLenum, CR_BARRIERCREATECR_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, name );
	WRITE_DATA( 12, GLuint, count );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBarrierCreateCRSWAP( GLuint name, GLuint count )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(16) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_BARRIERCREATECR_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(name) );
	WRITE_DATA( 12, GLuint, SWAP32(count) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBarrierDestroyCR( GLuint name )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, 12 );
	WRITE_DATA( 4, GLenum, CR_BARRIERDESTROYCR_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, name );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBarrierDestroyCRSWAP( GLuint name )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(12) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_BARRIERDESTROYCR_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(name) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBarrierExecCR( GLuint name )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, 12 );
	WRITE_DATA( 4, GLenum, CR_BARRIEREXECCR_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, name );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBarrierExecCRSWAP( GLuint name )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(12) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_BARRIEREXECCR_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(name) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBeginQueryARB( GLenum target, GLuint id )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, 16 );
	WRITE_DATA( 4, GLenum, CR_BEGINQUERYARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLuint, id );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBeginQueryARBSWAP( GLenum target, GLuint id )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(16) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_BEGINQUERYARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLuint, SWAP32(id) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBindBufferARB( GLenum target, GLuint buffer )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, 16 );
	WRITE_DATA( 4, GLenum, CR_BINDBUFFERARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLuint, buffer );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBindBufferARBSWAP( GLenum target, GLuint buffer )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(16) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_BINDBUFFERARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLuint, SWAP32(buffer) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBindFramebufferEXT( GLenum target, GLuint framebuffer )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, 16 );
	WRITE_DATA( 4, GLenum, CR_BINDFRAMEBUFFEREXT_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLuint, framebuffer );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBindFramebufferEXTSWAP( GLenum target, GLuint framebuffer )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(16) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_BINDFRAMEBUFFEREXT_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLuint, SWAP32(framebuffer) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBindProgramARB( GLenum target, GLuint program )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, 16 );
	WRITE_DATA( 4, GLenum, CR_BINDPROGRAMARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLuint, program );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBindProgramARBSWAP( GLenum target, GLuint program )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(16) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_BINDPROGRAMARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLuint, SWAP32(program) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBindProgramNV( GLenum target, GLuint id )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, 16 );
	WRITE_DATA( 4, GLenum, CR_BINDPROGRAMNV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLuint, id );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBindProgramNVSWAP( GLenum target, GLuint id )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(16) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_BINDPROGRAMNV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLuint, SWAP32(id) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBindRenderbufferEXT( GLenum target, GLuint renderbuffer )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, 16 );
	WRITE_DATA( 4, GLenum, CR_BINDRENDERBUFFEREXT_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLuint, renderbuffer );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBindRenderbufferEXTSWAP( GLenum target, GLuint renderbuffer )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(16) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_BINDRENDERBUFFEREXT_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLuint, SWAP32(renderbuffer) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBindTexture( GLenum target, GLuint texture )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLenum, target );
	WRITE_DATA( 4, GLuint, texture );
	WRITE_OPCODE( pc, CR_BINDTEXTURE_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBindTextureSWAP( GLenum target, GLuint texture )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLenum, SWAP32(target) );
	WRITE_DATA( 4, GLuint, SWAP32(texture) );
	WRITE_OPCODE( pc, CR_BINDTEXTURE_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBlendColorEXT( GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, 24 );
	WRITE_DATA( 4, GLenum, CR_BLENDCOLOREXT_EXTEND_OPCODE );
	WRITE_DATA( 8, GLclampf, red );
	WRITE_DATA( 12, GLclampf, green );
	WRITE_DATA( 16, GLclampf, blue );
	WRITE_DATA( 20, GLclampf, alpha );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBlendColorEXTSWAP( GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, SWAP32(24) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_BLENDCOLOREXT_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(red) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(green) );
	WRITE_DATA( 16, GLuint, SWAPFLOAT(blue) );
	WRITE_DATA( 20, GLuint, SWAPFLOAT(alpha) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBlendEquationEXT( GLenum mode )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, 12 );
	WRITE_DATA( 4, GLenum, CR_BLENDEQUATIONEXT_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, mode );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBlendEquationEXTSWAP( GLenum mode )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(12) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_BLENDEQUATIONEXT_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(mode) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBlendEquationSeparate( GLenum modeRGB, GLenum modeAlpha )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, 16 );
	WRITE_DATA( 4, GLenum, CR_BLENDEQUATIONSEPARATE_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, modeRGB );
	WRITE_DATA( 12, GLenum, modeAlpha );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBlendEquationSeparateSWAP( GLenum modeRGB, GLenum modeAlpha )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(16) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_BLENDEQUATIONSEPARATE_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(modeRGB) );
	WRITE_DATA( 12, GLenum, SWAP32(modeAlpha) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBlendFunc( GLenum sfactor, GLenum dfactor )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLenum, sfactor );
	WRITE_DATA( 4, GLenum, dfactor );
	WRITE_OPCODE( pc, CR_BLENDFUNC_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBlendFuncSWAP( GLenum sfactor, GLenum dfactor )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLenum, SWAP32(sfactor) );
	WRITE_DATA( 4, GLenum, SWAP32(dfactor) );
	WRITE_OPCODE( pc, CR_BLENDFUNC_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBlendFuncSeparateEXT( GLenum sfactorRGB, GLenum dfactorRGB, GLenum sfactorA, GLenum dfactorA )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, 24 );
	WRITE_DATA( 4, GLenum, CR_BLENDFUNCSEPARATEEXT_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, sfactorRGB );
	WRITE_DATA( 12, GLenum, dfactorRGB );
	WRITE_DATA( 16, GLenum, sfactorA );
	WRITE_DATA( 20, GLenum, dfactorA );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBlendFuncSeparateEXTSWAP( GLenum sfactorRGB, GLenum dfactorRGB, GLenum sfactorA, GLenum dfactorA )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, SWAP32(24) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_BLENDFUNCSEPARATEEXT_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(sfactorRGB) );
	WRITE_DATA( 12, GLenum, SWAP32(dfactorRGB) );
	WRITE_DATA( 16, GLenum, SWAP32(sfactorA) );
	WRITE_DATA( 20, GLenum, SWAP32(dfactorA) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBlitFramebufferEXT( GLint srcX0, GLint srcY0, GLint srcX1, GLint srcY1, GLint dstX0, GLint dstY0, GLint dstX1, GLint dstY1, GLbitfield mask, GLenum filter )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 48 );
	WRITE_DATA( 0, GLint, 48 );
	WRITE_DATA( 4, GLenum, CR_BLITFRAMEBUFFEREXT_EXTEND_OPCODE );
	WRITE_DATA( 8, GLint, srcX0 );
	WRITE_DATA( 12, GLint, srcY0 );
	WRITE_DATA( 16, GLint, srcX1 );
	WRITE_DATA( 20, GLint, srcY1 );
	WRITE_DATA( 24, GLint, dstX0 );
	WRITE_DATA( 28, GLint, dstY0 );
	WRITE_DATA( 32, GLint, dstX1 );
	WRITE_DATA( 36, GLint, dstY1 );
	WRITE_DATA( 40, GLbitfield, mask );
	WRITE_DATA( 44, GLenum, filter );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackBlitFramebufferEXTSWAP( GLint srcX0, GLint srcY0, GLint srcX1, GLint srcY1, GLint dstX0, GLint dstY0, GLint dstX1, GLint dstY1, GLbitfield mask, GLenum filter )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 48 );
	WRITE_DATA( 0, GLint, SWAP32(48) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_BLITFRAMEBUFFEREXT_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLint, SWAP32(srcX0) );
	WRITE_DATA( 12, GLint, SWAP32(srcY0) );
	WRITE_DATA( 16, GLint, SWAP32(srcX1) );
	WRITE_DATA( 20, GLint, SWAP32(srcY1) );
	WRITE_DATA( 24, GLint, SWAP32(dstX0) );
	WRITE_DATA( 28, GLint, SWAP32(dstY0) );
	WRITE_DATA( 32, GLint, SWAP32(dstX1) );
	WRITE_DATA( 36, GLint, SWAP32(dstY1) );
	WRITE_DATA( 40, GLbitfield, SWAP32(mask) );
	WRITE_DATA( 44, GLenum, SWAP32(filter) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCallList( GLuint list )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLuint, list );
	WRITE_OPCODE( pc, CR_CALLLIST_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCallListSWAP( GLuint list )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLuint, SWAP32(list) );
	WRITE_OPCODE( pc, CR_CALLLIST_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCheckFramebufferStatusEXT( GLenum target, GLenum * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_CHECKFRAMEBUFFERSTATUSEXT_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCheckFramebufferStatusEXTSWAP( GLenum target, GLenum * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_CHECKFRAMEBUFFERSTATUSEXT_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackChromiumParameterfCR( GLenum target, GLfloat value )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, 16 );
	WRITE_DATA( 4, GLenum, CR_CHROMIUMPARAMETERFCR_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLfloat, value );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackChromiumParameterfCRSWAP( GLenum target, GLfloat value )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(16) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_CHROMIUMPARAMETERFCR_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(value) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackChromiumParameteriCR( GLenum target, GLint value )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, 16 );
	WRITE_DATA( 4, GLenum, CR_CHROMIUMPARAMETERICR_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLint, value );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackChromiumParameteriCRSWAP( GLenum target, GLint value )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(16) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_CHROMIUMPARAMETERICR_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLint, SWAP32(value) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackClear( GLbitfield mask )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLbitfield, mask );
	WRITE_OPCODE( pc, CR_CLEAR_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackClearSWAP( GLbitfield mask )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLbitfield, SWAP32(mask) );
	WRITE_OPCODE( pc, CR_CLEAR_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackClearAccum( GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, 24 );
	WRITE_DATA( 4, GLenum, CR_CLEARACCUM_EXTEND_OPCODE );
	WRITE_DATA( 8, GLfloat, red );
	WRITE_DATA( 12, GLfloat, green );
	WRITE_DATA( 16, GLfloat, blue );
	WRITE_DATA( 20, GLfloat, alpha );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackClearAccumSWAP( GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, SWAP32(24) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_CLEARACCUM_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(red) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(green) );
	WRITE_DATA( 16, GLuint, SWAPFLOAT(blue) );
	WRITE_DATA( 20, GLuint, SWAPFLOAT(alpha) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackClearColor( GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, 24 );
	WRITE_DATA( 4, GLenum, CR_CLEARCOLOR_EXTEND_OPCODE );
	WRITE_DATA( 8, GLclampf, red );
	WRITE_DATA( 12, GLclampf, green );
	WRITE_DATA( 16, GLclampf, blue );
	WRITE_DATA( 20, GLclampf, alpha );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackClearColorSWAP( GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, SWAP32(24) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_CLEARCOLOR_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(red) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(green) );
	WRITE_DATA( 16, GLuint, SWAPFLOAT(blue) );
	WRITE_DATA( 20, GLuint, SWAPFLOAT(alpha) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackClearDepth( GLclampd depth )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, 16 );
	WRITE_DATA( 4, GLenum, CR_CLEARDEPTH_EXTEND_OPCODE );
	WRITE_DOUBLE( 8, depth );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackClearDepthSWAP( GLclampd depth )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(16) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_CLEARDEPTH_EXTEND_OPCODE) );
	WRITE_SWAPPED_DOUBLE( 8, depth );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackClearIndex( GLfloat c )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, 12 );
	WRITE_DATA( 4, GLenum, CR_CLEARINDEX_EXTEND_OPCODE );
	WRITE_DATA( 8, GLfloat, c );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackClearIndexSWAP( GLfloat c )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(12) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_CLEARINDEX_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(c) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackClearStencil( GLint s )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, 12 );
	WRITE_DATA( 4, GLenum, CR_CLEARSTENCIL_EXTEND_OPCODE );
	WRITE_DATA( 8, GLint, s );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackClearStencilSWAP( GLint s )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(12) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_CLEARSTENCIL_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLint, SWAP32(s) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackClientActiveTextureARB( GLenum texture )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, 12 );
	WRITE_DATA( 4, GLenum, CR_CLIENTACTIVETEXTUREARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, texture );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackClientActiveTextureARBSWAP( GLenum texture )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(12) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_CLIENTACTIVETEXTUREARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(texture) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3b( GLbyte red, GLbyte green, GLbyte blue )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 4, GL_TRUE );
	pc->current.c.color.b3 = data_ptr;
	WRITE_DATA( 0, GLbyte, red );
	WRITE_DATA( 1, GLbyte, green );
	WRITE_DATA( 2, GLbyte, blue );
	WRITE_OPCODE( pc, CR_COLOR3B_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3bSWAP( GLbyte red, GLbyte green, GLbyte blue )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 4, GL_TRUE );
	pc->current.c.color.b3 = data_ptr;
	WRITE_DATA( 0, GLbyte, red );
	WRITE_DATA( 1, GLbyte, green );
	WRITE_DATA( 2, GLbyte, blue );
	WRITE_OPCODE( pc, CR_COLOR3B_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3bv( const GLbyte * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color3bv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 4, GL_TRUE );
	pc->current.c.color.b3 = data_ptr;
	WRITE_DATA( 0, GLbyte, v[0] );
	WRITE_DATA( 1, GLbyte, v[1] );
	WRITE_DATA( 2, GLbyte, v[2] );
	WRITE_OPCODE( pc, CR_COLOR3B_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3bvSWAP( const GLbyte * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color3bv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 4, GL_TRUE );
	pc->current.c.color.b3 = data_ptr;
	WRITE_DATA( 0, GLbyte, v[0] );
	WRITE_DATA( 1, GLbyte, v[1] );
	WRITE_DATA( 2, GLbyte, v[2] );
	WRITE_OPCODE( pc, CR_COLOR3B_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3d( GLdouble red, GLdouble green, GLdouble blue )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 24, GL_TRUE );
	pc->current.c.color.d3 = data_ptr;
	WRITE_DOUBLE( 0, red );
	WRITE_DOUBLE( 8, green );
	WRITE_DOUBLE( 16, blue );
	WRITE_OPCODE( pc, CR_COLOR3D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3dSWAP( GLdouble red, GLdouble green, GLdouble blue )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 24, GL_TRUE );
	pc->current.c.color.d3 = data_ptr;
	WRITE_SWAPPED_DOUBLE( 0, red );
	WRITE_SWAPPED_DOUBLE( 8, green );
	WRITE_SWAPPED_DOUBLE( 16, blue );
	WRITE_OPCODE( pc, CR_COLOR3D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3dv( const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color3dv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 24, GL_TRUE );
	pc->current.c.color.d3 = data_ptr;
	WRITE_DOUBLE( 0, v[0] );
	WRITE_DOUBLE( 8, v[1] );
	WRITE_DOUBLE( 16, v[2] );
	WRITE_OPCODE( pc, CR_COLOR3D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3dvSWAP( const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color3dv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 24, GL_TRUE );
	pc->current.c.color.d3 = data_ptr;
	WRITE_SWAPPED_DOUBLE( 0, v[0] );
	WRITE_SWAPPED_DOUBLE( 8, v[1] );
	WRITE_SWAPPED_DOUBLE( 16, v[2] );
	WRITE_OPCODE( pc, CR_COLOR3D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3f( GLfloat red, GLfloat green, GLfloat blue )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 12, GL_TRUE );
	pc->current.c.color.f3 = data_ptr;
	WRITE_DATA( 0, GLfloat, red );
	WRITE_DATA( 4, GLfloat, green );
	WRITE_DATA( 8, GLfloat, blue );
	WRITE_OPCODE( pc, CR_COLOR3F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3fSWAP( GLfloat red, GLfloat green, GLfloat blue )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 12, GL_TRUE );
	pc->current.c.color.f3 = data_ptr;
	WRITE_DATA( 0, GLuint, SWAPFLOAT(red) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(green) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(blue) );
	WRITE_OPCODE( pc, CR_COLOR3F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3fv( const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color3fv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 12, GL_TRUE );
	pc->current.c.color.f3 = data_ptr;
	WRITE_DATA( 0, GLfloat, v[0] );
	WRITE_DATA( 4, GLfloat, v[1] );
	WRITE_DATA( 8, GLfloat, v[2] );
	WRITE_OPCODE( pc, CR_COLOR3F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3fvSWAP( const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color3fv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 12, GL_TRUE );
	pc->current.c.color.f3 = data_ptr;
	WRITE_DATA( 0, GLuint, SWAPFLOAT(v[0]) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(v[1]) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(v[2]) );
	WRITE_OPCODE( pc, CR_COLOR3F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3i( GLint red, GLint green, GLint blue )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 12, GL_TRUE );
	pc->current.c.color.i3 = data_ptr;
	WRITE_DATA( 0, GLint, red );
	WRITE_DATA( 4, GLint, green );
	WRITE_DATA( 8, GLint, blue );
	WRITE_OPCODE( pc, CR_COLOR3I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3iSWAP( GLint red, GLint green, GLint blue )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 12, GL_TRUE );
	pc->current.c.color.i3 = data_ptr;
	WRITE_DATA( 0, GLint, SWAP32(red) );
	WRITE_DATA( 4, GLint, SWAP32(green) );
	WRITE_DATA( 8, GLint, SWAP32(blue) );
	WRITE_OPCODE( pc, CR_COLOR3I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3iv( const GLint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color3iv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 12, GL_TRUE );
	pc->current.c.color.i3 = data_ptr;
	WRITE_DATA( 0, GLint, v[0] );
	WRITE_DATA( 4, GLint, v[1] );
	WRITE_DATA( 8, GLint, v[2] );
	WRITE_OPCODE( pc, CR_COLOR3I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3ivSWAP( const GLint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color3iv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 12, GL_TRUE );
	pc->current.c.color.i3 = data_ptr;
	WRITE_DATA( 0, GLint, SWAP32(v[0]) );
	WRITE_DATA( 4, GLint, SWAP32(v[1]) );
	WRITE_DATA( 8, GLint, SWAP32(v[2]) );
	WRITE_OPCODE( pc, CR_COLOR3I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3s( GLshort red, GLshort green, GLshort blue )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 8, GL_TRUE );
	pc->current.c.color.s3 = data_ptr;
	WRITE_DATA( 0, GLshort, red );
	WRITE_DATA( 2, GLshort, green );
	WRITE_DATA( 4, GLshort, blue );
	WRITE_OPCODE( pc, CR_COLOR3S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3sSWAP( GLshort red, GLshort green, GLshort blue )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 8, GL_TRUE );
	pc->current.c.color.s3 = data_ptr;
	WRITE_DATA( 0, GLshort, SWAP16(red) );
	WRITE_DATA( 2, GLshort, SWAP16(green) );
	WRITE_DATA( 4, GLshort, SWAP16(blue) );
	WRITE_OPCODE( pc, CR_COLOR3S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3sv( const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color3sv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 8, GL_TRUE );
	pc->current.c.color.s3 = data_ptr;
	WRITE_DATA( 0, GLshort, v[0] );
	WRITE_DATA( 2, GLshort, v[1] );
	WRITE_DATA( 4, GLshort, v[2] );
	WRITE_OPCODE( pc, CR_COLOR3S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3svSWAP( const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color3sv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 8, GL_TRUE );
	pc->current.c.color.s3 = data_ptr;
	WRITE_DATA( 0, GLshort, SWAP16(v[0]) );
	WRITE_DATA( 2, GLshort, SWAP16(v[1]) );
	WRITE_DATA( 4, GLshort, SWAP16(v[2]) );
	WRITE_OPCODE( pc, CR_COLOR3S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3ub( GLubyte red, GLubyte green, GLubyte blue )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 4, GL_TRUE );
	pc->current.c.color.ub3 = data_ptr;
	WRITE_DATA( 0, GLubyte, red );
	WRITE_DATA( 1, GLubyte, green );
	WRITE_DATA( 2, GLubyte, blue );
	WRITE_OPCODE( pc, CR_COLOR3UB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3ubSWAP( GLubyte red, GLubyte green, GLubyte blue )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 4, GL_TRUE );
	pc->current.c.color.ub3 = data_ptr;
	WRITE_DATA( 0, GLubyte, red );
	WRITE_DATA( 1, GLubyte, green );
	WRITE_DATA( 2, GLubyte, blue );
	WRITE_OPCODE( pc, CR_COLOR3UB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3ubv( const GLubyte * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color3ubv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 4, GL_TRUE );
	pc->current.c.color.ub3 = data_ptr;
	WRITE_DATA( 0, GLubyte, v[0] );
	WRITE_DATA( 1, GLubyte, v[1] );
	WRITE_DATA( 2, GLubyte, v[2] );
	WRITE_OPCODE( pc, CR_COLOR3UB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3ubvSWAP( const GLubyte * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color3ubv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 4, GL_TRUE );
	pc->current.c.color.ub3 = data_ptr;
	WRITE_DATA( 0, GLubyte, v[0] );
	WRITE_DATA( 1, GLubyte, v[1] );
	WRITE_DATA( 2, GLubyte, v[2] );
	WRITE_OPCODE( pc, CR_COLOR3UB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3ui( GLuint red, GLuint green, GLuint blue )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 12, GL_TRUE );
	pc->current.c.color.ui3 = data_ptr;
	WRITE_DATA( 0, GLuint, red );
	WRITE_DATA( 4, GLuint, green );
	WRITE_DATA( 8, GLuint, blue );
	WRITE_OPCODE( pc, CR_COLOR3UI_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3uiSWAP( GLuint red, GLuint green, GLuint blue )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 12, GL_TRUE );
	pc->current.c.color.ui3 = data_ptr;
	WRITE_DATA( 0, GLuint, SWAP32(red) );
	WRITE_DATA( 4, GLuint, SWAP32(green) );
	WRITE_DATA( 8, GLuint, SWAP32(blue) );
	WRITE_OPCODE( pc, CR_COLOR3UI_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3uiv( const GLuint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color3uiv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 12, GL_TRUE );
	pc->current.c.color.ui3 = data_ptr;
	WRITE_DATA( 0, GLuint, v[0] );
	WRITE_DATA( 4, GLuint, v[1] );
	WRITE_DATA( 8, GLuint, v[2] );
	WRITE_OPCODE( pc, CR_COLOR3UI_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3uivSWAP( const GLuint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color3uiv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 12, GL_TRUE );
	pc->current.c.color.ui3 = data_ptr;
	WRITE_DATA( 0, GLuint, SWAP32(v[0]) );
	WRITE_DATA( 4, GLuint, SWAP32(v[1]) );
	WRITE_DATA( 8, GLuint, SWAP32(v[2]) );
	WRITE_OPCODE( pc, CR_COLOR3UI_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3us( GLushort red, GLushort green, GLushort blue )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 8, GL_TRUE );
	pc->current.c.color.us3 = data_ptr;
	WRITE_DATA( 0, GLushort, red );
	WRITE_DATA( 2, GLushort, green );
	WRITE_DATA( 4, GLushort, blue );
	WRITE_OPCODE( pc, CR_COLOR3US_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3usSWAP( GLushort red, GLushort green, GLushort blue )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 8, GL_TRUE );
	pc->current.c.color.us3 = data_ptr;
	WRITE_DATA( 0, GLushort, SWAP16(red) );
	WRITE_DATA( 2, GLushort, SWAP16(green) );
	WRITE_DATA( 4, GLushort, SWAP16(blue) );
	WRITE_OPCODE( pc, CR_COLOR3US_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3usv( const GLushort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color3usv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 8, GL_TRUE );
	pc->current.c.color.us3 = data_ptr;
	WRITE_DATA( 0, GLushort, v[0] );
	WRITE_DATA( 2, GLushort, v[1] );
	WRITE_DATA( 4, GLushort, v[2] );
	WRITE_OPCODE( pc, CR_COLOR3US_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor3usvSWAP( const GLushort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color3usv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 8, GL_TRUE );
	pc->current.c.color.us3 = data_ptr;
	WRITE_DATA( 0, GLushort, SWAP16(v[0]) );
	WRITE_DATA( 2, GLushort, SWAP16(v[1]) );
	WRITE_DATA( 4, GLushort, SWAP16(v[2]) );
	WRITE_OPCODE( pc, CR_COLOR3US_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4b( GLbyte red, GLbyte green, GLbyte blue, GLbyte alpha )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 4, GL_TRUE );
	pc->current.c.color.b4 = data_ptr;
	WRITE_DATA( 0, GLbyte, red );
	WRITE_DATA( 1, GLbyte, green );
	WRITE_DATA( 2, GLbyte, blue );
	WRITE_DATA( 3, GLbyte, alpha );
	WRITE_OPCODE( pc, CR_COLOR4B_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4bSWAP( GLbyte red, GLbyte green, GLbyte blue, GLbyte alpha )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 4, GL_TRUE );
	pc->current.c.color.b4 = data_ptr;
	WRITE_DATA( 0, GLbyte, red );
	WRITE_DATA( 1, GLbyte, green );
	WRITE_DATA( 2, GLbyte, blue );
	WRITE_DATA( 3, GLbyte, alpha );
	WRITE_OPCODE( pc, CR_COLOR4B_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4bv( const GLbyte * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color4bv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 4, GL_TRUE );
	pc->current.c.color.b4 = data_ptr;
	WRITE_DATA( 0, GLbyte, v[0] );
	WRITE_DATA( 1, GLbyte, v[1] );
	WRITE_DATA( 2, GLbyte, v[2] );
	WRITE_DATA( 3, GLbyte, v[3] );
	WRITE_OPCODE( pc, CR_COLOR4B_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4bvSWAP( const GLbyte * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color4bv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 4, GL_TRUE );
	pc->current.c.color.b4 = data_ptr;
	WRITE_DATA( 0, GLbyte, v[0] );
	WRITE_DATA( 1, GLbyte, v[1] );
	WRITE_DATA( 2, GLbyte, v[2] );
	WRITE_DATA( 3, GLbyte, v[3] );
	WRITE_OPCODE( pc, CR_COLOR4B_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4d( GLdouble red, GLdouble green, GLdouble blue, GLdouble alpha )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 32, GL_TRUE );
	pc->current.c.color.d4 = data_ptr;
	WRITE_DOUBLE( 0, red );
	WRITE_DOUBLE( 8, green );
	WRITE_DOUBLE( 16, blue );
	WRITE_DOUBLE( 24, alpha );
	WRITE_OPCODE( pc, CR_COLOR4D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4dSWAP( GLdouble red, GLdouble green, GLdouble blue, GLdouble alpha )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 32, GL_TRUE );
	pc->current.c.color.d4 = data_ptr;
	WRITE_SWAPPED_DOUBLE( 0, red );
	WRITE_SWAPPED_DOUBLE( 8, green );
	WRITE_SWAPPED_DOUBLE( 16, blue );
	WRITE_SWAPPED_DOUBLE( 24, alpha );
	WRITE_OPCODE( pc, CR_COLOR4D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4dv( const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color4dv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 32, GL_TRUE );
	pc->current.c.color.d4 = data_ptr;
	WRITE_DOUBLE( 0, v[0] );
	WRITE_DOUBLE( 8, v[1] );
	WRITE_DOUBLE( 16, v[2] );
	WRITE_DOUBLE( 24, v[3] );
	WRITE_OPCODE( pc, CR_COLOR4D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4dvSWAP( const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color4dv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 32, GL_TRUE );
	pc->current.c.color.d4 = data_ptr;
	WRITE_SWAPPED_DOUBLE( 0, v[0] );
	WRITE_SWAPPED_DOUBLE( 8, v[1] );
	WRITE_SWAPPED_DOUBLE( 16, v[2] );
	WRITE_SWAPPED_DOUBLE( 24, v[3] );
	WRITE_OPCODE( pc, CR_COLOR4D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4f( GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 16, GL_TRUE );
	pc->current.c.color.f4 = data_ptr;
	WRITE_DATA( 0, GLfloat, red );
	WRITE_DATA( 4, GLfloat, green );
	WRITE_DATA( 8, GLfloat, blue );
	WRITE_DATA( 12, GLfloat, alpha );
	WRITE_OPCODE( pc, CR_COLOR4F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4fSWAP( GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 16, GL_TRUE );
	pc->current.c.color.f4 = data_ptr;
	WRITE_DATA( 0, GLuint, SWAPFLOAT(red) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(green) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(blue) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(alpha) );
	WRITE_OPCODE( pc, CR_COLOR4F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4fv( const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color4fv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 16, GL_TRUE );
	pc->current.c.color.f4 = data_ptr;
	WRITE_DATA( 0, GLfloat, v[0] );
	WRITE_DATA( 4, GLfloat, v[1] );
	WRITE_DATA( 8, GLfloat, v[2] );
	WRITE_DATA( 12, GLfloat, v[3] );
	WRITE_OPCODE( pc, CR_COLOR4F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4fvSWAP( const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color4fv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 16, GL_TRUE );
	pc->current.c.color.f4 = data_ptr;
	WRITE_DATA( 0, GLuint, SWAPFLOAT(v[0]) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(v[1]) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(v[2]) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(v[3]) );
	WRITE_OPCODE( pc, CR_COLOR4F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4i( GLint red, GLint green, GLint blue, GLint alpha )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 16, GL_TRUE );
	pc->current.c.color.i4 = data_ptr;
	WRITE_DATA( 0, GLint, red );
	WRITE_DATA( 4, GLint, green );
	WRITE_DATA( 8, GLint, blue );
	WRITE_DATA( 12, GLint, alpha );
	WRITE_OPCODE( pc, CR_COLOR4I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4iSWAP( GLint red, GLint green, GLint blue, GLint alpha )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 16, GL_TRUE );
	pc->current.c.color.i4 = data_ptr;
	WRITE_DATA( 0, GLint, SWAP32(red) );
	WRITE_DATA( 4, GLint, SWAP32(green) );
	WRITE_DATA( 8, GLint, SWAP32(blue) );
	WRITE_DATA( 12, GLint, SWAP32(alpha) );
	WRITE_OPCODE( pc, CR_COLOR4I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4iv( const GLint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color4iv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 16, GL_TRUE );
	pc->current.c.color.i4 = data_ptr;
	WRITE_DATA( 0, GLint, v[0] );
	WRITE_DATA( 4, GLint, v[1] );
	WRITE_DATA( 8, GLint, v[2] );
	WRITE_DATA( 12, GLint, v[3] );
	WRITE_OPCODE( pc, CR_COLOR4I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4ivSWAP( const GLint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color4iv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 16, GL_TRUE );
	pc->current.c.color.i4 = data_ptr;
	WRITE_DATA( 0, GLint, SWAP32(v[0]) );
	WRITE_DATA( 4, GLint, SWAP32(v[1]) );
	WRITE_DATA( 8, GLint, SWAP32(v[2]) );
	WRITE_DATA( 12, GLint, SWAP32(v[3]) );
	WRITE_OPCODE( pc, CR_COLOR4I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4s( GLshort red, GLshort green, GLshort blue, GLshort alpha )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 8, GL_TRUE );
	pc->current.c.color.s4 = data_ptr;
	WRITE_DATA( 0, GLshort, red );
	WRITE_DATA( 2, GLshort, green );
	WRITE_DATA( 4, GLshort, blue );
	WRITE_DATA( 6, GLshort, alpha );
	WRITE_OPCODE( pc, CR_COLOR4S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4sSWAP( GLshort red, GLshort green, GLshort blue, GLshort alpha )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 8, GL_TRUE );
	pc->current.c.color.s4 = data_ptr;
	WRITE_DATA( 0, GLshort, SWAP16(red) );
	WRITE_DATA( 2, GLshort, SWAP16(green) );
	WRITE_DATA( 4, GLshort, SWAP16(blue) );
	WRITE_DATA( 6, GLshort, SWAP16(alpha) );
	WRITE_OPCODE( pc, CR_COLOR4S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4sv( const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color4sv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 8, GL_TRUE );
	pc->current.c.color.s4 = data_ptr;
	WRITE_DATA( 0, GLshort, v[0] );
	WRITE_DATA( 2, GLshort, v[1] );
	WRITE_DATA( 4, GLshort, v[2] );
	WRITE_DATA( 6, GLshort, v[3] );
	WRITE_OPCODE( pc, CR_COLOR4S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4svSWAP( const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color4sv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 8, GL_TRUE );
	pc->current.c.color.s4 = data_ptr;
	WRITE_DATA( 0, GLshort, SWAP16(v[0]) );
	WRITE_DATA( 2, GLshort, SWAP16(v[1]) );
	WRITE_DATA( 4, GLshort, SWAP16(v[2]) );
	WRITE_DATA( 6, GLshort, SWAP16(v[3]) );
	WRITE_OPCODE( pc, CR_COLOR4S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4ub( GLubyte red, GLubyte green, GLubyte blue, GLubyte alpha )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 4, GL_TRUE );
	pc->current.c.color.ub4 = data_ptr;
	WRITE_DATA( 0, GLubyte, red );
	WRITE_DATA( 1, GLubyte, green );
	WRITE_DATA( 2, GLubyte, blue );
	WRITE_DATA( 3, GLubyte, alpha );
	WRITE_OPCODE( pc, CR_COLOR4UB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4ubSWAP( GLubyte red, GLubyte green, GLubyte blue, GLubyte alpha )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 4, GL_TRUE );
	pc->current.c.color.ub4 = data_ptr;
	WRITE_DATA( 0, GLubyte, red );
	WRITE_DATA( 1, GLubyte, green );
	WRITE_DATA( 2, GLubyte, blue );
	WRITE_DATA( 3, GLubyte, alpha );
	WRITE_OPCODE( pc, CR_COLOR4UB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4ubv( const GLubyte * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color4ubv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 4, GL_TRUE );
	pc->current.c.color.ub4 = data_ptr;
	WRITE_DATA( 0, GLubyte, v[0] );
	WRITE_DATA( 1, GLubyte, v[1] );
	WRITE_DATA( 2, GLubyte, v[2] );
	WRITE_DATA( 3, GLubyte, v[3] );
	WRITE_OPCODE( pc, CR_COLOR4UB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4ubvSWAP( const GLubyte * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color4ubv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 4, GL_TRUE );
	pc->current.c.color.ub4 = data_ptr;
	WRITE_DATA( 0, GLubyte, v[0] );
	WRITE_DATA( 1, GLubyte, v[1] );
	WRITE_DATA( 2, GLubyte, v[2] );
	WRITE_DATA( 3, GLubyte, v[3] );
	WRITE_OPCODE( pc, CR_COLOR4UB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4ui( GLuint red, GLuint green, GLuint blue, GLuint alpha )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 16, GL_TRUE );
	pc->current.c.color.ui4 = data_ptr;
	WRITE_DATA( 0, GLuint, red );
	WRITE_DATA( 4, GLuint, green );
	WRITE_DATA( 8, GLuint, blue );
	WRITE_DATA( 12, GLuint, alpha );
	WRITE_OPCODE( pc, CR_COLOR4UI_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4uiSWAP( GLuint red, GLuint green, GLuint blue, GLuint alpha )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 16, GL_TRUE );
	pc->current.c.color.ui4 = data_ptr;
	WRITE_DATA( 0, GLuint, SWAP32(red) );
	WRITE_DATA( 4, GLuint, SWAP32(green) );
	WRITE_DATA( 8, GLuint, SWAP32(blue) );
	WRITE_DATA( 12, GLuint, SWAP32(alpha) );
	WRITE_OPCODE( pc, CR_COLOR4UI_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4uiv( const GLuint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color4uiv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 16, GL_TRUE );
	pc->current.c.color.ui4 = data_ptr;
	WRITE_DATA( 0, GLuint, v[0] );
	WRITE_DATA( 4, GLuint, v[1] );
	WRITE_DATA( 8, GLuint, v[2] );
	WRITE_DATA( 12, GLuint, v[3] );
	WRITE_OPCODE( pc, CR_COLOR4UI_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4uivSWAP( const GLuint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color4uiv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 16, GL_TRUE );
	pc->current.c.color.ui4 = data_ptr;
	WRITE_DATA( 0, GLuint, SWAP32(v[0]) );
	WRITE_DATA( 4, GLuint, SWAP32(v[1]) );
	WRITE_DATA( 8, GLuint, SWAP32(v[2]) );
	WRITE_DATA( 12, GLuint, SWAP32(v[3]) );
	WRITE_OPCODE( pc, CR_COLOR4UI_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4us( GLushort red, GLushort green, GLushort blue, GLushort alpha )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 8, GL_TRUE );
	pc->current.c.color.us4 = data_ptr;
	WRITE_DATA( 0, GLushort, red );
	WRITE_DATA( 2, GLushort, green );
	WRITE_DATA( 4, GLushort, blue );
	WRITE_DATA( 6, GLushort, alpha );
	WRITE_OPCODE( pc, CR_COLOR4US_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4usSWAP( GLushort red, GLushort green, GLushort blue, GLushort alpha )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 8, GL_TRUE );
	pc->current.c.color.us4 = data_ptr;
	WRITE_DATA( 0, GLushort, SWAP16(red) );
	WRITE_DATA( 2, GLushort, SWAP16(green) );
	WRITE_DATA( 4, GLushort, SWAP16(blue) );
	WRITE_DATA( 6, GLushort, SWAP16(alpha) );
	WRITE_OPCODE( pc, CR_COLOR4US_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4usv( const GLushort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color4usv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 8, GL_TRUE );
	pc->current.c.color.us4 = data_ptr;
	WRITE_DATA( 0, GLushort, v[0] );
	WRITE_DATA( 2, GLushort, v[1] );
	WRITE_DATA( 4, GLushort, v[2] );
	WRITE_DATA( 6, GLushort, v[3] );
	WRITE_OPCODE( pc, CR_COLOR4US_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColor4usvSWAP( const GLushort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Color4usv");
        return;
    }
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 8, GL_TRUE );
	pc->current.c.color.us4 = data_ptr;
	WRITE_DATA( 0, GLushort, SWAP16(v[0]) );
	WRITE_DATA( 2, GLushort, SWAP16(v[1]) );
	WRITE_DATA( 4, GLushort, SWAP16(v[2]) );
	WRITE_DATA( 6, GLushort, SWAP16(v[3]) );
	WRITE_OPCODE( pc, CR_COLOR4US_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColorMask( GLboolean red, GLboolean green, GLboolean blue, GLboolean alpha )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 4, GL_TRUE );
	WRITE_DATA( 0, GLboolean, red );
	WRITE_DATA( 1, GLboolean, green );
	WRITE_DATA( 2, GLboolean, blue );
	WRITE_DATA( 3, GLboolean, alpha );
	WRITE_OPCODE( pc, CR_COLORMASK_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColorMaskSWAP( GLboolean red, GLboolean green, GLboolean blue, GLboolean alpha )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 4, GL_TRUE );
	WRITE_DATA( 0, GLboolean, red );
	WRITE_DATA( 1, GLboolean, green );
	WRITE_DATA( 2, GLboolean, blue );
	WRITE_DATA( 3, GLboolean, alpha );
	WRITE_OPCODE( pc, CR_COLORMASK_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColorMaterial( GLenum face, GLenum mode )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 8, GL_TRUE );
	WRITE_DATA( 0, GLenum, face );
	WRITE_DATA( 4, GLenum, mode );
	WRITE_OPCODE( pc, CR_COLORMATERIAL_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackColorMaterialSWAP( GLenum face, GLenum mode )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 8, GL_TRUE );
	WRITE_DATA( 0, GLenum, SWAP32(face) );
	WRITE_DATA( 4, GLenum, SWAP32(mode) );
	WRITE_OPCODE( pc, CR_COLORMATERIAL_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCombinerInputNV( GLenum stage, GLenum portion, GLenum variable, GLenum input, GLenum mapping, GLenum componentUsage )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_COMBINERINPUTNV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, stage );
	WRITE_DATA( 12, GLenum, portion );
	WRITE_DATA( 16, GLenum, variable );
	WRITE_DATA( 20, GLenum, input );
	WRITE_DATA( 24, GLenum, mapping );
	WRITE_DATA( 28, GLenum, componentUsage );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCombinerInputNVSWAP( GLenum stage, GLenum portion, GLenum variable, GLenum input, GLenum mapping, GLenum componentUsage )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_COMBINERINPUTNV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(stage) );
	WRITE_DATA( 12, GLenum, SWAP32(portion) );
	WRITE_DATA( 16, GLenum, SWAP32(variable) );
	WRITE_DATA( 20, GLenum, SWAP32(input) );
	WRITE_DATA( 24, GLenum, SWAP32(mapping) );
	WRITE_DATA( 28, GLenum, SWAP32(componentUsage) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCombinerOutputNV( GLenum stage, GLenum portion, GLenum abOutput, GLenum cdOutput, GLenum sumOutput, GLenum scale, GLenum bias, GLboolean abDotProduct, GLboolean cdDotProduct, GLboolean muxSum )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 40 );
	WRITE_DATA( 0, GLint, 40 );
	WRITE_DATA( 4, GLenum, CR_COMBINEROUTPUTNV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, stage );
	WRITE_DATA( 12, GLenum, portion );
	WRITE_DATA( 16, GLenum, abOutput );
	WRITE_DATA( 20, GLenum, cdOutput );
	WRITE_DATA( 24, GLenum, sumOutput );
	WRITE_DATA( 28, GLenum, scale );
	WRITE_DATA( 32, GLenum, bias );
	WRITE_DATA( 36, GLboolean, abDotProduct );
	WRITE_DATA( 37, GLboolean, cdDotProduct );
	WRITE_DATA( 38, GLboolean, muxSum );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCombinerOutputNVSWAP( GLenum stage, GLenum portion, GLenum abOutput, GLenum cdOutput, GLenum sumOutput, GLenum scale, GLenum bias, GLboolean abDotProduct, GLboolean cdDotProduct, GLboolean muxSum )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 40 );
	WRITE_DATA( 0, GLint, SWAP32(40) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_COMBINEROUTPUTNV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(stage) );
	WRITE_DATA( 12, GLenum, SWAP32(portion) );
	WRITE_DATA( 16, GLenum, SWAP32(abOutput) );
	WRITE_DATA( 20, GLenum, SWAP32(cdOutput) );
	WRITE_DATA( 24, GLenum, SWAP32(sumOutput) );
	WRITE_DATA( 28, GLenum, SWAP32(scale) );
	WRITE_DATA( 32, GLenum, SWAP32(bias) );
	WRITE_DATA( 36, GLboolean, abDotProduct );
	WRITE_DATA( 37, GLboolean, cdDotProduct );
	WRITE_DATA( 38, GLboolean, muxSum );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCombinerParameterfNV( GLenum pname, GLfloat param )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, 16 );
	WRITE_DATA( 4, GLenum, CR_COMBINERPARAMETERFNV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, pname );
	WRITE_DATA( 12, GLfloat, param );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCombinerParameterfNVSWAP( GLenum pname, GLfloat param )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(16) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_COMBINERPARAMETERFNV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(pname) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(param) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCombinerParameteriNV( GLenum pname, GLint param )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, 16 );
	WRITE_DATA( 4, GLenum, CR_COMBINERPARAMETERINV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, pname );
	WRITE_DATA( 12, GLint, param );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCombinerParameteriNVSWAP( GLenum pname, GLint param )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(16) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_COMBINERPARAMETERINV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(pname) );
	WRITE_DATA( 12, GLint, SWAP32(param) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCompileShader( GLuint shader )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, 12 );
	WRITE_DATA( 4, GLenum, CR_COMPILESHADER_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, shader );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCompileShaderSWAP( GLuint shader )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(12) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_COMPILESHADER_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(shader) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCopyPixels( GLint x, GLint y, GLsizei width, GLsizei height, GLenum type )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 20 );
	WRITE_DATA( 0, GLint, x );
	WRITE_DATA( 4, GLint, y );
	WRITE_DATA( 8, GLsizei, width );
	WRITE_DATA( 12, GLsizei, height );
	WRITE_DATA( 16, GLenum, type );
	WRITE_OPCODE( pc, CR_COPYPIXELS_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCopyPixelsSWAP( GLint x, GLint y, GLsizei width, GLsizei height, GLenum type )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 20 );
	WRITE_DATA( 0, GLint, SWAP32(x) );
	WRITE_DATA( 4, GLint, SWAP32(y) );
	WRITE_DATA( 8, GLsizei, SWAP32(width) );
	WRITE_DATA( 12, GLsizei, SWAP32(height) );
	WRITE_DATA( 16, GLenum, SWAP32(type) );
	WRITE_OPCODE( pc, CR_COPYPIXELS_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCopyTexImage1D( GLenum target, GLint level, GLenum internalFormat, GLint x, GLint y, GLsizei width, GLint border )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLenum, target );
	WRITE_DATA( 4, GLint, level );
	WRITE_DATA( 8, GLenum, internalFormat );
	WRITE_DATA( 12, GLint, x );
	WRITE_DATA( 16, GLint, y );
	WRITE_DATA( 20, GLsizei, width );
	WRITE_DATA( 24, GLint, border );
	WRITE_OPCODE( pc, CR_COPYTEXIMAGE1D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCopyTexImage1DSWAP( GLenum target, GLint level, GLenum internalFormat, GLint x, GLint y, GLsizei width, GLint border )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLenum, SWAP32(target) );
	WRITE_DATA( 4, GLint, SWAP32(level) );
	WRITE_DATA( 8, GLenum, SWAP32(internalFormat) );
	WRITE_DATA( 12, GLint, SWAP32(x) );
	WRITE_DATA( 16, GLint, SWAP32(y) );
	WRITE_DATA( 20, GLsizei, SWAP32(width) );
	WRITE_DATA( 24, GLint, SWAP32(border) );
	WRITE_OPCODE( pc, CR_COPYTEXIMAGE1D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCopyTexImage2D( GLenum target, GLint level, GLenum internalFormat, GLint x, GLint y, GLsizei width, GLsizei height, GLint border )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLenum, target );
	WRITE_DATA( 4, GLint, level );
	WRITE_DATA( 8, GLenum, internalFormat );
	WRITE_DATA( 12, GLint, x );
	WRITE_DATA( 16, GLint, y );
	WRITE_DATA( 20, GLsizei, width );
	WRITE_DATA( 24, GLsizei, height );
	WRITE_DATA( 28, GLint, border );
	WRITE_OPCODE( pc, CR_COPYTEXIMAGE2D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCopyTexImage2DSWAP( GLenum target, GLint level, GLenum internalFormat, GLint x, GLint y, GLsizei width, GLsizei height, GLint border )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLenum, SWAP32(target) );
	WRITE_DATA( 4, GLint, SWAP32(level) );
	WRITE_DATA( 8, GLenum, SWAP32(internalFormat) );
	WRITE_DATA( 12, GLint, SWAP32(x) );
	WRITE_DATA( 16, GLint, SWAP32(y) );
	WRITE_DATA( 20, GLsizei, SWAP32(width) );
	WRITE_DATA( 24, GLsizei, SWAP32(height) );
	WRITE_DATA( 28, GLint, SWAP32(border) );
	WRITE_OPCODE( pc, CR_COPYTEXIMAGE2D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCopyTexSubImage1D( GLenum target, GLint level, GLint xoffset, GLint x, GLint y, GLsizei width )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLenum, target );
	WRITE_DATA( 4, GLint, level );
	WRITE_DATA( 8, GLint, xoffset );
	WRITE_DATA( 12, GLint, x );
	WRITE_DATA( 16, GLint, y );
	WRITE_DATA( 20, GLsizei, width );
	WRITE_OPCODE( pc, CR_COPYTEXSUBIMAGE1D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCopyTexSubImage1DSWAP( GLenum target, GLint level, GLint xoffset, GLint x, GLint y, GLsizei width )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLenum, SWAP32(target) );
	WRITE_DATA( 4, GLint, SWAP32(level) );
	WRITE_DATA( 8, GLint, SWAP32(xoffset) );
	WRITE_DATA( 12, GLint, SWAP32(x) );
	WRITE_DATA( 16, GLint, SWAP32(y) );
	WRITE_DATA( 20, GLsizei, SWAP32(width) );
	WRITE_OPCODE( pc, CR_COPYTEXSUBIMAGE1D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCopyTexSubImage2D( GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint x, GLint y, GLsizei width, GLsizei height )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLenum, target );
	WRITE_DATA( 4, GLint, level );
	WRITE_DATA( 8, GLint, xoffset );
	WRITE_DATA( 12, GLint, yoffset );
	WRITE_DATA( 16, GLint, x );
	WRITE_DATA( 20, GLint, y );
	WRITE_DATA( 24, GLsizei, width );
	WRITE_DATA( 28, GLsizei, height );
	WRITE_OPCODE( pc, CR_COPYTEXSUBIMAGE2D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCopyTexSubImage2DSWAP( GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint x, GLint y, GLsizei width, GLsizei height )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLenum, SWAP32(target) );
	WRITE_DATA( 4, GLint, SWAP32(level) );
	WRITE_DATA( 8, GLint, SWAP32(xoffset) );
	WRITE_DATA( 12, GLint, SWAP32(yoffset) );
	WRITE_DATA( 16, GLint, SWAP32(x) );
	WRITE_DATA( 20, GLint, SWAP32(y) );
	WRITE_DATA( 24, GLsizei, SWAP32(width) );
	WRITE_DATA( 28, GLsizei, SWAP32(height) );
	WRITE_OPCODE( pc, CR_COPYTEXSUBIMAGE2D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCopyTexSubImage3D( GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint x, GLint y, GLsizei width, GLsizei height )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 36 );
	WRITE_DATA( 0, GLenum, target );
	WRITE_DATA( 4, GLint, level );
	WRITE_DATA( 8, GLint, xoffset );
	WRITE_DATA( 12, GLint, yoffset );
	WRITE_DATA( 16, GLint, zoffset );
	WRITE_DATA( 20, GLint, x );
	WRITE_DATA( 24, GLint, y );
	WRITE_DATA( 28, GLsizei, width );
	WRITE_DATA( 32, GLsizei, height );
	WRITE_OPCODE( pc, CR_COPYTEXSUBIMAGE3D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCopyTexSubImage3DSWAP( GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint x, GLint y, GLsizei width, GLsizei height )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 36 );
	WRITE_DATA( 0, GLenum, SWAP32(target) );
	WRITE_DATA( 4, GLint, SWAP32(level) );
	WRITE_DATA( 8, GLint, SWAP32(xoffset) );
	WRITE_DATA( 12, GLint, SWAP32(yoffset) );
	WRITE_DATA( 16, GLint, SWAP32(zoffset) );
	WRITE_DATA( 20, GLint, SWAP32(x) );
	WRITE_DATA( 24, GLint, SWAP32(y) );
	WRITE_DATA( 28, GLsizei, SWAP32(width) );
	WRITE_DATA( 32, GLsizei, SWAP32(height) );
	WRITE_OPCODE( pc, CR_COPYTEXSUBIMAGE3D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCreateProgram( GLuint * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, 24 );
	WRITE_DATA( 4, GLenum, CR_CREATEPROGRAM_EXTEND_OPCODE );
	WRITE_NETWORK_POINTER( 8, (void *) return_value );
	WRITE_NETWORK_POINTER( 16, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCreateProgramSWAP( GLuint * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, SWAP32(24) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_CREATEPROGRAM_EXTEND_OPCODE) );
	WRITE_NETWORK_POINTER( 8, (void *) return_value );
	WRITE_NETWORK_POINTER( 16, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCreateShader( GLenum type, GLuint * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_CREATESHADER_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, type );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCreateShaderSWAP( GLenum type, GLuint * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_CREATESHADER_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(type) );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCullFace( GLenum mode )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLenum, mode );
	WRITE_OPCODE( pc, CR_CULLFACE_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackCullFaceSWAP( GLenum mode )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLenum, SWAP32(mode) );
	WRITE_OPCODE( pc, CR_CULLFACE_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDeleteLists( GLuint list, GLsizei range )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, 16 );
	WRITE_DATA( 4, GLenum, CR_DELETELISTS_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, list );
	WRITE_DATA( 12, GLsizei, range );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDeleteListsSWAP( GLuint list, GLsizei range )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(16) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_DELETELISTS_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(list) );
	WRITE_DATA( 12, GLsizei, SWAP32(range) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDeleteObjectARB( GLhandleARB obj )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, 12 );
	WRITE_DATA( 4, GLenum, CR_DELETEOBJECTARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLhandleARB, obj );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDeleteObjectARBSWAP( GLhandleARB obj )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(12) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_DELETEOBJECTARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLhandleARB, SWAP32(obj) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDeleteProgram( GLuint program )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, 12 );
	WRITE_DATA( 4, GLenum, CR_DELETEPROGRAM_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, program );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDeleteProgramSWAP( GLuint program )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(12) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_DELETEPROGRAM_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(program) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDeleteShader( GLuint shader )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, 12 );
	WRITE_DATA( 4, GLenum, CR_DELETESHADER_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, shader );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDeleteShaderSWAP( GLuint shader )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(12) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_DELETESHADER_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(shader) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDepthFunc( GLenum func )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLenum, func );
	WRITE_OPCODE( pc, CR_DEPTHFUNC_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDepthFuncSWAP( GLenum func )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLenum, SWAP32(func) );
	WRITE_OPCODE( pc, CR_DEPTHFUNC_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDepthMask( GLboolean flag )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLboolean, flag );
	WRITE_OPCODE( pc, CR_DEPTHMASK_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDepthMaskSWAP( GLboolean flag )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLboolean, flag );
	WRITE_OPCODE( pc, CR_DEPTHMASK_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDepthRange( GLclampd zNear, GLclampd zFar )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DOUBLE( 0, zNear );
	WRITE_DOUBLE( 8, zFar );
	WRITE_OPCODE( pc, CR_DEPTHRANGE_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDepthRangeSWAP( GLclampd zNear, GLclampd zFar )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_SWAPPED_DOUBLE( 0, zNear );
	WRITE_SWAPPED_DOUBLE( 8, zFar );
	WRITE_OPCODE( pc, CR_DEPTHRANGE_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDestroyContext( GLint ctx )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, 12 );
	WRITE_DATA( 4, GLenum, CR_DESTROYCONTEXT_EXTEND_OPCODE );
	WRITE_DATA( 8, GLint, ctx );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDestroyContextSWAP( GLint ctx )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(12) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_DESTROYCONTEXT_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLint, SWAP32(ctx) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDetachShader( GLuint program, GLuint shader )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, 16 );
	WRITE_DATA( 4, GLenum, CR_DETACHSHADER_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, program );
	WRITE_DATA( 12, GLuint, shader );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDetachShaderSWAP( GLuint program, GLuint shader )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(16) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_DETACHSHADER_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(program) );
	WRITE_DATA( 12, GLuint, SWAP32(shader) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDisable( GLenum cap )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLenum, cap );
	WRITE_OPCODE( pc, CR_DISABLE_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDisableSWAP( GLenum cap )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLenum, SWAP32(cap) );
	WRITE_OPCODE( pc, CR_DISABLE_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDisableClientState( GLenum array )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLenum, array );
	WRITE_OPCODE( pc, CR_DISABLECLIENTSTATE_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDisableClientStateSWAP( GLenum array )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLenum, SWAP32(array) );
	WRITE_OPCODE( pc, CR_DISABLECLIENTSTATE_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDisableVertexAttribArrayARB( GLuint index )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, 12 );
	WRITE_DATA( 4, GLenum, CR_DISABLEVERTEXATTRIBARRAYARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, index );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDisableVertexAttribArrayARBSWAP( GLuint index )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(12) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_DISABLEVERTEXATTRIBARRAYARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(index) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDrawArrays( GLenum mode, GLint first, GLsizei count )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLenum, mode );
	WRITE_DATA( 4, GLint, first );
	WRITE_DATA( 8, GLsizei, count );
	WRITE_OPCODE( pc, CR_DRAWARRAYS_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDrawArraysSWAP( GLenum mode, GLint first, GLsizei count )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLenum, SWAP32(mode) );
	WRITE_DATA( 4, GLint, SWAP32(first) );
	WRITE_DATA( 8, GLsizei, SWAP32(count) );
	WRITE_OPCODE( pc, CR_DRAWARRAYS_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDrawBuffer( GLenum mode )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, 12 );
	WRITE_DATA( 4, GLenum, CR_DRAWBUFFER_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, mode );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackDrawBufferSWAP( GLenum mode )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(12) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_DRAWBUFFER_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(mode) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEdgeFlag( GLboolean flag )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.edgeFlag.l1 = data_ptr;
	WRITE_DATA( 0, GLboolean, flag );
	WRITE_OPCODE( pc, CR_EDGEFLAG_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEdgeFlagSWAP( GLboolean flag )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.edgeFlag.l1 = data_ptr;
	WRITE_DATA( 0, GLboolean, flag );
	WRITE_OPCODE( pc, CR_EDGEFLAG_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEdgeFlagv( const GLboolean * flag )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!flag) {
        crDebug("App passed NULL as flag for EdgeFlagv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.edgeFlag.l1 = data_ptr;
	WRITE_DATA( 0, GLboolean, flag[0] );
	WRITE_OPCODE( pc, CR_EDGEFLAG_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEdgeFlagvSWAP( const GLboolean * flag )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!flag) {
        crDebug("App passed NULL as flag for EdgeFlagv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.edgeFlag.l1 = data_ptr;
	WRITE_DATA( 0, GLboolean, flag[0] );
	WRITE_OPCODE( pc, CR_EDGEFLAG_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEnable( GLenum cap )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLenum, cap );
	WRITE_OPCODE( pc, CR_ENABLE_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEnableSWAP( GLenum cap )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLenum, SWAP32(cap) );
	WRITE_OPCODE( pc, CR_ENABLE_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEnableClientState( GLenum array )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLenum, array );
	WRITE_OPCODE( pc, CR_ENABLECLIENTSTATE_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEnableClientStateSWAP( GLenum array )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLenum, SWAP32(array) );
	WRITE_OPCODE( pc, CR_ENABLECLIENTSTATE_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEnableVertexAttribArrayARB( GLuint index )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, 12 );
	WRITE_DATA( 4, GLenum, CR_ENABLEVERTEXATTRIBARRAYARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, index );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEnableVertexAttribArrayARBSWAP( GLuint index )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(12) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_ENABLEVERTEXATTRIBARRAYARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(index) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEndQueryARB( GLenum target )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, 12 );
	WRITE_DATA( 4, GLenum, CR_ENDQUERYARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEndQueryARBSWAP( GLenum target )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(12) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_ENDQUERYARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalCoord1d( GLdouble u )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DOUBLE( 0, u );
	WRITE_OPCODE( pc, CR_EVALCOORD1D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalCoord1dSWAP( GLdouble u )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_SWAPPED_DOUBLE( 0, u );
	WRITE_OPCODE( pc, CR_EVALCOORD1D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalCoord1dv( const GLdouble * u )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!u) {
        crDebug("App passed NULL as u for EvalCoord1dv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DOUBLE( 0, u[0] );
	WRITE_OPCODE( pc, CR_EVALCOORD1D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalCoord1dvSWAP( const GLdouble * u )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!u) {
        crDebug("App passed NULL as u for EvalCoord1dv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_SWAPPED_DOUBLE( 0, u[0] );
	WRITE_OPCODE( pc, CR_EVALCOORD1D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalCoord1f( GLfloat u )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLfloat, u );
	WRITE_OPCODE( pc, CR_EVALCOORD1F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalCoord1fSWAP( GLfloat u )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLuint, SWAPFLOAT(u) );
	WRITE_OPCODE( pc, CR_EVALCOORD1F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalCoord1fv( const GLfloat * u )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!u) {
        crDebug("App passed NULL as u for EvalCoord1fv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLfloat, u[0] );
	WRITE_OPCODE( pc, CR_EVALCOORD1F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalCoord1fvSWAP( const GLfloat * u )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!u) {
        crDebug("App passed NULL as u for EvalCoord1fv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLuint, SWAPFLOAT(u[0]) );
	WRITE_OPCODE( pc, CR_EVALCOORD1F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalCoord2d( GLdouble u, GLdouble v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DOUBLE( 0, u );
	WRITE_DOUBLE( 8, v );
	WRITE_OPCODE( pc, CR_EVALCOORD2D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalCoord2dSWAP( GLdouble u, GLdouble v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_SWAPPED_DOUBLE( 0, u );
	WRITE_SWAPPED_DOUBLE( 8, v );
	WRITE_OPCODE( pc, CR_EVALCOORD2D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalCoord2dv( const GLdouble * u )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!u) {
        crDebug("App passed NULL as u for EvalCoord2dv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DOUBLE( 0, u[0] );
	WRITE_DOUBLE( 8, u[1] );
	WRITE_OPCODE( pc, CR_EVALCOORD2D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalCoord2dvSWAP( const GLdouble * u )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!u) {
        crDebug("App passed NULL as u for EvalCoord2dv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_SWAPPED_DOUBLE( 0, u[0] );
	WRITE_SWAPPED_DOUBLE( 8, u[1] );
	WRITE_OPCODE( pc, CR_EVALCOORD2D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalCoord2f( GLfloat u, GLfloat v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLfloat, u );
	WRITE_DATA( 4, GLfloat, v );
	WRITE_OPCODE( pc, CR_EVALCOORD2F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalCoord2fSWAP( GLfloat u, GLfloat v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLuint, SWAPFLOAT(u) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(v) );
	WRITE_OPCODE( pc, CR_EVALCOORD2F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalCoord2fv( const GLfloat * u )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!u) {
        crDebug("App passed NULL as u for EvalCoord2fv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLfloat, u[0] );
	WRITE_DATA( 4, GLfloat, u[1] );
	WRITE_OPCODE( pc, CR_EVALCOORD2F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalCoord2fvSWAP( const GLfloat * u )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!u) {
        crDebug("App passed NULL as u for EvalCoord2fv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLuint, SWAPFLOAT(u[0]) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(u[1]) );
	WRITE_OPCODE( pc, CR_EVALCOORD2F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalMesh1( GLenum mode, GLint i1, GLint i2 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLenum, mode );
	WRITE_DATA( 4, GLint, i1 );
	WRITE_DATA( 8, GLint, i2 );
	WRITE_OPCODE( pc, CR_EVALMESH1_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalMesh1SWAP( GLenum mode, GLint i1, GLint i2 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLenum, SWAP32(mode) );
	WRITE_DATA( 4, GLint, SWAP32(i1) );
	WRITE_DATA( 8, GLint, SWAP32(i2) );
	WRITE_OPCODE( pc, CR_EVALMESH1_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalMesh2( GLenum mode, GLint i1, GLint i2, GLint j1, GLint j2 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 20 );
	WRITE_DATA( 0, GLenum, mode );
	WRITE_DATA( 4, GLint, i1 );
	WRITE_DATA( 8, GLint, i2 );
	WRITE_DATA( 12, GLint, j1 );
	WRITE_DATA( 16, GLint, j2 );
	WRITE_OPCODE( pc, CR_EVALMESH2_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalMesh2SWAP( GLenum mode, GLint i1, GLint i2, GLint j1, GLint j2 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 20 );
	WRITE_DATA( 0, GLenum, SWAP32(mode) );
	WRITE_DATA( 4, GLint, SWAP32(i1) );
	WRITE_DATA( 8, GLint, SWAP32(i2) );
	WRITE_DATA( 12, GLint, SWAP32(j1) );
	WRITE_DATA( 16, GLint, SWAP32(j2) );
	WRITE_OPCODE( pc, CR_EVALMESH2_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalPoint1( GLint i )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLint, i );
	WRITE_OPCODE( pc, CR_EVALPOINT1_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalPoint1SWAP( GLint i )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLint, SWAP32(i) );
	WRITE_OPCODE( pc, CR_EVALPOINT1_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalPoint2( GLint i, GLint j )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLint, i );
	WRITE_DATA( 4, GLint, j );
	WRITE_OPCODE( pc, CR_EVALPOINT2_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackEvalPoint2SWAP( GLint i, GLint j )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLint, SWAP32(i) );
	WRITE_DATA( 4, GLint, SWAP32(j) );
	WRITE_OPCODE( pc, CR_EVALPOINT2_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFinalCombinerInputNV( GLenum variable, GLenum input, GLenum mapping, GLenum componentUsage )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, 24 );
	WRITE_DATA( 4, GLenum, CR_FINALCOMBINERINPUTNV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, variable );
	WRITE_DATA( 12, GLenum, input );
	WRITE_DATA( 16, GLenum, mapping );
	WRITE_DATA( 20, GLenum, componentUsage );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFinalCombinerInputNVSWAP( GLenum variable, GLenum input, GLenum mapping, GLenum componentUsage )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, SWAP32(24) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_FINALCOMBINERINPUTNV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(variable) );
	WRITE_DATA( 12, GLenum, SWAP32(input) );
	WRITE_DATA( 16, GLenum, SWAP32(mapping) );
	WRITE_DATA( 20, GLenum, SWAP32(componentUsage) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFinish( void )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_ARGS( pc );
	WRITE_OPCODE( pc, CR_FINISH_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFinishSWAP( void )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_ARGS( pc );
	WRITE_OPCODE( pc, CR_FINISH_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFinishFenceNV( GLuint fence )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, 12 );
	WRITE_DATA( 4, GLenum, CR_FINISHFENCENV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, fence );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFinishFenceNVSWAP( GLuint fence )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(12) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_FINISHFENCENV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(fence) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFlush( void )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_ARGS( pc );
	WRITE_OPCODE( pc, CR_FLUSH_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFlushSWAP( void )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_ARGS( pc );
	WRITE_OPCODE( pc, CR_FLUSH_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFlushVertexArrayRangeNV( void )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLint, 8 );
	WRITE_DATA( 4, GLenum, CR_FLUSHVERTEXARRAYRANGENV_EXTEND_OPCODE );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFlushVertexArrayRangeNVSWAP( void )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLint, SWAP32(8) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_FLUSHVERTEXARRAYRANGENV_EXTEND_OPCODE) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFogCoorddEXT( GLdouble coord )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.fogCoord.d1 = data_ptr;
	WRITE_DOUBLE( 0, coord );
	WRITE_OPCODE( pc, CR_FOGCOORDDEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFogCoorddEXTSWAP( GLdouble coord )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.fogCoord.d1 = data_ptr;
	WRITE_SWAPPED_DOUBLE( 0, coord );
	WRITE_OPCODE( pc, CR_FOGCOORDDEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFogCoorddvEXT( const GLdouble * coord )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!coord) {
        crDebug("App passed NULL as coord for FogCoorddvEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.fogCoord.d1 = data_ptr;
	WRITE_DOUBLE( 0, coord[0] );
	WRITE_OPCODE( pc, CR_FOGCOORDDEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFogCoorddvEXTSWAP( const GLdouble * coord )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!coord) {
        crDebug("App passed NULL as coord for FogCoorddvEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.fogCoord.d1 = data_ptr;
	WRITE_SWAPPED_DOUBLE( 0, coord[0] );
	WRITE_OPCODE( pc, CR_FOGCOORDDEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFogCoordfEXT( GLfloat coord )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.fogCoord.f1 = data_ptr;
	WRITE_DATA( 0, GLfloat, coord );
	WRITE_OPCODE( pc, CR_FOGCOORDFEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFogCoordfEXTSWAP( GLfloat coord )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.fogCoord.f1 = data_ptr;
	WRITE_DATA( 0, GLuint, SWAPFLOAT(coord) );
	WRITE_OPCODE( pc, CR_FOGCOORDFEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFogCoordfvEXT( const GLfloat * coord )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!coord) {
        crDebug("App passed NULL as coord for FogCoordfvEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.fogCoord.f1 = data_ptr;
	WRITE_DATA( 0, GLfloat, coord[0] );
	WRITE_OPCODE( pc, CR_FOGCOORDFEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFogCoordfvEXTSWAP( const GLfloat * coord )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!coord) {
        crDebug("App passed NULL as coord for FogCoordfvEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.fogCoord.f1 = data_ptr;
	WRITE_DATA( 0, GLuint, SWAPFLOAT(coord[0]) );
	WRITE_OPCODE( pc, CR_FOGCOORDFEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFogf( GLenum pname, GLfloat param )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLenum, pname );
	WRITE_DATA( 4, GLfloat, param );
	WRITE_OPCODE( pc, CR_FOGF_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFogfSWAP( GLenum pname, GLfloat param )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLenum, SWAP32(pname) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(param) );
	WRITE_OPCODE( pc, CR_FOGF_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFogi( GLenum pname, GLint param )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLenum, pname );
	WRITE_DATA( 4, GLint, param );
	WRITE_OPCODE( pc, CR_FOGI_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFogiSWAP( GLenum pname, GLint param )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLenum, SWAP32(pname) );
	WRITE_DATA( 4, GLint, SWAP32(param) );
	WRITE_OPCODE( pc, CR_FOGI_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFramebufferRenderbufferEXT( GLenum target, GLenum attachment, GLenum renderbuffertarget, GLuint renderbuffer )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, 24 );
	WRITE_DATA( 4, GLenum, CR_FRAMEBUFFERRENDERBUFFEREXT_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLenum, attachment );
	WRITE_DATA( 16, GLenum, renderbuffertarget );
	WRITE_DATA( 20, GLuint, renderbuffer );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFramebufferRenderbufferEXTSWAP( GLenum target, GLenum attachment, GLenum renderbuffertarget, GLuint renderbuffer )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, SWAP32(24) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_FRAMEBUFFERRENDERBUFFEREXT_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLenum, SWAP32(attachment) );
	WRITE_DATA( 16, GLenum, SWAP32(renderbuffertarget) );
	WRITE_DATA( 20, GLuint, SWAP32(renderbuffer) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFramebufferTexture1DEXT( GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_FRAMEBUFFERTEXTURE1DEXT_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLenum, attachment );
	WRITE_DATA( 16, GLenum, textarget );
	WRITE_DATA( 20, GLuint, texture );
	WRITE_DATA( 24, GLint, level );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFramebufferTexture1DEXTSWAP( GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_FRAMEBUFFERTEXTURE1DEXT_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLenum, SWAP32(attachment) );
	WRITE_DATA( 16, GLenum, SWAP32(textarget) );
	WRITE_DATA( 20, GLuint, SWAP32(texture) );
	WRITE_DATA( 24, GLint, SWAP32(level) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFramebufferTexture2DEXT( GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_FRAMEBUFFERTEXTURE2DEXT_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLenum, attachment );
	WRITE_DATA( 16, GLenum, textarget );
	WRITE_DATA( 20, GLuint, texture );
	WRITE_DATA( 24, GLint, level );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFramebufferTexture2DEXTSWAP( GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_FRAMEBUFFERTEXTURE2DEXT_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLenum, SWAP32(attachment) );
	WRITE_DATA( 16, GLenum, SWAP32(textarget) );
	WRITE_DATA( 20, GLuint, SWAP32(texture) );
	WRITE_DATA( 24, GLint, SWAP32(level) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFramebufferTexture3DEXT( GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level, GLint zoffset )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_FRAMEBUFFERTEXTURE3DEXT_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLenum, attachment );
	WRITE_DATA( 16, GLenum, textarget );
	WRITE_DATA( 20, GLuint, texture );
	WRITE_DATA( 24, GLint, level );
	WRITE_DATA( 28, GLint, zoffset );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFramebufferTexture3DEXTSWAP( GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level, GLint zoffset )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_FRAMEBUFFERTEXTURE3DEXT_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLenum, SWAP32(attachment) );
	WRITE_DATA( 16, GLenum, SWAP32(textarget) );
	WRITE_DATA( 20, GLuint, SWAP32(texture) );
	WRITE_DATA( 24, GLint, SWAP32(level) );
	WRITE_DATA( 28, GLint, SWAP32(zoffset) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFrontFace( GLenum mode )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLenum, mode );
	WRITE_OPCODE( pc, CR_FRONTFACE_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFrontFaceSWAP( GLenum mode )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLenum, SWAP32(mode) );
	WRITE_OPCODE( pc, CR_FRONTFACE_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFrustum( GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 48 );
	WRITE_DOUBLE( 0, left );
	WRITE_DOUBLE( 8, right );
	WRITE_DOUBLE( 16, bottom );
	WRITE_DOUBLE( 24, top );
	WRITE_DOUBLE( 32, zNear );
	WRITE_DOUBLE( 40, zFar );
	WRITE_OPCODE( pc, CR_FRUSTUM_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackFrustumSWAP( GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 48 );
	WRITE_SWAPPED_DOUBLE( 0, left );
	WRITE_SWAPPED_DOUBLE( 8, right );
	WRITE_SWAPPED_DOUBLE( 16, bottom );
	WRITE_SWAPPED_DOUBLE( 24, top );
	WRITE_SWAPPED_DOUBLE( 32, zNear );
	WRITE_SWAPPED_DOUBLE( 40, zFar );
	WRITE_OPCODE( pc, CR_FRUSTUM_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGenBuffersARB( GLsizei n, GLuint * buffer, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_GENBUFFERSARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLsizei, n );
	WRITE_NETWORK_POINTER( 12, (void *) buffer );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGenBuffersARBSWAP( GLsizei n, GLuint * buffer, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GENBUFFERSARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLsizei, SWAP32(n) );
	WRITE_NETWORK_POINTER( 12, (void *) buffer );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGenFencesNV( GLsizei n, GLuint * fences, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_GENFENCESNV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLsizei, n );
	WRITE_NETWORK_POINTER( 12, (void *) fences );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGenFencesNVSWAP( GLsizei n, GLuint * fences, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GENFENCESNV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLsizei, SWAP32(n) );
	WRITE_NETWORK_POINTER( 12, (void *) fences );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGenFramebuffersEXT( GLsizei n, GLuint * framebuffers, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_GENFRAMEBUFFERSEXT_EXTEND_OPCODE );
	WRITE_DATA( 8, GLsizei, n );
	WRITE_NETWORK_POINTER( 12, (void *) framebuffers );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGenFramebuffersEXTSWAP( GLsizei n, GLuint * framebuffers, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GENFRAMEBUFFERSEXT_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLsizei, SWAP32(n) );
	WRITE_NETWORK_POINTER( 12, (void *) framebuffers );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGenLists( GLsizei range, GLuint * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_GENLISTS_EXTEND_OPCODE );
	WRITE_DATA( 8, GLsizei, range );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGenListsSWAP( GLsizei range, GLuint * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GENLISTS_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLsizei, SWAP32(range) );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGenProgramsARB( GLsizei n, GLuint * programs, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_GENPROGRAMSARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLsizei, n );
	WRITE_NETWORK_POINTER( 12, (void *) programs );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGenProgramsARBSWAP( GLsizei n, GLuint * programs, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GENPROGRAMSARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLsizei, SWAP32(n) );
	WRITE_NETWORK_POINTER( 12, (void *) programs );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGenProgramsNV( GLsizei n, GLuint * ids, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_GENPROGRAMSNV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLsizei, n );
	WRITE_NETWORK_POINTER( 12, (void *) ids );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGenProgramsNVSWAP( GLsizei n, GLuint * ids, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GENPROGRAMSNV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLsizei, SWAP32(n) );
	WRITE_NETWORK_POINTER( 12, (void *) ids );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGenQueriesARB( GLsizei n, GLuint * ids, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_GENQUERIESARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLsizei, n );
	WRITE_NETWORK_POINTER( 12, (void *) ids );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGenQueriesARBSWAP( GLsizei n, GLuint * ids, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GENQUERIESARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLsizei, SWAP32(n) );
	WRITE_NETWORK_POINTER( 12, (void *) ids );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGenRenderbuffersEXT( GLsizei n, GLuint * renderbuffers, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_GENRENDERBUFFERSEXT_EXTEND_OPCODE );
	WRITE_DATA( 8, GLsizei, n );
	WRITE_NETWORK_POINTER( 12, (void *) renderbuffers );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGenRenderbuffersEXTSWAP( GLsizei n, GLuint * renderbuffers, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GENRENDERBUFFERSEXT_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLsizei, SWAP32(n) );
	WRITE_NETWORK_POINTER( 12, (void *) renderbuffers );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGenTextures( GLsizei n, GLuint * textures, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_GENTEXTURES_EXTEND_OPCODE );
	WRITE_DATA( 8, GLsizei, n );
	WRITE_NETWORK_POINTER( 12, (void *) textures );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGenTexturesSWAP( GLsizei n, GLuint * textures, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GENTEXTURES_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLsizei, SWAP32(n) );
	WRITE_NETWORK_POINTER( 12, (void *) textures );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGenerateMipmapEXT( GLenum target )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, 12 );
	WRITE_DATA( 4, GLenum, CR_GENERATEMIPMAPEXT_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGenerateMipmapEXTSWAP( GLenum target )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(12) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GENERATEMIPMAPEXT_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetBooleanv( GLenum pname, GLboolean * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_GETBOOLEANV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, pname );
	WRITE_NETWORK_POINTER( 12, (void *) params );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetBooleanvSWAP( GLenum pname, GLboolean * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETBOOLEANV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 12, (void *) params );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetBufferParameterivARB( GLenum target, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETBUFFERPARAMETERIVARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetBufferParameterivARBSWAP( GLenum target, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETBUFFERPARAMETERIVARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetChromiumParametervCR( GLenum target, GLuint index, GLenum type, GLsizei count, GLvoid * values, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 40 );
	WRITE_DATA( 0, GLint, 40 );
	WRITE_DATA( 4, GLenum, CR_GETCHROMIUMPARAMETERVCR_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLuint, index );
	WRITE_DATA( 16, GLenum, type );
	WRITE_DATA( 20, GLsizei, count );
	WRITE_NETWORK_POINTER( 24, (void *) values );
	WRITE_NETWORK_POINTER( 32, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetChromiumParametervCRSWAP( GLenum target, GLuint index, GLenum type, GLsizei count, GLvoid * values, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 40 );
	WRITE_DATA( 0, GLint, SWAP32(40) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETCHROMIUMPARAMETERVCR_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLuint, SWAP32(index) );
	WRITE_DATA( 16, GLenum, SWAP32(type) );
	WRITE_DATA( 20, GLsizei, SWAP32(count) );
	WRITE_NETWORK_POINTER( 24, (void *) values );
	WRITE_NETWORK_POINTER( 32, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetClipPlane( GLenum plane, GLdouble * equation, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_GETCLIPPLANE_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, plane );
	WRITE_NETWORK_POINTER( 12, (void *) equation );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetClipPlaneSWAP( GLenum plane, GLdouble * equation, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETCLIPPLANE_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(plane) );
	WRITE_NETWORK_POINTER( 12, (void *) equation );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetCombinerInputParameterfvNV( GLenum stage, GLenum portion, GLenum variable, GLenum pname, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 40 );
	WRITE_DATA( 0, GLint, 40 );
	WRITE_DATA( 4, GLenum, CR_GETCOMBINERINPUTPARAMETERFVNV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, stage );
	WRITE_DATA( 12, GLenum, portion );
	WRITE_DATA( 16, GLenum, variable );
	WRITE_DATA( 20, GLenum, pname );
	WRITE_NETWORK_POINTER( 24, (void *) params );
	WRITE_NETWORK_POINTER( 32, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetCombinerInputParameterfvNVSWAP( GLenum stage, GLenum portion, GLenum variable, GLenum pname, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 40 );
	WRITE_DATA( 0, GLint, SWAP32(40) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETCOMBINERINPUTPARAMETERFVNV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(stage) );
	WRITE_DATA( 12, GLenum, SWAP32(portion) );
	WRITE_DATA( 16, GLenum, SWAP32(variable) );
	WRITE_DATA( 20, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 24, (void *) params );
	WRITE_NETWORK_POINTER( 32, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetCombinerInputParameterivNV( GLenum stage, GLenum portion, GLenum variable, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 40 );
	WRITE_DATA( 0, GLint, 40 );
	WRITE_DATA( 4, GLenum, CR_GETCOMBINERINPUTPARAMETERIVNV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, stage );
	WRITE_DATA( 12, GLenum, portion );
	WRITE_DATA( 16, GLenum, variable );
	WRITE_DATA( 20, GLenum, pname );
	WRITE_NETWORK_POINTER( 24, (void *) params );
	WRITE_NETWORK_POINTER( 32, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetCombinerInputParameterivNVSWAP( GLenum stage, GLenum portion, GLenum variable, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 40 );
	WRITE_DATA( 0, GLint, SWAP32(40) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETCOMBINERINPUTPARAMETERIVNV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(stage) );
	WRITE_DATA( 12, GLenum, SWAP32(portion) );
	WRITE_DATA( 16, GLenum, SWAP32(variable) );
	WRITE_DATA( 20, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 24, (void *) params );
	WRITE_NETWORK_POINTER( 32, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetCombinerOutputParameterfvNV( GLenum stage, GLenum portion, GLenum pname, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 36 );
	WRITE_DATA( 0, GLint, 36 );
	WRITE_DATA( 4, GLenum, CR_GETCOMBINEROUTPUTPARAMETERFVNV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, stage );
	WRITE_DATA( 12, GLenum, portion );
	WRITE_DATA( 16, GLenum, pname );
	WRITE_NETWORK_POINTER( 20, (void *) params );
	WRITE_NETWORK_POINTER( 28, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetCombinerOutputParameterfvNVSWAP( GLenum stage, GLenum portion, GLenum pname, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 36 );
	WRITE_DATA( 0, GLint, SWAP32(36) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETCOMBINEROUTPUTPARAMETERFVNV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(stage) );
	WRITE_DATA( 12, GLenum, SWAP32(portion) );
	WRITE_DATA( 16, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 20, (void *) params );
	WRITE_NETWORK_POINTER( 28, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetCombinerOutputParameterivNV( GLenum stage, GLenum portion, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 36 );
	WRITE_DATA( 0, GLint, 36 );
	WRITE_DATA( 4, GLenum, CR_GETCOMBINEROUTPUTPARAMETERIVNV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, stage );
	WRITE_DATA( 12, GLenum, portion );
	WRITE_DATA( 16, GLenum, pname );
	WRITE_NETWORK_POINTER( 20, (void *) params );
	WRITE_NETWORK_POINTER( 28, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetCombinerOutputParameterivNVSWAP( GLenum stage, GLenum portion, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 36 );
	WRITE_DATA( 0, GLint, SWAP32(36) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETCOMBINEROUTPUTPARAMETERIVNV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(stage) );
	WRITE_DATA( 12, GLenum, SWAP32(portion) );
	WRITE_DATA( 16, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 20, (void *) params );
	WRITE_NETWORK_POINTER( 28, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetCombinerStageParameterfvNV( GLenum stage, GLenum pname, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETCOMBINERSTAGEPARAMETERFVNV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, stage );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetCombinerStageParameterfvNVSWAP( GLenum stage, GLenum pname, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETCOMBINERSTAGEPARAMETERFVNV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(stage) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetDoublev( GLenum pname, GLdouble * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_GETDOUBLEV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, pname );
	WRITE_NETWORK_POINTER( 12, (void *) params );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetDoublevSWAP( GLenum pname, GLdouble * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETDOUBLEV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 12, (void *) params );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetError( GLenum * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, 24 );
	WRITE_DATA( 4, GLenum, CR_GETERROR_EXTEND_OPCODE );
	WRITE_NETWORK_POINTER( 8, (void *) return_value );
	WRITE_NETWORK_POINTER( 16, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetErrorSWAP( GLenum * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, SWAP32(24) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETERROR_EXTEND_OPCODE) );
	WRITE_NETWORK_POINTER( 8, (void *) return_value );
	WRITE_NETWORK_POINTER( 16, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetFenceivNV( GLuint fence, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETFENCEIVNV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, fence );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetFenceivNVSWAP( GLuint fence, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETFENCEIVNV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(fence) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetFinalCombinerInputParameterfvNV( GLenum variable, GLenum pname, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETFINALCOMBINERINPUTPARAMETERFVNV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, variable );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetFinalCombinerInputParameterfvNVSWAP( GLenum variable, GLenum pname, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETFINALCOMBINERINPUTPARAMETERFVNV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(variable) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetFinalCombinerInputParameterivNV( GLenum variable, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETFINALCOMBINERINPUTPARAMETERIVNV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, variable );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetFinalCombinerInputParameterivNVSWAP( GLenum variable, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETFINALCOMBINERINPUTPARAMETERIVNV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(variable) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetFloatv( GLenum pname, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_GETFLOATV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, pname );
	WRITE_NETWORK_POINTER( 12, (void *) params );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetFloatvSWAP( GLenum pname, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETFLOATV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 12, (void *) params );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetFramebufferAttachmentParameterivEXT( GLenum target, GLenum attachment, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 36 );
	WRITE_DATA( 0, GLint, 36 );
	WRITE_DATA( 4, GLenum, CR_GETFRAMEBUFFERATTACHMENTPARAMETERIVEXT_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLenum, attachment );
	WRITE_DATA( 16, GLenum, pname );
	WRITE_NETWORK_POINTER( 20, (void *) params );
	WRITE_NETWORK_POINTER( 28, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetFramebufferAttachmentParameterivEXTSWAP( GLenum target, GLenum attachment, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 36 );
	WRITE_DATA( 0, GLint, SWAP32(36) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETFRAMEBUFFERATTACHMENTPARAMETERIVEXT_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLenum, SWAP32(attachment) );
	WRITE_DATA( 16, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 20, (void *) params );
	WRITE_NETWORK_POINTER( 28, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetHandleARB( GLenum pname, GLhandleARB * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_GETHANDLEARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, pname );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetHandleARBSWAP( GLenum pname, GLhandleARB * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETHANDLEARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetIntegerv( GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_GETINTEGERV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, pname );
	WRITE_NETWORK_POINTER( 12, (void *) params );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetIntegervSWAP( GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETINTEGERV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 12, (void *) params );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetLightfv( GLenum light, GLenum pname, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETLIGHTFV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, light );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetLightfvSWAP( GLenum light, GLenum pname, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETLIGHTFV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(light) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetLightiv( GLenum light, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETLIGHTIV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, light );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetLightivSWAP( GLenum light, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETLIGHTIV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(light) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetMapdv( GLenum target, GLenum query, GLdouble * v, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETMAPDV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLenum, query );
	WRITE_NETWORK_POINTER( 16, (void *) v );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetMapdvSWAP( GLenum target, GLenum query, GLdouble * v, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETMAPDV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLenum, SWAP32(query) );
	WRITE_NETWORK_POINTER( 16, (void *) v );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetMapfv( GLenum target, GLenum query, GLfloat * v, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETMAPFV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLenum, query );
	WRITE_NETWORK_POINTER( 16, (void *) v );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetMapfvSWAP( GLenum target, GLenum query, GLfloat * v, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETMAPFV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLenum, SWAP32(query) );
	WRITE_NETWORK_POINTER( 16, (void *) v );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetMapiv( GLenum target, GLenum query, GLint * v, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETMAPIV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLenum, query );
	WRITE_NETWORK_POINTER( 16, (void *) v );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetMapivSWAP( GLenum target, GLenum query, GLint * v, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETMAPIV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLenum, SWAP32(query) );
	WRITE_NETWORK_POINTER( 16, (void *) v );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetMaterialfv( GLenum face, GLenum pname, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETMATERIALFV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, face );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetMaterialfvSWAP( GLenum face, GLenum pname, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETMATERIALFV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(face) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetMaterialiv( GLenum face, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETMATERIALIV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, face );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetMaterialivSWAP( GLenum face, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETMATERIALIV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(face) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetObjectParameterfvARB( GLhandleARB obj, GLenum pname, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETOBJECTPARAMETERFVARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLhandleARB, obj );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetObjectParameterfvARBSWAP( GLhandleARB obj, GLenum pname, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETOBJECTPARAMETERFVARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLhandleARB, SWAP32(obj) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetObjectParameterivARB( GLhandleARB obj, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETOBJECTPARAMETERIVARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLhandleARB, obj );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetObjectParameterivARBSWAP( GLhandleARB obj, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETOBJECTPARAMETERIVARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLhandleARB, SWAP32(obj) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetPixelMapfv( GLenum map, GLfloat * values, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_GETPIXELMAPFV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, map );
	WRITE_NETWORK_POINTER( 12, (void *) values );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetPixelMapfvSWAP( GLenum map, GLfloat * values, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETPIXELMAPFV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(map) );
	WRITE_NETWORK_POINTER( 12, (void *) values );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetPixelMapuiv( GLenum map, GLuint * values, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_GETPIXELMAPUIV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, map );
	WRITE_NETWORK_POINTER( 12, (void *) values );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetPixelMapuivSWAP( GLenum map, GLuint * values, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETPIXELMAPUIV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(map) );
	WRITE_NETWORK_POINTER( 12, (void *) values );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetPixelMapusv( GLenum map, GLushort * values, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_GETPIXELMAPUSV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, map );
	WRITE_NETWORK_POINTER( 12, (void *) values );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetPixelMapusvSWAP( GLenum map, GLushort * values, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETPIXELMAPUSV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(map) );
	WRITE_NETWORK_POINTER( 12, (void *) values );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetPointerv( GLenum pname, GLvoid ** params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_GETPOINTERV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, pname );
	WRITE_NETWORK_POINTER( 12, (void *) params );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetPointervSWAP( GLenum pname, GLvoid ** params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETPOINTERV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 12, (void *) params );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetPolygonStipple( GLubyte * mask, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, 24 );
	WRITE_DATA( 4, GLenum, CR_GETPOLYGONSTIPPLE_EXTEND_OPCODE );
	WRITE_NETWORK_POINTER( 8, (void *) mask );
	WRITE_NETWORK_POINTER( 16, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetPolygonStippleSWAP( GLubyte * mask, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, SWAP32(24) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETPOLYGONSTIPPLE_EXTEND_OPCODE) );
	WRITE_NETWORK_POINTER( 8, (void *) mask );
	WRITE_NETWORK_POINTER( 16, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetProgramEnvParameterdvARB( GLenum target, GLuint index, GLdouble * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETPROGRAMENVPARAMETERDVARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLuint, index );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetProgramEnvParameterdvARBSWAP( GLenum target, GLuint index, GLdouble * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETPROGRAMENVPARAMETERDVARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLuint, SWAP32(index) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetProgramEnvParameterfvARB( GLenum target, GLuint index, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETPROGRAMENVPARAMETERFVARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLuint, index );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetProgramEnvParameterfvARBSWAP( GLenum target, GLuint index, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETPROGRAMENVPARAMETERFVARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLuint, SWAP32(index) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetProgramLocalParameterdvARB( GLenum target, GLuint index, GLdouble * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETPROGRAMLOCALPARAMETERDVARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLuint, index );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetProgramLocalParameterdvARBSWAP( GLenum target, GLuint index, GLdouble * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETPROGRAMLOCALPARAMETERDVARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLuint, SWAP32(index) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetProgramLocalParameterfvARB( GLenum target, GLuint index, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETPROGRAMLOCALPARAMETERFVARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLuint, index );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetProgramLocalParameterfvARBSWAP( GLenum target, GLuint index, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETPROGRAMLOCALPARAMETERFVARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLuint, SWAP32(index) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetProgramParameterdvNV( GLenum target, GLuint index, GLenum pname, GLdouble * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 36 );
	WRITE_DATA( 0, GLint, 36 );
	WRITE_DATA( 4, GLenum, CR_GETPROGRAMPARAMETERDVNV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLuint, index );
	WRITE_DATA( 16, GLenum, pname );
	WRITE_NETWORK_POINTER( 20, (void *) params );
	WRITE_NETWORK_POINTER( 28, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetProgramParameterdvNVSWAP( GLenum target, GLuint index, GLenum pname, GLdouble * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 36 );
	WRITE_DATA( 0, GLint, SWAP32(36) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETPROGRAMPARAMETERDVNV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLuint, SWAP32(index) );
	WRITE_DATA( 16, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 20, (void *) params );
	WRITE_NETWORK_POINTER( 28, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetProgramParameterfvNV( GLenum target, GLuint index, GLenum pname, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 36 );
	WRITE_DATA( 0, GLint, 36 );
	WRITE_DATA( 4, GLenum, CR_GETPROGRAMPARAMETERFVNV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLuint, index );
	WRITE_DATA( 16, GLenum, pname );
	WRITE_NETWORK_POINTER( 20, (void *) params );
	WRITE_NETWORK_POINTER( 28, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetProgramParameterfvNVSWAP( GLenum target, GLuint index, GLenum pname, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 36 );
	WRITE_DATA( 0, GLint, SWAP32(36) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETPROGRAMPARAMETERFVNV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLuint, SWAP32(index) );
	WRITE_DATA( 16, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 20, (void *) params );
	WRITE_NETWORK_POINTER( 28, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetProgramStringARB( GLenum target, GLenum pname, GLvoid * string, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETPROGRAMSTRINGARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) string );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetProgramStringARBSWAP( GLenum target, GLenum pname, GLvoid * string, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETPROGRAMSTRINGARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) string );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetProgramStringNV( GLuint id, GLenum pname, GLubyte * program, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETPROGRAMSTRINGNV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, id );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) program );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetProgramStringNVSWAP( GLuint id, GLenum pname, GLubyte * program, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETPROGRAMSTRINGNV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(id) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) program );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetProgramiv( GLuint program, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETPROGRAMIV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, program );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetProgramivSWAP( GLuint program, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETPROGRAMIV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(program) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetProgramivARB( GLenum target, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETPROGRAMIVARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetProgramivARBSWAP( GLenum target, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETPROGRAMIVARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetProgramivNV( GLuint id, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETPROGRAMIVNV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, id );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetProgramivNVSWAP( GLuint id, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETPROGRAMIVNV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(id) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetQueryObjectivARB( GLuint id, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETQUERYOBJECTIVARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, id );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetQueryObjectivARBSWAP( GLuint id, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETQUERYOBJECTIVARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(id) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetQueryObjectuivARB( GLuint id, GLenum pname, GLuint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETQUERYOBJECTUIVARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, id );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetQueryObjectuivARBSWAP( GLuint id, GLenum pname, GLuint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETQUERYOBJECTUIVARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(id) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetQueryivARB( GLenum target, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETQUERYIVARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetQueryivARBSWAP( GLenum target, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETQUERYIVARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetRenderbufferParameterivEXT( GLenum target, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETRENDERBUFFERPARAMETERIVEXT_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetRenderbufferParameterivEXTSWAP( GLenum target, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETRENDERBUFFERPARAMETERIVEXT_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetShaderiv( GLuint shader, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETSHADERIV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, shader );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetShaderivSWAP( GLuint shader, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETSHADERIV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(shader) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetString( GLenum name, const GLubyte * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_GETSTRING_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, name );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetStringSWAP( GLenum name, const GLubyte * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETSTRING_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(name) );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetTexEnvfv( GLenum target, GLenum pname, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETTEXENVFV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetTexEnvfvSWAP( GLenum target, GLenum pname, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETTEXENVFV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetTexEnviv( GLenum target, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETTEXENVIV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetTexEnvivSWAP( GLenum target, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETTEXENVIV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetTexGendv( GLenum coord, GLenum pname, GLdouble * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETTEXGENDV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, coord );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetTexGendvSWAP( GLenum coord, GLenum pname, GLdouble * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETTEXGENDV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(coord) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetTexGenfv( GLenum coord, GLenum pname, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETTEXGENFV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, coord );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetTexGenfvSWAP( GLenum coord, GLenum pname, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETTEXGENFV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(coord) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetTexGeniv( GLenum coord, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETTEXGENIV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, coord );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetTexGenivSWAP( GLenum coord, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETTEXGENIV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(coord) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetTexLevelParameterfv( GLenum target, GLint level, GLenum pname, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 36 );
	WRITE_DATA( 0, GLint, 36 );
	WRITE_DATA( 4, GLenum, CR_GETTEXLEVELPARAMETERFV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLint, level );
	WRITE_DATA( 16, GLenum, pname );
	WRITE_NETWORK_POINTER( 20, (void *) params );
	WRITE_NETWORK_POINTER( 28, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetTexLevelParameterfvSWAP( GLenum target, GLint level, GLenum pname, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 36 );
	WRITE_DATA( 0, GLint, SWAP32(36) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETTEXLEVELPARAMETERFV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLint, SWAP32(level) );
	WRITE_DATA( 16, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 20, (void *) params );
	WRITE_NETWORK_POINTER( 28, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetTexLevelParameteriv( GLenum target, GLint level, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 36 );
	WRITE_DATA( 0, GLint, 36 );
	WRITE_DATA( 4, GLenum, CR_GETTEXLEVELPARAMETERIV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLint, level );
	WRITE_DATA( 16, GLenum, pname );
	WRITE_NETWORK_POINTER( 20, (void *) params );
	WRITE_NETWORK_POINTER( 28, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetTexLevelParameterivSWAP( GLenum target, GLint level, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 36 );
	WRITE_DATA( 0, GLint, SWAP32(36) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETTEXLEVELPARAMETERIV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLint, SWAP32(level) );
	WRITE_DATA( 16, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 20, (void *) params );
	WRITE_NETWORK_POINTER( 28, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetTexParameterfv( GLenum target, GLenum pname, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETTEXPARAMETERFV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetTexParameterfvSWAP( GLenum target, GLenum pname, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETTEXPARAMETERFV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetTexParameteriv( GLenum target, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETTEXPARAMETERIV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetTexParameterivSWAP( GLenum target, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETTEXPARAMETERIV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetTrackMatrixivNV( GLenum target, GLuint address, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 36 );
	WRITE_DATA( 0, GLint, 36 );
	WRITE_DATA( 4, GLenum, CR_GETTRACKMATRIXIVNV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLuint, address );
	WRITE_DATA( 16, GLenum, pname );
	WRITE_NETWORK_POINTER( 20, (void *) params );
	WRITE_NETWORK_POINTER( 28, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetTrackMatrixivNVSWAP( GLenum target, GLuint address, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 36 );
	WRITE_DATA( 0, GLint, SWAP32(36) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETTRACKMATRIXIVNV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLuint, SWAP32(address) );
	WRITE_DATA( 16, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 20, (void *) params );
	WRITE_NETWORK_POINTER( 28, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetUniformfv( GLuint program, GLint location, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETUNIFORMFV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, program );
	WRITE_DATA( 12, GLint, location );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetUniformfvSWAP( GLuint program, GLint location, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETUNIFORMFV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(program) );
	WRITE_DATA( 12, GLint, SWAP32(location) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetUniformiv( GLuint program, GLint location, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETUNIFORMIV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, program );
	WRITE_DATA( 12, GLint, location );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetUniformivSWAP( GLuint program, GLint location, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETUNIFORMIV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(program) );
	WRITE_DATA( 12, GLint, SWAP32(location) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetVertexAttribPointervARB( GLuint index, GLenum pname, GLvoid ** pointer, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETVERTEXATTRIBPOINTERVARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, index );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) pointer );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetVertexAttribPointervARBSWAP( GLuint index, GLenum pname, GLvoid ** pointer, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETVERTEXATTRIBPOINTERVARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(index) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) pointer );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetVertexAttribPointervNV( GLuint index, GLenum pname, GLvoid ** pointer, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETVERTEXATTRIBPOINTERVNV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, index );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) pointer );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetVertexAttribPointervNVSWAP( GLuint index, GLenum pname, GLvoid ** pointer, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETVERTEXATTRIBPOINTERVNV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(index) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) pointer );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetVertexAttribdvARB( GLuint index, GLenum pname, GLdouble * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETVERTEXATTRIBDVARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, index );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetVertexAttribdvARBSWAP( GLuint index, GLenum pname, GLdouble * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETVERTEXATTRIBDVARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(index) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetVertexAttribdvNV( GLuint index, GLenum pname, GLdouble * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETVERTEXATTRIBDVNV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, index );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetVertexAttribdvNVSWAP( GLuint index, GLenum pname, GLdouble * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETVERTEXATTRIBDVNV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(index) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetVertexAttribfvARB( GLuint index, GLenum pname, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETVERTEXATTRIBFVARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, index );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetVertexAttribfvARBSWAP( GLuint index, GLenum pname, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETVERTEXATTRIBFVARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(index) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetVertexAttribfvNV( GLuint index, GLenum pname, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETVERTEXATTRIBFVNV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, index );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetVertexAttribfvNVSWAP( GLuint index, GLenum pname, GLfloat * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETVERTEXATTRIBFVNV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(index) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetVertexAttribivARB( GLuint index, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETVERTEXATTRIBIVARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, index );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetVertexAttribivARBSWAP( GLuint index, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETVERTEXATTRIBIVARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(index) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetVertexAttribivNV( GLuint index, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_GETVERTEXATTRIBIVNV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, index );
	WRITE_DATA( 12, GLenum, pname );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackGetVertexAttribivNVSWAP( GLuint index, GLenum pname, GLint * params, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_GETVERTEXATTRIBIVNV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(index) );
	WRITE_DATA( 12, GLenum, SWAP32(pname) );
	WRITE_NETWORK_POINTER( 16, (void *) params );
	WRITE_NETWORK_POINTER( 24, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackHint( GLenum target, GLenum mode )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, 16 );
	WRITE_DATA( 4, GLenum, CR_HINT_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLenum, mode );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackHintSWAP( GLenum target, GLenum mode )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(16) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_HINT_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLenum, SWAP32(mode) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIndexMask( GLuint mask )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLuint, mask );
	WRITE_OPCODE( pc, CR_INDEXMASK_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIndexMaskSWAP( GLuint mask )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLuint, SWAP32(mask) );
	WRITE_OPCODE( pc, CR_INDEXMASK_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIndexd( GLdouble c )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.index.d1 = data_ptr;
	WRITE_DOUBLE( 0, c );
	WRITE_OPCODE( pc, CR_INDEXD_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIndexdSWAP( GLdouble c )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.index.d1 = data_ptr;
	WRITE_SWAPPED_DOUBLE( 0, c );
	WRITE_OPCODE( pc, CR_INDEXD_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIndexdv( const GLdouble * c )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!c) {
        crDebug("App passed NULL as c for Indexdv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.index.d1 = data_ptr;
	WRITE_DOUBLE( 0, c[0] );
	WRITE_OPCODE( pc, CR_INDEXD_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIndexdvSWAP( const GLdouble * c )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!c) {
        crDebug("App passed NULL as c for Indexdv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.index.d1 = data_ptr;
	WRITE_SWAPPED_DOUBLE( 0, c[0] );
	WRITE_OPCODE( pc, CR_INDEXD_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIndexf( GLfloat c )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.index.f1 = data_ptr;
	WRITE_DATA( 0, GLfloat, c );
	WRITE_OPCODE( pc, CR_INDEXF_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIndexfSWAP( GLfloat c )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.index.f1 = data_ptr;
	WRITE_DATA( 0, GLuint, SWAPFLOAT(c) );
	WRITE_OPCODE( pc, CR_INDEXF_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIndexfv( const GLfloat * c )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!c) {
        crDebug("App passed NULL as c for Indexfv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.index.f1 = data_ptr;
	WRITE_DATA( 0, GLfloat, c[0] );
	WRITE_OPCODE( pc, CR_INDEXF_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIndexfvSWAP( const GLfloat * c )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!c) {
        crDebug("App passed NULL as c for Indexfv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.index.f1 = data_ptr;
	WRITE_DATA( 0, GLuint, SWAPFLOAT(c[0]) );
	WRITE_OPCODE( pc, CR_INDEXF_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIndexi( GLint c )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.index.i1 = data_ptr;
	WRITE_DATA( 0, GLint, c );
	WRITE_OPCODE( pc, CR_INDEXI_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIndexiSWAP( GLint c )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.index.i1 = data_ptr;
	WRITE_DATA( 0, GLint, SWAP32(c) );
	WRITE_OPCODE( pc, CR_INDEXI_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIndexiv( const GLint * c )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!c) {
        crDebug("App passed NULL as c for Indexiv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.index.i1 = data_ptr;
	WRITE_DATA( 0, GLint, c[0] );
	WRITE_OPCODE( pc, CR_INDEXI_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIndexivSWAP( const GLint * c )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!c) {
        crDebug("App passed NULL as c for Indexiv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.index.i1 = data_ptr;
	WRITE_DATA( 0, GLint, SWAP32(c[0]) );
	WRITE_OPCODE( pc, CR_INDEXI_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIndexs( GLshort c )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.index.s1 = data_ptr;
	WRITE_DATA( 0, GLshort, c );
	WRITE_OPCODE( pc, CR_INDEXS_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIndexsSWAP( GLshort c )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.index.s1 = data_ptr;
	WRITE_DATA( 0, GLshort, SWAP16(c) );
	WRITE_OPCODE( pc, CR_INDEXS_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIndexsv( const GLshort * c )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!c) {
        crDebug("App passed NULL as c for Indexsv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.index.s1 = data_ptr;
	WRITE_DATA( 0, GLshort, c[0] );
	WRITE_OPCODE( pc, CR_INDEXS_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIndexsvSWAP( const GLshort * c )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!c) {
        crDebug("App passed NULL as c for Indexsv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.index.s1 = data_ptr;
	WRITE_DATA( 0, GLshort, SWAP16(c[0]) );
	WRITE_OPCODE( pc, CR_INDEXS_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIndexub( GLubyte c )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.index.ub1 = data_ptr;
	WRITE_DATA( 0, GLubyte, c );
	WRITE_OPCODE( pc, CR_INDEXUB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIndexubSWAP( GLubyte c )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.index.ub1 = data_ptr;
	WRITE_DATA( 0, GLubyte, c );
	WRITE_OPCODE( pc, CR_INDEXUB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIndexubv( const GLubyte * c )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!c) {
        crDebug("App passed NULL as c for Indexubv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.index.ub1 = data_ptr;
	WRITE_DATA( 0, GLubyte, c[0] );
	WRITE_OPCODE( pc, CR_INDEXUB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIndexubvSWAP( const GLubyte * c )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!c) {
        crDebug("App passed NULL as c for Indexubv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.index.ub1 = data_ptr;
	WRITE_DATA( 0, GLubyte, c[0] );
	WRITE_OPCODE( pc, CR_INDEXUB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackInitNames( void )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_ARGS( pc );
	WRITE_OPCODE( pc, CR_INITNAMES_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackInitNamesSWAP( void )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_ARGS( pc );
	WRITE_OPCODE( pc, CR_INITNAMES_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIsBufferARB( GLuint buffer, GLboolean * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_ISBUFFERARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, buffer );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIsBufferARBSWAP( GLuint buffer, GLboolean * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_ISBUFFERARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(buffer) );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIsEnabled( GLenum cap, GLboolean * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_ISENABLED_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, cap );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIsEnabledSWAP( GLenum cap, GLboolean * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_ISENABLED_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(cap) );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIsFenceNV( GLuint fence, GLboolean * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_ISFENCENV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, fence );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIsFenceNVSWAP( GLuint fence, GLboolean * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_ISFENCENV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(fence) );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIsFramebufferEXT( GLuint framebuffer, GLboolean * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_ISFRAMEBUFFEREXT_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, framebuffer );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIsFramebufferEXTSWAP( GLuint framebuffer, GLboolean * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_ISFRAMEBUFFEREXT_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(framebuffer) );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIsList( GLuint list, GLboolean * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_ISLIST_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, list );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIsListSWAP( GLuint list, GLboolean * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_ISLIST_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(list) );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIsProgram( GLuint program, GLboolean * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_ISPROGRAM_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, program );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIsProgramSWAP( GLuint program, GLboolean * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_ISPROGRAM_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(program) );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIsProgramARB( GLuint program, GLboolean * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_ISPROGRAMARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, program );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIsProgramARBSWAP( GLuint program, GLboolean * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_ISPROGRAMARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(program) );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIsQueryARB( GLuint id, GLboolean * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_ISQUERYARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, id );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIsQueryARBSWAP( GLuint id, GLboolean * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_ISQUERYARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(id) );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIsRenderbufferEXT( GLuint renderbuffer, GLboolean * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_ISRENDERBUFFEREXT_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, renderbuffer );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIsRenderbufferEXTSWAP( GLuint renderbuffer, GLboolean * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_ISRENDERBUFFEREXT_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(renderbuffer) );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIsShader( GLuint shader, GLboolean * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_ISSHADER_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, shader );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIsShaderSWAP( GLuint shader, GLboolean * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_ISSHADER_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(shader) );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIsTexture( GLuint texture, GLboolean * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_ISTEXTURE_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, texture );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackIsTextureSWAP( GLuint texture, GLboolean * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_ISTEXTURE_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(texture) );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackLightModelf( GLenum pname, GLfloat param )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLenum, pname );
	WRITE_DATA( 4, GLfloat, param );
	WRITE_OPCODE( pc, CR_LIGHTMODELF_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackLightModelfSWAP( GLenum pname, GLfloat param )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLenum, SWAP32(pname) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(param) );
	WRITE_OPCODE( pc, CR_LIGHTMODELF_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackLightModeli( GLenum pname, GLint param )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLenum, pname );
	WRITE_DATA( 4, GLint, param );
	WRITE_OPCODE( pc, CR_LIGHTMODELI_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackLightModeliSWAP( GLenum pname, GLint param )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLenum, SWAP32(pname) );
	WRITE_DATA( 4, GLint, SWAP32(param) );
	WRITE_OPCODE( pc, CR_LIGHTMODELI_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackLightf( GLenum light, GLenum pname, GLfloat param )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLenum, light );
	WRITE_DATA( 4, GLenum, pname );
	WRITE_DATA( 8, GLfloat, param );
	WRITE_OPCODE( pc, CR_LIGHTF_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackLightfSWAP( GLenum light, GLenum pname, GLfloat param )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLenum, SWAP32(light) );
	WRITE_DATA( 4, GLenum, SWAP32(pname) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(param) );
	WRITE_OPCODE( pc, CR_LIGHTF_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackLighti( GLenum light, GLenum pname, GLint param )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLenum, light );
	WRITE_DATA( 4, GLenum, pname );
	WRITE_DATA( 8, GLint, param );
	WRITE_OPCODE( pc, CR_LIGHTI_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackLightiSWAP( GLenum light, GLenum pname, GLint param )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLenum, SWAP32(light) );
	WRITE_DATA( 4, GLenum, SWAP32(pname) );
	WRITE_DATA( 8, GLint, SWAP32(param) );
	WRITE_OPCODE( pc, CR_LIGHTI_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackLineStipple( GLint factor, GLushort pattern )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLint, factor );
	WRITE_DATA( 4, GLushort, pattern );
	WRITE_OPCODE( pc, CR_LINESTIPPLE_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackLineStippleSWAP( GLint factor, GLushort pattern )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLint, SWAP32(factor) );
	WRITE_DATA( 4, GLushort, SWAP16(pattern) );
	WRITE_OPCODE( pc, CR_LINESTIPPLE_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackLineWidth( GLfloat width )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLfloat, width );
	WRITE_OPCODE( pc, CR_LINEWIDTH_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackLineWidthSWAP( GLfloat width )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLuint, SWAPFLOAT(width) );
	WRITE_OPCODE( pc, CR_LINEWIDTH_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackLinkProgram( GLuint program )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, 12 );
	WRITE_DATA( 4, GLenum, CR_LINKPROGRAM_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, program );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackLinkProgramSWAP( GLuint program )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(12) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_LINKPROGRAM_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(program) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackListBase( GLuint base )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, 12 );
	WRITE_DATA( 4, GLenum, CR_LISTBASE_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, base );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackListBaseSWAP( GLuint base )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(12) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_LISTBASE_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(base) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackLoadIdentity( void )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_ARGS( pc );
	WRITE_OPCODE( pc, CR_LOADIDENTITY_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackLoadIdentitySWAP( void )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_ARGS( pc );
	WRITE_OPCODE( pc, CR_LOADIDENTITY_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackLoadName( GLuint name )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLuint, name );
	WRITE_OPCODE( pc, CR_LOADNAME_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackLoadNameSWAP( GLuint name )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLuint, SWAP32(name) );
	WRITE_OPCODE( pc, CR_LOADNAME_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackLogicOp( GLenum opcode )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, 12 );
	WRITE_DATA( 4, GLenum, CR_LOGICOP_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, opcode );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackLogicOpSWAP( GLenum opcode )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(12) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_LOGICOP_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(opcode) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMakeCurrent( GLint window, GLint nativeWindow, GLint ctx )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 20 );
	WRITE_DATA( 0, GLint, 20 );
	WRITE_DATA( 4, GLenum, CR_MAKECURRENT_EXTEND_OPCODE );
	WRITE_DATA( 8, GLint, window );
	WRITE_DATA( 12, GLint, nativeWindow );
	WRITE_DATA( 16, GLint, ctx );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMakeCurrentSWAP( GLint window, GLint nativeWindow, GLint ctx )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 20 );
	WRITE_DATA( 0, GLint, SWAP32(20) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_MAKECURRENT_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLint, SWAP32(window) );
	WRITE_DATA( 12, GLint, SWAP32(nativeWindow) );
	WRITE_DATA( 16, GLint, SWAP32(ctx) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMapGrid1d( GLint un, GLdouble u1, GLdouble u2 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 20 );
	WRITE_DATA( 0, GLint, un );
	WRITE_DOUBLE( 4, u1 );
	WRITE_DOUBLE( 12, u2 );
	WRITE_OPCODE( pc, CR_MAPGRID1D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMapGrid1dSWAP( GLint un, GLdouble u1, GLdouble u2 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 20 );
	WRITE_DATA( 0, GLint, SWAP32(un) );
	WRITE_SWAPPED_DOUBLE( 4, u1 );
	WRITE_SWAPPED_DOUBLE( 12, u2 );
	WRITE_OPCODE( pc, CR_MAPGRID1D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMapGrid1f( GLint un, GLfloat u1, GLfloat u2 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, un );
	WRITE_DATA( 4, GLfloat, u1 );
	WRITE_DATA( 8, GLfloat, u2 );
	WRITE_OPCODE( pc, CR_MAPGRID1F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMapGrid1fSWAP( GLint un, GLfloat u1, GLfloat u2 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(un) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(u1) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(u2) );
	WRITE_OPCODE( pc, CR_MAPGRID1F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMapGrid2d( GLint un, GLdouble u1, GLdouble u2, GLint vn, GLdouble v1, GLdouble v2 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 40 );
	WRITE_DATA( 0, GLint, un );
	WRITE_DOUBLE( 4, u1 );
	WRITE_DOUBLE( 12, u2 );
	WRITE_DATA( 20, GLint, vn );
	WRITE_DOUBLE( 24, v1 );
	WRITE_DOUBLE( 32, v2 );
	WRITE_OPCODE( pc, CR_MAPGRID2D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMapGrid2dSWAP( GLint un, GLdouble u1, GLdouble u2, GLint vn, GLdouble v1, GLdouble v2 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 40 );
	WRITE_DATA( 0, GLint, SWAP32(un) );
	WRITE_SWAPPED_DOUBLE( 4, u1 );
	WRITE_SWAPPED_DOUBLE( 12, u2 );
	WRITE_DATA( 20, GLint, SWAP32(vn) );
	WRITE_SWAPPED_DOUBLE( 24, v1 );
	WRITE_SWAPPED_DOUBLE( 32, v2 );
	WRITE_OPCODE( pc, CR_MAPGRID2D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMapGrid2f( GLint un, GLfloat u1, GLfloat u2, GLint vn, GLfloat v1, GLfloat v2 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, un );
	WRITE_DATA( 4, GLfloat, u1 );
	WRITE_DATA( 8, GLfloat, u2 );
	WRITE_DATA( 12, GLint, vn );
	WRITE_DATA( 16, GLfloat, v1 );
	WRITE_DATA( 20, GLfloat, v2 );
	WRITE_OPCODE( pc, CR_MAPGRID2F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMapGrid2fSWAP( GLint un, GLfloat u1, GLfloat u2, GLint vn, GLfloat v1, GLfloat v2 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, SWAP32(un) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(u1) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(u2) );
	WRITE_DATA( 12, GLint, SWAP32(vn) );
	WRITE_DATA( 16, GLuint, SWAPFLOAT(v1) );
	WRITE_DATA( 20, GLuint, SWAPFLOAT(v2) );
	WRITE_OPCODE( pc, CR_MAPGRID2F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMaterialf( GLenum face, GLenum pname, GLfloat param )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLenum, face );
	WRITE_DATA( 4, GLenum, pname );
	WRITE_DATA( 8, GLfloat, param );
	WRITE_OPCODE( pc, CR_MATERIALF_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMaterialfSWAP( GLenum face, GLenum pname, GLfloat param )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLenum, SWAP32(face) );
	WRITE_DATA( 4, GLenum, SWAP32(pname) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(param) );
	WRITE_OPCODE( pc, CR_MATERIALF_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMateriali( GLenum face, GLenum pname, GLint param )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLenum, face );
	WRITE_DATA( 4, GLenum, pname );
	WRITE_DATA( 8, GLint, param );
	WRITE_OPCODE( pc, CR_MATERIALI_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMaterialiSWAP( GLenum face, GLenum pname, GLint param )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLenum, SWAP32(face) );
	WRITE_DATA( 4, GLenum, SWAP32(pname) );
	WRITE_DATA( 8, GLint, SWAP32(param) );
	WRITE_OPCODE( pc, CR_MATERIALI_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMatrixMode( GLenum mode )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLenum, mode );
	WRITE_OPCODE( pc, CR_MATRIXMODE_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMatrixModeSWAP( GLenum mode )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLenum, SWAP32(mode) );
	WRITE_OPCODE( pc, CR_MATRIXMODE_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord1dARB( GLenum texture, GLdouble s )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.texCoord.d1[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, texture );
	WRITE_DOUBLE( 4, s );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD1DARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord1dARBSWAP( GLenum texture, GLdouble s )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.texCoord.d1[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, SWAP32(texture) );
	WRITE_SWAPPED_DOUBLE( 4, s );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD1DARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord1dvARB( GLenum texture, const GLdouble * t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord1dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.texCoord.d1[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, texture );
	WRITE_DOUBLE( 4, t[0] );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD1DARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord1dvARBSWAP( GLenum texture, const GLdouble * t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord1dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.texCoord.d1[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, SWAP32(texture) );
	WRITE_SWAPPED_DOUBLE( 4, t[0] );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD1DARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord1fARB( GLenum texture, GLfloat s )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.f1[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, texture );
	WRITE_DATA( 4, GLfloat, s );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD1FARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord1fARBSWAP( GLenum texture, GLfloat s )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.f1[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, SWAP32(texture) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(s) );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD1FARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord1fvARB( GLenum texture, const GLfloat * t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord1fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.f1[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, texture );
	WRITE_DATA( 4, GLfloat, t[0] );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD1FARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord1fvARBSWAP( GLenum texture, const GLfloat * t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord1fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.f1[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, SWAP32(texture) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(t[0]) );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD1FARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord1iARB( GLenum texture, GLint s )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.i1[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, texture );
	WRITE_DATA( 4, GLint, s );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD1IARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord1iARBSWAP( GLenum texture, GLint s )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.i1[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, SWAP32(texture) );
	WRITE_DATA( 4, GLint, SWAP32(s) );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD1IARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord1ivARB( GLenum texture, const GLint * t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord1ivARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.i1[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, texture );
	WRITE_DATA( 4, GLint, t[0] );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD1IARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord1ivARBSWAP( GLenum texture, const GLint * t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord1ivARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.i1[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, SWAP32(texture) );
	WRITE_DATA( 4, GLint, SWAP32(t[0]) );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD1IARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord1sARB( GLenum texture, GLshort s )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.s1[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, texture );
	WRITE_DATA( 4, GLshort, s );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD1SARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord1sARBSWAP( GLenum texture, GLshort s )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.s1[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, SWAP32(texture) );
	WRITE_DATA( 4, GLshort, SWAP16(s) );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD1SARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord1svARB( GLenum texture, const GLshort * t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord1svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.s1[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, texture );
	WRITE_DATA( 4, GLshort, t[0] );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD1SARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord1svARBSWAP( GLenum texture, const GLshort * t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord1svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.s1[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, SWAP32(texture) );
	WRITE_DATA( 4, GLshort, SWAP16(t[0]) );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD1SARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord2dARB( GLenum texture, GLdouble s, GLdouble t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 20 );
	pc->current.c.texCoord.d2[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, texture );
	WRITE_DOUBLE( 4, s );
	WRITE_DOUBLE( 12, t );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD2DARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord2dARBSWAP( GLenum texture, GLdouble s, GLdouble t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 20 );
	pc->current.c.texCoord.d2[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, SWAP32(texture) );
	WRITE_SWAPPED_DOUBLE( 4, s );
	WRITE_SWAPPED_DOUBLE( 12, t );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD2DARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord2dvARB( GLenum texture, const GLdouble * t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord2dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 20 );
	pc->current.c.texCoord.d2[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, texture );
	WRITE_DOUBLE( 4, t[0] );
	WRITE_DOUBLE( 12, t[1] );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD2DARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord2dvARBSWAP( GLenum texture, const GLdouble * t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord2dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 20 );
	pc->current.c.texCoord.d2[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, SWAP32(texture) );
	WRITE_SWAPPED_DOUBLE( 4, t[0] );
	WRITE_SWAPPED_DOUBLE( 12, t[1] );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD2DARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord2fARB( GLenum texture, GLfloat s, GLfloat t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.texCoord.f2[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, texture );
	WRITE_DATA( 4, GLfloat, s );
	WRITE_DATA( 8, GLfloat, t );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD2FARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord2fARBSWAP( GLenum texture, GLfloat s, GLfloat t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.texCoord.f2[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, SWAP32(texture) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(s) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(t) );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD2FARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord2fvARB( GLenum texture, const GLfloat * t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord2fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.texCoord.f2[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, texture );
	WRITE_DATA( 4, GLfloat, t[0] );
	WRITE_DATA( 8, GLfloat, t[1] );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD2FARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord2fvARBSWAP( GLenum texture, const GLfloat * t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord2fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.texCoord.f2[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, SWAP32(texture) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(t[0]) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(t[1]) );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD2FARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord2iARB( GLenum texture, GLint s, GLint t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.texCoord.i2[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, texture );
	WRITE_DATA( 4, GLint, s );
	WRITE_DATA( 8, GLint, t );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD2IARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord2iARBSWAP( GLenum texture, GLint s, GLint t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.texCoord.i2[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, SWAP32(texture) );
	WRITE_DATA( 4, GLint, SWAP32(s) );
	WRITE_DATA( 8, GLint, SWAP32(t) );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD2IARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord2ivARB( GLenum texture, const GLint * t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord2ivARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.texCoord.i2[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, texture );
	WRITE_DATA( 4, GLint, t[0] );
	WRITE_DATA( 8, GLint, t[1] );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD2IARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord2ivARBSWAP( GLenum texture, const GLint * t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord2ivARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.texCoord.i2[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, SWAP32(texture) );
	WRITE_DATA( 4, GLint, SWAP32(t[0]) );
	WRITE_DATA( 8, GLint, SWAP32(t[1]) );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD2IARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord2sARB( GLenum texture, GLshort s, GLshort t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.s2[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, texture );
	WRITE_DATA( 4, GLshort, s );
	WRITE_DATA( 6, GLshort, t );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD2SARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord2sARBSWAP( GLenum texture, GLshort s, GLshort t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.s2[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, SWAP32(texture) );
	WRITE_DATA( 4, GLshort, SWAP16(s) );
	WRITE_DATA( 6, GLshort, SWAP16(t) );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD2SARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord2svARB( GLenum texture, const GLshort * t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord2svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.s2[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, texture );
	WRITE_DATA( 4, GLshort, t[0] );
	WRITE_DATA( 6, GLshort, t[1] );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD2SARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord2svARBSWAP( GLenum texture, const GLshort * t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord2svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.s2[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, SWAP32(texture) );
	WRITE_DATA( 4, GLshort, SWAP16(t[0]) );
	WRITE_DATA( 6, GLshort, SWAP16(t[1]) );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD2SARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord3dARB( GLenum texture, GLdouble s, GLdouble t, GLdouble r )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	pc->current.c.texCoord.d3[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, texture );
	WRITE_DOUBLE( 4, s );
	WRITE_DOUBLE( 12, t );
	WRITE_DOUBLE( 20, r );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD3DARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord3dARBSWAP( GLenum texture, GLdouble s, GLdouble t, GLdouble r )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	pc->current.c.texCoord.d3[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, SWAP32(texture) );
	WRITE_SWAPPED_DOUBLE( 4, s );
	WRITE_SWAPPED_DOUBLE( 12, t );
	WRITE_SWAPPED_DOUBLE( 20, r );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD3DARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord3dvARB( GLenum texture, const GLdouble * t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord3dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 28 );
	pc->current.c.texCoord.d3[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, texture );
	WRITE_DOUBLE( 4, t[0] );
	WRITE_DOUBLE( 12, t[1] );
	WRITE_DOUBLE( 20, t[2] );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD3DARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord3dvARBSWAP( GLenum texture, const GLdouble * t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord3dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 28 );
	pc->current.c.texCoord.d3[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, SWAP32(texture) );
	WRITE_SWAPPED_DOUBLE( 4, t[0] );
	WRITE_SWAPPED_DOUBLE( 12, t[1] );
	WRITE_SWAPPED_DOUBLE( 20, t[2] );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD3DARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord3fARB( GLenum texture, GLfloat s, GLfloat t, GLfloat r )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	pc->current.c.texCoord.f3[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, texture );
	WRITE_DATA( 4, GLfloat, s );
	WRITE_DATA( 8, GLfloat, t );
	WRITE_DATA( 12, GLfloat, r );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD3FARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord3fARBSWAP( GLenum texture, GLfloat s, GLfloat t, GLfloat r )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	pc->current.c.texCoord.f3[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, SWAP32(texture) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(s) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(t) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(r) );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD3FARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord3fvARB( GLenum texture, const GLfloat * t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord3fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	pc->current.c.texCoord.f3[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, texture );
	WRITE_DATA( 4, GLfloat, t[0] );
	WRITE_DATA( 8, GLfloat, t[1] );
	WRITE_DATA( 12, GLfloat, t[2] );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD3FARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord3fvARBSWAP( GLenum texture, const GLfloat * t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord3fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	pc->current.c.texCoord.f3[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, SWAP32(texture) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(t[0]) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(t[1]) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(t[2]) );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD3FARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord3iARB( GLenum texture, GLint s, GLint t, GLint r )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	pc->current.c.texCoord.i3[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, texture );
	WRITE_DATA( 4, GLint, s );
	WRITE_DATA( 8, GLint, t );
	WRITE_DATA( 12, GLint, r );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD3IARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord3iARBSWAP( GLenum texture, GLint s, GLint t, GLint r )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	pc->current.c.texCoord.i3[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, SWAP32(texture) );
	WRITE_DATA( 4, GLint, SWAP32(s) );
	WRITE_DATA( 8, GLint, SWAP32(t) );
	WRITE_DATA( 12, GLint, SWAP32(r) );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD3IARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord3ivARB( GLenum texture, const GLint * t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord3ivARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	pc->current.c.texCoord.i3[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, texture );
	WRITE_DATA( 4, GLint, t[0] );
	WRITE_DATA( 8, GLint, t[1] );
	WRITE_DATA( 12, GLint, t[2] );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD3IARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord3ivARBSWAP( GLenum texture, const GLint * t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord3ivARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	pc->current.c.texCoord.i3[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, SWAP32(texture) );
	WRITE_DATA( 4, GLint, SWAP32(t[0]) );
	WRITE_DATA( 8, GLint, SWAP32(t[1]) );
	WRITE_DATA( 12, GLint, SWAP32(t[2]) );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD3IARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord3sARB( GLenum texture, GLshort s, GLshort t, GLshort r )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.texCoord.s3[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, texture );
	WRITE_DATA( 4, GLshort, s );
	WRITE_DATA( 6, GLshort, t );
	WRITE_DATA( 8, GLshort, r );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD3SARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord3sARBSWAP( GLenum texture, GLshort s, GLshort t, GLshort r )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.texCoord.s3[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, SWAP32(texture) );
	WRITE_DATA( 4, GLshort, SWAP16(s) );
	WRITE_DATA( 6, GLshort, SWAP16(t) );
	WRITE_DATA( 8, GLshort, SWAP16(r) );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD3SARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord3svARB( GLenum texture, const GLshort * t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord3svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.texCoord.s3[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, texture );
	WRITE_DATA( 4, GLshort, t[0] );
	WRITE_DATA( 6, GLshort, t[1] );
	WRITE_DATA( 8, GLshort, t[2] );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD3SARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord3svARBSWAP( GLenum texture, const GLshort * t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord3svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.texCoord.s3[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, SWAP32(texture) );
	WRITE_DATA( 4, GLshort, SWAP16(t[0]) );
	WRITE_DATA( 6, GLshort, SWAP16(t[1]) );
	WRITE_DATA( 8, GLshort, SWAP16(t[2]) );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD3SARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord4dARB( GLenum texture, GLdouble s, GLdouble t, GLdouble r, GLdouble q )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 36 );
	pc->current.c.texCoord.d4[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, texture );
	WRITE_DOUBLE( 4, s );
	WRITE_DOUBLE( 12, t );
	WRITE_DOUBLE( 20, r );
	WRITE_DOUBLE( 28, q );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD4DARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord4dARBSWAP( GLenum texture, GLdouble s, GLdouble t, GLdouble r, GLdouble q )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 36 );
	pc->current.c.texCoord.d4[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, SWAP32(texture) );
	WRITE_SWAPPED_DOUBLE( 4, s );
	WRITE_SWAPPED_DOUBLE( 12, t );
	WRITE_SWAPPED_DOUBLE( 20, r );
	WRITE_SWAPPED_DOUBLE( 28, q );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD4DARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord4dvARB( GLenum texture, const GLdouble * t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord4dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 36 );
	pc->current.c.texCoord.d4[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, texture );
	WRITE_DOUBLE( 4, t[0] );
	WRITE_DOUBLE( 12, t[1] );
	WRITE_DOUBLE( 20, t[2] );
	WRITE_DOUBLE( 28, t[3] );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD4DARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord4dvARBSWAP( GLenum texture, const GLdouble * t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord4dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 36 );
	pc->current.c.texCoord.d4[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, SWAP32(texture) );
	WRITE_SWAPPED_DOUBLE( 4, t[0] );
	WRITE_SWAPPED_DOUBLE( 12, t[1] );
	WRITE_SWAPPED_DOUBLE( 20, t[2] );
	WRITE_SWAPPED_DOUBLE( 28, t[3] );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD4DARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord4fARB( GLenum texture, GLfloat s, GLfloat t, GLfloat r, GLfloat q )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 20 );
	pc->current.c.texCoord.f4[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, texture );
	WRITE_DATA( 4, GLfloat, s );
	WRITE_DATA( 8, GLfloat, t );
	WRITE_DATA( 12, GLfloat, r );
	WRITE_DATA( 16, GLfloat, q );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD4FARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord4fARBSWAP( GLenum texture, GLfloat s, GLfloat t, GLfloat r, GLfloat q )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 20 );
	pc->current.c.texCoord.f4[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, SWAP32(texture) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(s) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(t) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(r) );
	WRITE_DATA( 16, GLuint, SWAPFLOAT(q) );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD4FARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord4fvARB( GLenum texture, const GLfloat * t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord4fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 20 );
	pc->current.c.texCoord.f4[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, texture );
	WRITE_DATA( 4, GLfloat, t[0] );
	WRITE_DATA( 8, GLfloat, t[1] );
	WRITE_DATA( 12, GLfloat, t[2] );
	WRITE_DATA( 16, GLfloat, t[3] );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD4FARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord4fvARBSWAP( GLenum texture, const GLfloat * t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord4fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 20 );
	pc->current.c.texCoord.f4[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, SWAP32(texture) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(t[0]) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(t[1]) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(t[2]) );
	WRITE_DATA( 16, GLuint, SWAPFLOAT(t[3]) );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD4FARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord4iARB( GLenum texture, GLint s, GLint t, GLint r, GLint q )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 20 );
	pc->current.c.texCoord.i4[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, texture );
	WRITE_DATA( 4, GLint, s );
	WRITE_DATA( 8, GLint, t );
	WRITE_DATA( 12, GLint, r );
	WRITE_DATA( 16, GLint, q );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD4IARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord4iARBSWAP( GLenum texture, GLint s, GLint t, GLint r, GLint q )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 20 );
	pc->current.c.texCoord.i4[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, SWAP32(texture) );
	WRITE_DATA( 4, GLint, SWAP32(s) );
	WRITE_DATA( 8, GLint, SWAP32(t) );
	WRITE_DATA( 12, GLint, SWAP32(r) );
	WRITE_DATA( 16, GLint, SWAP32(q) );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD4IARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord4ivARB( GLenum texture, const GLint * t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord4ivARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 20 );
	pc->current.c.texCoord.i4[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, texture );
	WRITE_DATA( 4, GLint, t[0] );
	WRITE_DATA( 8, GLint, t[1] );
	WRITE_DATA( 12, GLint, t[2] );
	WRITE_DATA( 16, GLint, t[3] );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD4IARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord4ivARBSWAP( GLenum texture, const GLint * t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord4ivARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 20 );
	pc->current.c.texCoord.i4[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, SWAP32(texture) );
	WRITE_DATA( 4, GLint, SWAP32(t[0]) );
	WRITE_DATA( 8, GLint, SWAP32(t[1]) );
	WRITE_DATA( 12, GLint, SWAP32(t[2]) );
	WRITE_DATA( 16, GLint, SWAP32(t[3]) );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD4IARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord4sARB( GLenum texture, GLshort s, GLshort t, GLshort r, GLshort q )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.texCoord.s4[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, texture );
	WRITE_DATA( 4, GLshort, s );
	WRITE_DATA( 6, GLshort, t );
	WRITE_DATA( 8, GLshort, r );
	WRITE_DATA( 10, GLshort, q );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD4SARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord4sARBSWAP( GLenum texture, GLshort s, GLshort t, GLshort r, GLshort q )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.texCoord.s4[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, SWAP32(texture) );
	WRITE_DATA( 4, GLshort, SWAP16(s) );
	WRITE_DATA( 6, GLshort, SWAP16(t) );
	WRITE_DATA( 8, GLshort, SWAP16(r) );
	WRITE_DATA( 10, GLshort, SWAP16(q) );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD4SARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord4svARB( GLenum texture, const GLshort * t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord4svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.texCoord.s4[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, texture );
	WRITE_DATA( 4, GLshort, t[0] );
	WRITE_DATA( 6, GLshort, t[1] );
	WRITE_DATA( 8, GLshort, t[2] );
	WRITE_DATA( 10, GLshort, t[3] );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD4SARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackMultiTexCoord4svARBSWAP( GLenum texture, const GLshort * t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!t) {
        crDebug("App passed NULL as t for MultiTexCoord4svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.texCoord.s4[texture-GL_TEXTURE0_ARB] = data_ptr + 4;
	WRITE_DATA( 0, GLenum, SWAP32(texture) );
	WRITE_DATA( 4, GLshort, SWAP16(t[0]) );
	WRITE_DATA( 6, GLshort, SWAP16(t[1]) );
	WRITE_DATA( 8, GLshort, SWAP16(t[2]) );
	WRITE_DATA( 10, GLshort, SWAP16(t[3]) );
	WRITE_OPCODE( pc, CR_MULTITEXCOORD4SARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackNormal3b( GLbyte nx, GLbyte ny, GLbyte nz )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.normal.b3 = data_ptr;
	WRITE_DATA( 0, GLbyte, nx );
	WRITE_DATA( 1, GLbyte, ny );
	WRITE_DATA( 2, GLbyte, nz );
	WRITE_OPCODE( pc, CR_NORMAL3B_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackNormal3bSWAP( GLbyte nx, GLbyte ny, GLbyte nz )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.normal.b3 = data_ptr;
	WRITE_DATA( 0, GLbyte, nx );
	WRITE_DATA( 1, GLbyte, ny );
	WRITE_DATA( 2, GLbyte, nz );
	WRITE_OPCODE( pc, CR_NORMAL3B_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackNormal3bv( const GLbyte * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Normal3bv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.normal.b3 = data_ptr;
	WRITE_DATA( 0, GLbyte, v[0] );
	WRITE_DATA( 1, GLbyte, v[1] );
	WRITE_DATA( 2, GLbyte, v[2] );
	WRITE_OPCODE( pc, CR_NORMAL3B_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackNormal3bvSWAP( const GLbyte * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Normal3bv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.normal.b3 = data_ptr;
	WRITE_DATA( 0, GLbyte, v[0] );
	WRITE_DATA( 1, GLbyte, v[1] );
	WRITE_DATA( 2, GLbyte, v[2] );
	WRITE_OPCODE( pc, CR_NORMAL3B_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackNormal3d( GLdouble nx, GLdouble ny, GLdouble nz )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	pc->current.c.normal.d3 = data_ptr;
	WRITE_DOUBLE( 0, nx );
	WRITE_DOUBLE( 8, ny );
	WRITE_DOUBLE( 16, nz );
	WRITE_OPCODE( pc, CR_NORMAL3D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackNormal3dSWAP( GLdouble nx, GLdouble ny, GLdouble nz )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	pc->current.c.normal.d3 = data_ptr;
	WRITE_SWAPPED_DOUBLE( 0, nx );
	WRITE_SWAPPED_DOUBLE( 8, ny );
	WRITE_SWAPPED_DOUBLE( 16, nz );
	WRITE_OPCODE( pc, CR_NORMAL3D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackNormal3dv( const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Normal3dv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 24 );
	pc->current.c.normal.d3 = data_ptr;
	WRITE_DOUBLE( 0, v[0] );
	WRITE_DOUBLE( 8, v[1] );
	WRITE_DOUBLE( 16, v[2] );
	WRITE_OPCODE( pc, CR_NORMAL3D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackNormal3dvSWAP( const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Normal3dv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 24 );
	pc->current.c.normal.d3 = data_ptr;
	WRITE_SWAPPED_DOUBLE( 0, v[0] );
	WRITE_SWAPPED_DOUBLE( 8, v[1] );
	WRITE_SWAPPED_DOUBLE( 16, v[2] );
	WRITE_OPCODE( pc, CR_NORMAL3D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackNormal3f( GLfloat nx, GLfloat ny, GLfloat nz )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.normal.f3 = data_ptr;
	WRITE_DATA( 0, GLfloat, nx );
	WRITE_DATA( 4, GLfloat, ny );
	WRITE_DATA( 8, GLfloat, nz );
	WRITE_OPCODE( pc, CR_NORMAL3F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackNormal3fSWAP( GLfloat nx, GLfloat ny, GLfloat nz )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.normal.f3 = data_ptr;
	WRITE_DATA( 0, GLuint, SWAPFLOAT(nx) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(ny) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(nz) );
	WRITE_OPCODE( pc, CR_NORMAL3F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackNormal3fv( const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Normal3fv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.normal.f3 = data_ptr;
	WRITE_DATA( 0, GLfloat, v[0] );
	WRITE_DATA( 4, GLfloat, v[1] );
	WRITE_DATA( 8, GLfloat, v[2] );
	WRITE_OPCODE( pc, CR_NORMAL3F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackNormal3fvSWAP( const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Normal3fv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.normal.f3 = data_ptr;
	WRITE_DATA( 0, GLuint, SWAPFLOAT(v[0]) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(v[1]) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(v[2]) );
	WRITE_OPCODE( pc, CR_NORMAL3F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackNormal3i( GLint nx, GLint ny, GLint nz )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.normal.i3 = data_ptr;
	WRITE_DATA( 0, GLint, nx );
	WRITE_DATA( 4, GLint, ny );
	WRITE_DATA( 8, GLint, nz );
	WRITE_OPCODE( pc, CR_NORMAL3I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackNormal3iSWAP( GLint nx, GLint ny, GLint nz )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.normal.i3 = data_ptr;
	WRITE_DATA( 0, GLint, SWAP32(nx) );
	WRITE_DATA( 4, GLint, SWAP32(ny) );
	WRITE_DATA( 8, GLint, SWAP32(nz) );
	WRITE_OPCODE( pc, CR_NORMAL3I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackNormal3iv( const GLint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Normal3iv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.normal.i3 = data_ptr;
	WRITE_DATA( 0, GLint, v[0] );
	WRITE_DATA( 4, GLint, v[1] );
	WRITE_DATA( 8, GLint, v[2] );
	WRITE_OPCODE( pc, CR_NORMAL3I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackNormal3ivSWAP( const GLint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Normal3iv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.normal.i3 = data_ptr;
	WRITE_DATA( 0, GLint, SWAP32(v[0]) );
	WRITE_DATA( 4, GLint, SWAP32(v[1]) );
	WRITE_DATA( 8, GLint, SWAP32(v[2]) );
	WRITE_OPCODE( pc, CR_NORMAL3I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackNormal3s( GLshort nx, GLshort ny, GLshort nz )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.normal.s3 = data_ptr;
	WRITE_DATA( 0, GLshort, nx );
	WRITE_DATA( 2, GLshort, ny );
	WRITE_DATA( 4, GLshort, nz );
	WRITE_OPCODE( pc, CR_NORMAL3S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackNormal3sSWAP( GLshort nx, GLshort ny, GLshort nz )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.normal.s3 = data_ptr;
	WRITE_DATA( 0, GLshort, SWAP16(nx) );
	WRITE_DATA( 2, GLshort, SWAP16(ny) );
	WRITE_DATA( 4, GLshort, SWAP16(nz) );
	WRITE_OPCODE( pc, CR_NORMAL3S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackNormal3sv( const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Normal3sv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.normal.s3 = data_ptr;
	WRITE_DATA( 0, GLshort, v[0] );
	WRITE_DATA( 2, GLshort, v[1] );
	WRITE_DATA( 4, GLshort, v[2] );
	WRITE_OPCODE( pc, CR_NORMAL3S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackNormal3svSWAP( const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Normal3sv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.normal.s3 = data_ptr;
	WRITE_DATA( 0, GLshort, SWAP16(v[0]) );
	WRITE_DATA( 2, GLshort, SWAP16(v[1]) );
	WRITE_DATA( 4, GLshort, SWAP16(v[2]) );
	WRITE_OPCODE( pc, CR_NORMAL3S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackOrtho( GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 48 );
	WRITE_DOUBLE( 0, left );
	WRITE_DOUBLE( 8, right );
	WRITE_DOUBLE( 16, bottom );
	WRITE_DOUBLE( 24, top );
	WRITE_DOUBLE( 32, zNear );
	WRITE_DOUBLE( 40, zFar );
	WRITE_OPCODE( pc, CR_ORTHO_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackOrthoSWAP( GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 48 );
	WRITE_SWAPPED_DOUBLE( 0, left );
	WRITE_SWAPPED_DOUBLE( 8, right );
	WRITE_SWAPPED_DOUBLE( 16, bottom );
	WRITE_SWAPPED_DOUBLE( 24, top );
	WRITE_SWAPPED_DOUBLE( 32, zNear );
	WRITE_SWAPPED_DOUBLE( 40, zFar );
	WRITE_OPCODE( pc, CR_ORTHO_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPassThrough( GLfloat token )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLfloat, token );
	WRITE_OPCODE( pc, CR_PASSTHROUGH_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPassThroughSWAP( GLfloat token )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLuint, SWAPFLOAT(token) );
	WRITE_OPCODE( pc, CR_PASSTHROUGH_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPixelStoref( GLenum pname, GLfloat param )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLenum, pname );
	WRITE_DATA( 4, GLfloat, param );
	WRITE_OPCODE( pc, CR_PIXELSTOREF_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPixelStorefSWAP( GLenum pname, GLfloat param )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLenum, SWAP32(pname) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(param) );
	WRITE_OPCODE( pc, CR_PIXELSTOREF_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPixelStorei( GLenum pname, GLint param )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLenum, pname );
	WRITE_DATA( 4, GLint, param );
	WRITE_OPCODE( pc, CR_PIXELSTOREI_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPixelStoreiSWAP( GLenum pname, GLint param )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLenum, SWAP32(pname) );
	WRITE_DATA( 4, GLint, SWAP32(param) );
	WRITE_OPCODE( pc, CR_PIXELSTOREI_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPixelTransferf( GLenum pname, GLfloat param )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLenum, pname );
	WRITE_DATA( 4, GLfloat, param );
	WRITE_OPCODE( pc, CR_PIXELTRANSFERF_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPixelTransferfSWAP( GLenum pname, GLfloat param )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLenum, SWAP32(pname) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(param) );
	WRITE_OPCODE( pc, CR_PIXELTRANSFERF_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPixelTransferi( GLenum pname, GLint param )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLenum, pname );
	WRITE_DATA( 4, GLint, param );
	WRITE_OPCODE( pc, CR_PIXELTRANSFERI_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPixelTransferiSWAP( GLenum pname, GLint param )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLenum, SWAP32(pname) );
	WRITE_DATA( 4, GLint, SWAP32(param) );
	WRITE_OPCODE( pc, CR_PIXELTRANSFERI_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPixelZoom( GLfloat xfactor, GLfloat yfactor )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLfloat, xfactor );
	WRITE_DATA( 4, GLfloat, yfactor );
	WRITE_OPCODE( pc, CR_PIXELZOOM_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPixelZoomSWAP( GLfloat xfactor, GLfloat yfactor )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLuint, SWAPFLOAT(xfactor) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(yfactor) );
	WRITE_OPCODE( pc, CR_PIXELZOOM_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPointParameterfARB( GLenum pname, GLfloat param )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, 16 );
	WRITE_DATA( 4, GLenum, CR_POINTPARAMETERFARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, pname );
	WRITE_DATA( 12, GLfloat, param );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPointParameterfARBSWAP( GLenum pname, GLfloat param )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(16) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_POINTPARAMETERFARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(pname) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(param) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPointParameteri( GLenum pname, GLint param )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, 16 );
	WRITE_DATA( 4, GLenum, CR_POINTPARAMETERI_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, pname );
	WRITE_DATA( 12, GLint, param );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPointParameteriSWAP( GLenum pname, GLint param )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(16) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_POINTPARAMETERI_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(pname) );
	WRITE_DATA( 12, GLint, SWAP32(param) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPointSize( GLfloat size )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLfloat, size );
	WRITE_OPCODE( pc, CR_POINTSIZE_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPointSizeSWAP( GLfloat size )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLuint, SWAPFLOAT(size) );
	WRITE_OPCODE( pc, CR_POINTSIZE_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPolygonMode( GLenum face, GLenum mode )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLenum, face );
	WRITE_DATA( 4, GLenum, mode );
	WRITE_OPCODE( pc, CR_POLYGONMODE_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPolygonModeSWAP( GLenum face, GLenum mode )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLenum, SWAP32(face) );
	WRITE_DATA( 4, GLenum, SWAP32(mode) );
	WRITE_OPCODE( pc, CR_POLYGONMODE_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPolygonOffset( GLfloat factor, GLfloat units )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLfloat, factor );
	WRITE_DATA( 4, GLfloat, units );
	WRITE_OPCODE( pc, CR_POLYGONOFFSET_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPolygonOffsetSWAP( GLfloat factor, GLfloat units )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLuint, SWAPFLOAT(factor) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(units) );
	WRITE_OPCODE( pc, CR_POLYGONOFFSET_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPopAttrib( void )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLint, 8 );
	WRITE_DATA( 4, GLenum, CR_POPATTRIB_EXTEND_OPCODE );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPopAttribSWAP( void )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLint, SWAP32(8) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_POPATTRIB_EXTEND_OPCODE) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPopClientAttrib( void )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLint, 8 );
	WRITE_DATA( 4, GLenum, CR_POPCLIENTATTRIB_EXTEND_OPCODE );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPopClientAttribSWAP( void )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLint, SWAP32(8) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_POPCLIENTATTRIB_EXTEND_OPCODE) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPopMatrix( void )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_ARGS( pc );
	WRITE_OPCODE( pc, CR_POPMATRIX_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPopMatrixSWAP( void )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_ARGS( pc );
	WRITE_OPCODE( pc, CR_POPMATRIX_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPopName( void )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_ARGS( pc );
	WRITE_OPCODE( pc, CR_POPNAME_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPopNameSWAP( void )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_ARGS( pc );
	WRITE_OPCODE( pc, CR_POPNAME_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramEnvParameter4dARB( GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 48 );
	WRITE_DATA( 0, GLint, 48 );
	WRITE_DATA( 4, GLenum, CR_PROGRAMENVPARAMETER4DARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLuint, index );
	WRITE_DOUBLE( 16, x );
	WRITE_DOUBLE( 24, y );
	WRITE_DOUBLE( 32, z );
	WRITE_DOUBLE( 40, w );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramEnvParameter4dARBSWAP( GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 48 );
	WRITE_DATA( 0, GLint, SWAP32(48) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_PROGRAMENVPARAMETER4DARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLuint, SWAP32(index) );
	WRITE_SWAPPED_DOUBLE( 16, x );
	WRITE_SWAPPED_DOUBLE( 24, y );
	WRITE_SWAPPED_DOUBLE( 32, z );
	WRITE_SWAPPED_DOUBLE( 40, w );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramEnvParameter4dvARB( GLenum target, GLuint index, const GLdouble * params )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!params) {
        crDebug("App passed NULL as params for ProgramEnvParameter4dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 48 );
	WRITE_DATA( 0, GLint, 48 );
	WRITE_DATA( 4, GLenum, CR_PROGRAMENVPARAMETER4DARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLuint, index );
	WRITE_DOUBLE( 16, params[0] );
	WRITE_DOUBLE( 24, params[1] );
	WRITE_DOUBLE( 32, params[2] );
	WRITE_DOUBLE( 40, params[3] );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramEnvParameter4dvARBSWAP( GLenum target, GLuint index, const GLdouble * params )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!params) {
        crDebug("App passed NULL as params for ProgramEnvParameter4dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 48 );
	WRITE_DATA( 0, GLint, SWAP32(48) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_PROGRAMENVPARAMETER4DARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLuint, SWAP32(index) );
	WRITE_SWAPPED_DOUBLE( 16, params[0] );
	WRITE_SWAPPED_DOUBLE( 24, params[1] );
	WRITE_SWAPPED_DOUBLE( 32, params[2] );
	WRITE_SWAPPED_DOUBLE( 40, params[3] );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramEnvParameter4fARB( GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_PROGRAMENVPARAMETER4FARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLuint, index );
	WRITE_DATA( 16, GLfloat, x );
	WRITE_DATA( 20, GLfloat, y );
	WRITE_DATA( 24, GLfloat, z );
	WRITE_DATA( 28, GLfloat, w );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramEnvParameter4fARBSWAP( GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_PROGRAMENVPARAMETER4FARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLuint, SWAP32(index) );
	WRITE_DATA( 16, GLuint, SWAPFLOAT(x) );
	WRITE_DATA( 20, GLuint, SWAPFLOAT(y) );
	WRITE_DATA( 24, GLuint, SWAPFLOAT(z) );
	WRITE_DATA( 28, GLuint, SWAPFLOAT(w) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramEnvParameter4fvARB( GLenum target, GLuint index, const GLfloat * params )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!params) {
        crDebug("App passed NULL as params for ProgramEnvParameter4fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_PROGRAMENVPARAMETER4FARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLuint, index );
	WRITE_DATA( 16, GLfloat, params[0] );
	WRITE_DATA( 20, GLfloat, params[1] );
	WRITE_DATA( 24, GLfloat, params[2] );
	WRITE_DATA( 28, GLfloat, params[3] );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramEnvParameter4fvARBSWAP( GLenum target, GLuint index, const GLfloat * params )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!params) {
        crDebug("App passed NULL as params for ProgramEnvParameter4fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_PROGRAMENVPARAMETER4FARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLuint, SWAP32(index) );
	WRITE_DATA( 16, GLuint, SWAPFLOAT(params[0]) );
	WRITE_DATA( 20, GLuint, SWAPFLOAT(params[1]) );
	WRITE_DATA( 24, GLuint, SWAPFLOAT(params[2]) );
	WRITE_DATA( 28, GLuint, SWAPFLOAT(params[3]) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramLocalParameter4dARB( GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 48 );
	WRITE_DATA( 0, GLint, 48 );
	WRITE_DATA( 4, GLenum, CR_PROGRAMLOCALPARAMETER4DARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLuint, index );
	WRITE_DOUBLE( 16, x );
	WRITE_DOUBLE( 24, y );
	WRITE_DOUBLE( 32, z );
	WRITE_DOUBLE( 40, w );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramLocalParameter4dARBSWAP( GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 48 );
	WRITE_DATA( 0, GLint, SWAP32(48) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_PROGRAMLOCALPARAMETER4DARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLuint, SWAP32(index) );
	WRITE_SWAPPED_DOUBLE( 16, x );
	WRITE_SWAPPED_DOUBLE( 24, y );
	WRITE_SWAPPED_DOUBLE( 32, z );
	WRITE_SWAPPED_DOUBLE( 40, w );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramLocalParameter4dvARB( GLenum target, GLuint index, const GLdouble * params )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!params) {
        crDebug("App passed NULL as params for ProgramLocalParameter4dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 48 );
	WRITE_DATA( 0, GLint, 48 );
	WRITE_DATA( 4, GLenum, CR_PROGRAMLOCALPARAMETER4DARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLuint, index );
	WRITE_DOUBLE( 16, params[0] );
	WRITE_DOUBLE( 24, params[1] );
	WRITE_DOUBLE( 32, params[2] );
	WRITE_DOUBLE( 40, params[3] );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramLocalParameter4dvARBSWAP( GLenum target, GLuint index, const GLdouble * params )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!params) {
        crDebug("App passed NULL as params for ProgramLocalParameter4dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 48 );
	WRITE_DATA( 0, GLint, SWAP32(48) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_PROGRAMLOCALPARAMETER4DARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLuint, SWAP32(index) );
	WRITE_SWAPPED_DOUBLE( 16, params[0] );
	WRITE_SWAPPED_DOUBLE( 24, params[1] );
	WRITE_SWAPPED_DOUBLE( 32, params[2] );
	WRITE_SWAPPED_DOUBLE( 40, params[3] );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramLocalParameter4fARB( GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_PROGRAMLOCALPARAMETER4FARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLuint, index );
	WRITE_DATA( 16, GLfloat, x );
	WRITE_DATA( 20, GLfloat, y );
	WRITE_DATA( 24, GLfloat, z );
	WRITE_DATA( 28, GLfloat, w );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramLocalParameter4fARBSWAP( GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_PROGRAMLOCALPARAMETER4FARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLuint, SWAP32(index) );
	WRITE_DATA( 16, GLuint, SWAPFLOAT(x) );
	WRITE_DATA( 20, GLuint, SWAPFLOAT(y) );
	WRITE_DATA( 24, GLuint, SWAPFLOAT(z) );
	WRITE_DATA( 28, GLuint, SWAPFLOAT(w) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramLocalParameter4fvARB( GLenum target, GLuint index, const GLfloat * params )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!params) {
        crDebug("App passed NULL as params for ProgramLocalParameter4fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_PROGRAMLOCALPARAMETER4FARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLuint, index );
	WRITE_DATA( 16, GLfloat, params[0] );
	WRITE_DATA( 20, GLfloat, params[1] );
	WRITE_DATA( 24, GLfloat, params[2] );
	WRITE_DATA( 28, GLfloat, params[3] );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramLocalParameter4fvARBSWAP( GLenum target, GLuint index, const GLfloat * params )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!params) {
        crDebug("App passed NULL as params for ProgramLocalParameter4fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_PROGRAMLOCALPARAMETER4FARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLuint, SWAP32(index) );
	WRITE_DATA( 16, GLuint, SWAPFLOAT(params[0]) );
	WRITE_DATA( 20, GLuint, SWAPFLOAT(params[1]) );
	WRITE_DATA( 24, GLuint, SWAPFLOAT(params[2]) );
	WRITE_DATA( 28, GLuint, SWAPFLOAT(params[3]) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramParameter4dNV( GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 48 );
	WRITE_DATA( 0, GLint, 48 );
	WRITE_DATA( 4, GLenum, CR_PROGRAMPARAMETER4DNV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLuint, index );
	WRITE_DOUBLE( 16, x );
	WRITE_DOUBLE( 24, y );
	WRITE_DOUBLE( 32, z );
	WRITE_DOUBLE( 40, w );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramParameter4dNVSWAP( GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 48 );
	WRITE_DATA( 0, GLint, SWAP32(48) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_PROGRAMPARAMETER4DNV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLuint, SWAP32(index) );
	WRITE_SWAPPED_DOUBLE( 16, x );
	WRITE_SWAPPED_DOUBLE( 24, y );
	WRITE_SWAPPED_DOUBLE( 32, z );
	WRITE_SWAPPED_DOUBLE( 40, w );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramParameter4dvNV( GLenum target, GLuint index, const GLdouble * params )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!params) {
        crDebug("App passed NULL as params for ProgramParameter4dvNV");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 48 );
	WRITE_DATA( 0, GLint, 48 );
	WRITE_DATA( 4, GLenum, CR_PROGRAMPARAMETER4DNV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLuint, index );
	WRITE_DOUBLE( 16, params[0] );
	WRITE_DOUBLE( 24, params[1] );
	WRITE_DOUBLE( 32, params[2] );
	WRITE_DOUBLE( 40, params[3] );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramParameter4dvNVSWAP( GLenum target, GLuint index, const GLdouble * params )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!params) {
        crDebug("App passed NULL as params for ProgramParameter4dvNV");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 48 );
	WRITE_DATA( 0, GLint, SWAP32(48) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_PROGRAMPARAMETER4DNV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLuint, SWAP32(index) );
	WRITE_SWAPPED_DOUBLE( 16, params[0] );
	WRITE_SWAPPED_DOUBLE( 24, params[1] );
	WRITE_SWAPPED_DOUBLE( 32, params[2] );
	WRITE_SWAPPED_DOUBLE( 40, params[3] );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramParameter4fNV( GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_PROGRAMPARAMETER4FNV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLuint, index );
	WRITE_DATA( 16, GLfloat, x );
	WRITE_DATA( 20, GLfloat, y );
	WRITE_DATA( 24, GLfloat, z );
	WRITE_DATA( 28, GLfloat, w );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramParameter4fNVSWAP( GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_PROGRAMPARAMETER4FNV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLuint, SWAP32(index) );
	WRITE_DATA( 16, GLuint, SWAPFLOAT(x) );
	WRITE_DATA( 20, GLuint, SWAPFLOAT(y) );
	WRITE_DATA( 24, GLuint, SWAPFLOAT(z) );
	WRITE_DATA( 28, GLuint, SWAPFLOAT(w) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramParameter4fvNV( GLenum target, GLuint index, const GLfloat * params )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!params) {
        crDebug("App passed NULL as params for ProgramParameter4fvNV");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_PROGRAMPARAMETER4FNV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLuint, index );
	WRITE_DATA( 16, GLfloat, params[0] );
	WRITE_DATA( 20, GLfloat, params[1] );
	WRITE_DATA( 24, GLfloat, params[2] );
	WRITE_DATA( 28, GLfloat, params[3] );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackProgramParameter4fvNVSWAP( GLenum target, GLuint index, const GLfloat * params )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!params) {
        crDebug("App passed NULL as params for ProgramParameter4fvNV");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_PROGRAMPARAMETER4FNV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLuint, SWAP32(index) );
	WRITE_DATA( 16, GLuint, SWAPFLOAT(params[0]) );
	WRITE_DATA( 20, GLuint, SWAPFLOAT(params[1]) );
	WRITE_DATA( 24, GLuint, SWAPFLOAT(params[2]) );
	WRITE_DATA( 28, GLuint, SWAPFLOAT(params[3]) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPushAttrib( GLbitfield mask )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, 12 );
	WRITE_DATA( 4, GLenum, CR_PUSHATTRIB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLbitfield, mask );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPushAttribSWAP( GLbitfield mask )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(12) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_PUSHATTRIB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLbitfield, SWAP32(mask) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPushClientAttrib( GLbitfield mask )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, 12 );
	WRITE_DATA( 4, GLenum, CR_PUSHCLIENTATTRIB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLbitfield, mask );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPushClientAttribSWAP( GLbitfield mask )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(12) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_PUSHCLIENTATTRIB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLbitfield, SWAP32(mask) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPushMatrix( void )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_ARGS( pc );
	WRITE_OPCODE( pc, CR_PUSHMATRIX_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPushMatrixSWAP( void )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_ARGS( pc );
	WRITE_OPCODE( pc, CR_PUSHMATRIX_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPushName( GLuint name )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLuint, name );
	WRITE_OPCODE( pc, CR_PUSHNAME_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackPushNameSWAP( GLuint name )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLuint, SWAP32(name) );
	WRITE_OPCODE( pc, CR_PUSHNAME_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos2d( GLdouble x, GLdouble y )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DOUBLE( 0, x );
	WRITE_DOUBLE( 8, y );
	WRITE_OPCODE( pc, CR_RASTERPOS2D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos2dSWAP( GLdouble x, GLdouble y )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_SWAPPED_DOUBLE( 0, x );
	WRITE_SWAPPED_DOUBLE( 8, y );
	WRITE_OPCODE( pc, CR_RASTERPOS2D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos2dv( const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos2dv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DOUBLE( 0, v[0] );
	WRITE_DOUBLE( 8, v[1] );
	WRITE_OPCODE( pc, CR_RASTERPOS2D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos2dvSWAP( const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos2dv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_SWAPPED_DOUBLE( 0, v[0] );
	WRITE_SWAPPED_DOUBLE( 8, v[1] );
	WRITE_OPCODE( pc, CR_RASTERPOS2D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos2f( GLfloat x, GLfloat y )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLfloat, x );
	WRITE_DATA( 4, GLfloat, y );
	WRITE_OPCODE( pc, CR_RASTERPOS2F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos2fSWAP( GLfloat x, GLfloat y )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLuint, SWAPFLOAT(x) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(y) );
	WRITE_OPCODE( pc, CR_RASTERPOS2F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos2fv( const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos2fv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLfloat, v[0] );
	WRITE_DATA( 4, GLfloat, v[1] );
	WRITE_OPCODE( pc, CR_RASTERPOS2F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos2fvSWAP( const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos2fv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLuint, SWAPFLOAT(v[0]) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(v[1]) );
	WRITE_OPCODE( pc, CR_RASTERPOS2F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos2i( GLint x, GLint y )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLint, x );
	WRITE_DATA( 4, GLint, y );
	WRITE_OPCODE( pc, CR_RASTERPOS2I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos2iSWAP( GLint x, GLint y )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLint, SWAP32(x) );
	WRITE_DATA( 4, GLint, SWAP32(y) );
	WRITE_OPCODE( pc, CR_RASTERPOS2I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos2iv( const GLint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos2iv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLint, v[0] );
	WRITE_DATA( 4, GLint, v[1] );
	WRITE_OPCODE( pc, CR_RASTERPOS2I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos2ivSWAP( const GLint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos2iv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLint, SWAP32(v[0]) );
	WRITE_DATA( 4, GLint, SWAP32(v[1]) );
	WRITE_OPCODE( pc, CR_RASTERPOS2I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos2s( GLshort x, GLshort y )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLshort, x );
	WRITE_DATA( 2, GLshort, y );
	WRITE_OPCODE( pc, CR_RASTERPOS2S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos2sSWAP( GLshort x, GLshort y )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLshort, SWAP16(x) );
	WRITE_DATA( 2, GLshort, SWAP16(y) );
	WRITE_OPCODE( pc, CR_RASTERPOS2S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos2sv( const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos2sv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLshort, v[0] );
	WRITE_DATA( 2, GLshort, v[1] );
	WRITE_OPCODE( pc, CR_RASTERPOS2S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos2svSWAP( const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos2sv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLshort, SWAP16(v[0]) );
	WRITE_DATA( 2, GLshort, SWAP16(v[1]) );
	WRITE_OPCODE( pc, CR_RASTERPOS2S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos3d( GLdouble x, GLdouble y, GLdouble z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DOUBLE( 0, x );
	WRITE_DOUBLE( 8, y );
	WRITE_DOUBLE( 16, z );
	WRITE_OPCODE( pc, CR_RASTERPOS3D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos3dSWAP( GLdouble x, GLdouble y, GLdouble z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_SWAPPED_DOUBLE( 0, x );
	WRITE_SWAPPED_DOUBLE( 8, y );
	WRITE_SWAPPED_DOUBLE( 16, z );
	WRITE_OPCODE( pc, CR_RASTERPOS3D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos3dv( const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos3dv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DOUBLE( 0, v[0] );
	WRITE_DOUBLE( 8, v[1] );
	WRITE_DOUBLE( 16, v[2] );
	WRITE_OPCODE( pc, CR_RASTERPOS3D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos3dvSWAP( const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos3dv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_SWAPPED_DOUBLE( 0, v[0] );
	WRITE_SWAPPED_DOUBLE( 8, v[1] );
	WRITE_SWAPPED_DOUBLE( 16, v[2] );
	WRITE_OPCODE( pc, CR_RASTERPOS3D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos3f( GLfloat x, GLfloat y, GLfloat z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLfloat, x );
	WRITE_DATA( 4, GLfloat, y );
	WRITE_DATA( 8, GLfloat, z );
	WRITE_OPCODE( pc, CR_RASTERPOS3F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos3fSWAP( GLfloat x, GLfloat y, GLfloat z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLuint, SWAPFLOAT(x) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(y) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(z) );
	WRITE_OPCODE( pc, CR_RASTERPOS3F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos3fv( const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos3fv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLfloat, v[0] );
	WRITE_DATA( 4, GLfloat, v[1] );
	WRITE_DATA( 8, GLfloat, v[2] );
	WRITE_OPCODE( pc, CR_RASTERPOS3F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos3fvSWAP( const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos3fv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLuint, SWAPFLOAT(v[0]) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(v[1]) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(v[2]) );
	WRITE_OPCODE( pc, CR_RASTERPOS3F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos3i( GLint x, GLint y, GLint z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, x );
	WRITE_DATA( 4, GLint, y );
	WRITE_DATA( 8, GLint, z );
	WRITE_OPCODE( pc, CR_RASTERPOS3I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos3iSWAP( GLint x, GLint y, GLint z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(x) );
	WRITE_DATA( 4, GLint, SWAP32(y) );
	WRITE_DATA( 8, GLint, SWAP32(z) );
	WRITE_OPCODE( pc, CR_RASTERPOS3I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos3iv( const GLint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos3iv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, v[0] );
	WRITE_DATA( 4, GLint, v[1] );
	WRITE_DATA( 8, GLint, v[2] );
	WRITE_OPCODE( pc, CR_RASTERPOS3I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos3ivSWAP( const GLint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos3iv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(v[0]) );
	WRITE_DATA( 4, GLint, SWAP32(v[1]) );
	WRITE_DATA( 8, GLint, SWAP32(v[2]) );
	WRITE_OPCODE( pc, CR_RASTERPOS3I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos3s( GLshort x, GLshort y, GLshort z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLshort, x );
	WRITE_DATA( 2, GLshort, y );
	WRITE_DATA( 4, GLshort, z );
	WRITE_OPCODE( pc, CR_RASTERPOS3S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos3sSWAP( GLshort x, GLshort y, GLshort z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLshort, SWAP16(x) );
	WRITE_DATA( 2, GLshort, SWAP16(y) );
	WRITE_DATA( 4, GLshort, SWAP16(z) );
	WRITE_OPCODE( pc, CR_RASTERPOS3S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos3sv( const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos3sv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLshort, v[0] );
	WRITE_DATA( 2, GLshort, v[1] );
	WRITE_DATA( 4, GLshort, v[2] );
	WRITE_OPCODE( pc, CR_RASTERPOS3S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos3svSWAP( const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos3sv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLshort, SWAP16(v[0]) );
	WRITE_DATA( 2, GLshort, SWAP16(v[1]) );
	WRITE_DATA( 4, GLshort, SWAP16(v[2]) );
	WRITE_OPCODE( pc, CR_RASTERPOS3S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos4d( GLdouble x, GLdouble y, GLdouble z, GLdouble w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DOUBLE( 0, x );
	WRITE_DOUBLE( 8, y );
	WRITE_DOUBLE( 16, z );
	WRITE_DOUBLE( 24, w );
	WRITE_OPCODE( pc, CR_RASTERPOS4D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos4dSWAP( GLdouble x, GLdouble y, GLdouble z, GLdouble w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_SWAPPED_DOUBLE( 0, x );
	WRITE_SWAPPED_DOUBLE( 8, y );
	WRITE_SWAPPED_DOUBLE( 16, z );
	WRITE_SWAPPED_DOUBLE( 24, w );
	WRITE_OPCODE( pc, CR_RASTERPOS4D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos4dv( const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos4dv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DOUBLE( 0, v[0] );
	WRITE_DOUBLE( 8, v[1] );
	WRITE_DOUBLE( 16, v[2] );
	WRITE_DOUBLE( 24, v[3] );
	WRITE_OPCODE( pc, CR_RASTERPOS4D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos4dvSWAP( const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos4dv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_SWAPPED_DOUBLE( 0, v[0] );
	WRITE_SWAPPED_DOUBLE( 8, v[1] );
	WRITE_SWAPPED_DOUBLE( 16, v[2] );
	WRITE_SWAPPED_DOUBLE( 24, v[3] );
	WRITE_OPCODE( pc, CR_RASTERPOS4D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos4f( GLfloat x, GLfloat y, GLfloat z, GLfloat w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLfloat, x );
	WRITE_DATA( 4, GLfloat, y );
	WRITE_DATA( 8, GLfloat, z );
	WRITE_DATA( 12, GLfloat, w );
	WRITE_OPCODE( pc, CR_RASTERPOS4F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos4fSWAP( GLfloat x, GLfloat y, GLfloat z, GLfloat w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLuint, SWAPFLOAT(x) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(y) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(z) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(w) );
	WRITE_OPCODE( pc, CR_RASTERPOS4F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos4fv( const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos4fv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLfloat, v[0] );
	WRITE_DATA( 4, GLfloat, v[1] );
	WRITE_DATA( 8, GLfloat, v[2] );
	WRITE_DATA( 12, GLfloat, v[3] );
	WRITE_OPCODE( pc, CR_RASTERPOS4F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos4fvSWAP( const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos4fv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLuint, SWAPFLOAT(v[0]) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(v[1]) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(v[2]) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(v[3]) );
	WRITE_OPCODE( pc, CR_RASTERPOS4F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos4i( GLint x, GLint y, GLint z, GLint w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, x );
	WRITE_DATA( 4, GLint, y );
	WRITE_DATA( 8, GLint, z );
	WRITE_DATA( 12, GLint, w );
	WRITE_OPCODE( pc, CR_RASTERPOS4I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos4iSWAP( GLint x, GLint y, GLint z, GLint w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(x) );
	WRITE_DATA( 4, GLint, SWAP32(y) );
	WRITE_DATA( 8, GLint, SWAP32(z) );
	WRITE_DATA( 12, GLint, SWAP32(w) );
	WRITE_OPCODE( pc, CR_RASTERPOS4I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos4iv( const GLint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos4iv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, v[0] );
	WRITE_DATA( 4, GLint, v[1] );
	WRITE_DATA( 8, GLint, v[2] );
	WRITE_DATA( 12, GLint, v[3] );
	WRITE_OPCODE( pc, CR_RASTERPOS4I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos4ivSWAP( const GLint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos4iv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(v[0]) );
	WRITE_DATA( 4, GLint, SWAP32(v[1]) );
	WRITE_DATA( 8, GLint, SWAP32(v[2]) );
	WRITE_DATA( 12, GLint, SWAP32(v[3]) );
	WRITE_OPCODE( pc, CR_RASTERPOS4I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos4s( GLshort x, GLshort y, GLshort z, GLshort w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLshort, x );
	WRITE_DATA( 2, GLshort, y );
	WRITE_DATA( 4, GLshort, z );
	WRITE_DATA( 6, GLshort, w );
	WRITE_OPCODE( pc, CR_RASTERPOS4S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos4sSWAP( GLshort x, GLshort y, GLshort z, GLshort w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLshort, SWAP16(x) );
	WRITE_DATA( 2, GLshort, SWAP16(y) );
	WRITE_DATA( 4, GLshort, SWAP16(z) );
	WRITE_DATA( 6, GLshort, SWAP16(w) );
	WRITE_OPCODE( pc, CR_RASTERPOS4S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos4sv( const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos4sv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLshort, v[0] );
	WRITE_DATA( 2, GLshort, v[1] );
	WRITE_DATA( 4, GLshort, v[2] );
	WRITE_DATA( 6, GLshort, v[3] );
	WRITE_OPCODE( pc, CR_RASTERPOS4S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRasterPos4svSWAP( const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for RasterPos4sv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLshort, SWAP16(v[0]) );
	WRITE_DATA( 2, GLshort, SWAP16(v[1]) );
	WRITE_DATA( 4, GLshort, SWAP16(v[2]) );
	WRITE_DATA( 6, GLshort, SWAP16(v[3]) );
	WRITE_OPCODE( pc, CR_RASTERPOS4S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackReadBuffer( GLenum mode )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, 12 );
	WRITE_DATA( 4, GLenum, CR_READBUFFER_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, mode );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackReadBufferSWAP( GLenum mode )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(12) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_READBUFFER_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(mode) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRectd( GLdouble x1, GLdouble y1, GLdouble x2, GLdouble y2 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DOUBLE( 0, x1 );
	WRITE_DOUBLE( 8, y1 );
	WRITE_DOUBLE( 16, x2 );
	WRITE_DOUBLE( 24, y2 );
	WRITE_OPCODE( pc, CR_RECTD_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRectdSWAP( GLdouble x1, GLdouble y1, GLdouble x2, GLdouble y2 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_SWAPPED_DOUBLE( 0, x1 );
	WRITE_SWAPPED_DOUBLE( 8, y1 );
	WRITE_SWAPPED_DOUBLE( 16, x2 );
	WRITE_SWAPPED_DOUBLE( 24, y2 );
	WRITE_OPCODE( pc, CR_RECTD_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRectdv( const GLdouble * v1, const GLdouble * v2 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v1) {
        crDebug("App passed NULL as v1 for Rectdv");
        return;
    }
    if (!v2) {
        crDebug("App passed NULL as v2 for Rectdv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DOUBLE( 0, v1[0] );
	WRITE_DOUBLE( 8, v1[1] );
	WRITE_DOUBLE( 0, v2[0] );
	WRITE_DOUBLE( 8, v2[1] );
	WRITE_OPCODE( pc, CR_RECTD_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRectdvSWAP( const GLdouble * v1, const GLdouble * v2 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v1) {
        crDebug("App passed NULL as v1 for Rectdv");
        return;
    }
    if (!v2) {
        crDebug("App passed NULL as v2 for Rectdv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_SWAPPED_DOUBLE( 0, v1[0] );
	WRITE_SWAPPED_DOUBLE( 8, v1[1] );
	WRITE_SWAPPED_DOUBLE( 0, v2[0] );
	WRITE_SWAPPED_DOUBLE( 8, v2[1] );
	WRITE_OPCODE( pc, CR_RECTD_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRectf( GLfloat x1, GLfloat y1, GLfloat x2, GLfloat y2 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLfloat, x1 );
	WRITE_DATA( 4, GLfloat, y1 );
	WRITE_DATA( 8, GLfloat, x2 );
	WRITE_DATA( 12, GLfloat, y2 );
	WRITE_OPCODE( pc, CR_RECTF_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRectfSWAP( GLfloat x1, GLfloat y1, GLfloat x2, GLfloat y2 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLuint, SWAPFLOAT(x1) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(y1) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(x2) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(y2) );
	WRITE_OPCODE( pc, CR_RECTF_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRectfv( const GLfloat * v1, const GLfloat * v2 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v1) {
        crDebug("App passed NULL as v1 for Rectfv");
        return;
    }
    if (!v2) {
        crDebug("App passed NULL as v2 for Rectfv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLfloat, v1[0] );
	WRITE_DATA( 4, GLfloat, v1[1] );
	WRITE_DATA( 0, GLfloat, v2[0] );
	WRITE_DATA( 4, GLfloat, v2[1] );
	WRITE_OPCODE( pc, CR_RECTF_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRectfvSWAP( const GLfloat * v1, const GLfloat * v2 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v1) {
        crDebug("App passed NULL as v1 for Rectfv");
        return;
    }
    if (!v2) {
        crDebug("App passed NULL as v2 for Rectfv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLuint, SWAPFLOAT(v1[0]) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(v1[1]) );
	WRITE_DATA( 0, GLuint, SWAPFLOAT(v2[0]) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(v2[1]) );
	WRITE_OPCODE( pc, CR_RECTF_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRecti( GLint x1, GLint y1, GLint x2, GLint y2 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, x1 );
	WRITE_DATA( 4, GLint, y1 );
	WRITE_DATA( 8, GLint, x2 );
	WRITE_DATA( 12, GLint, y2 );
	WRITE_OPCODE( pc, CR_RECTI_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRectiSWAP( GLint x1, GLint y1, GLint x2, GLint y2 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(x1) );
	WRITE_DATA( 4, GLint, SWAP32(y1) );
	WRITE_DATA( 8, GLint, SWAP32(x2) );
	WRITE_DATA( 12, GLint, SWAP32(y2) );
	WRITE_OPCODE( pc, CR_RECTI_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRectiv( const GLint * v1, const GLint * v2 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v1) {
        crDebug("App passed NULL as v1 for Rectiv");
        return;
    }
    if (!v2) {
        crDebug("App passed NULL as v2 for Rectiv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, v1[0] );
	WRITE_DATA( 4, GLint, v1[1] );
	WRITE_DATA( 0, GLint, v2[0] );
	WRITE_DATA( 4, GLint, v2[1] );
	WRITE_OPCODE( pc, CR_RECTI_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRectivSWAP( const GLint * v1, const GLint * v2 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v1) {
        crDebug("App passed NULL as v1 for Rectiv");
        return;
    }
    if (!v2) {
        crDebug("App passed NULL as v2 for Rectiv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(v1[0]) );
	WRITE_DATA( 4, GLint, SWAP32(v1[1]) );
	WRITE_DATA( 0, GLint, SWAP32(v2[0]) );
	WRITE_DATA( 4, GLint, SWAP32(v2[1]) );
	WRITE_OPCODE( pc, CR_RECTI_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRects( GLshort x1, GLshort y1, GLshort x2, GLshort y2 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLshort, x1 );
	WRITE_DATA( 2, GLshort, y1 );
	WRITE_DATA( 4, GLshort, x2 );
	WRITE_DATA( 6, GLshort, y2 );
	WRITE_OPCODE( pc, CR_RECTS_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRectsSWAP( GLshort x1, GLshort y1, GLshort x2, GLshort y2 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLshort, SWAP16(x1) );
	WRITE_DATA( 2, GLshort, SWAP16(y1) );
	WRITE_DATA( 4, GLshort, SWAP16(x2) );
	WRITE_DATA( 6, GLshort, SWAP16(y2) );
	WRITE_OPCODE( pc, CR_RECTS_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRectsv( const GLshort * v1, const GLshort * v2 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v1) {
        crDebug("App passed NULL as v1 for Rectsv");
        return;
    }
    if (!v2) {
        crDebug("App passed NULL as v2 for Rectsv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLshort, v1[0] );
	WRITE_DATA( 2, GLshort, v1[1] );
	WRITE_DATA( 0, GLshort, v2[0] );
	WRITE_DATA( 2, GLshort, v2[1] );
	WRITE_OPCODE( pc, CR_RECTS_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRectsvSWAP( const GLshort * v1, const GLshort * v2 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v1) {
        crDebug("App passed NULL as v1 for Rectsv");
        return;
    }
    if (!v2) {
        crDebug("App passed NULL as v2 for Rectsv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLshort, SWAP16(v1[0]) );
	WRITE_DATA( 2, GLshort, SWAP16(v1[1]) );
	WRITE_DATA( 0, GLshort, SWAP16(v2[0]) );
	WRITE_DATA( 2, GLshort, SWAP16(v2[1]) );
	WRITE_OPCODE( pc, CR_RECTS_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRenderMode( GLenum mode, GLint * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_RENDERMODE_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, mode );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRenderModeSWAP( GLenum mode, GLint * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_RENDERMODE_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(mode) );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRenderbufferStorageEXT( GLenum target, GLenum internalformat, GLsizei width, GLsizei height )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, 24 );
	WRITE_DATA( 4, GLenum, CR_RENDERBUFFERSTORAGEEXT_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLenum, internalformat );
	WRITE_DATA( 16, GLsizei, width );
	WRITE_DATA( 20, GLsizei, height );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRenderbufferStorageEXTSWAP( GLenum target, GLenum internalformat, GLsizei width, GLsizei height )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, SWAP32(24) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_RENDERBUFFERSTORAGEEXT_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLenum, SWAP32(internalformat) );
	WRITE_DATA( 16, GLsizei, SWAP32(width) );
	WRITE_DATA( 20, GLsizei, SWAP32(height) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRotated( GLdouble angle, GLdouble x, GLdouble y, GLdouble z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DOUBLE( 0, angle );
	WRITE_DOUBLE( 8, x );
	WRITE_DOUBLE( 16, y );
	WRITE_DOUBLE( 24, z );
	WRITE_OPCODE( pc, CR_ROTATED_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRotatedSWAP( GLdouble angle, GLdouble x, GLdouble y, GLdouble z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_SWAPPED_DOUBLE( 0, angle );
	WRITE_SWAPPED_DOUBLE( 8, x );
	WRITE_SWAPPED_DOUBLE( 16, y );
	WRITE_SWAPPED_DOUBLE( 24, z );
	WRITE_OPCODE( pc, CR_ROTATED_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRotatef( GLfloat angle, GLfloat x, GLfloat y, GLfloat z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLfloat, angle );
	WRITE_DATA( 4, GLfloat, x );
	WRITE_DATA( 8, GLfloat, y );
	WRITE_DATA( 12, GLfloat, z );
	WRITE_OPCODE( pc, CR_ROTATEF_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackRotatefSWAP( GLfloat angle, GLfloat x, GLfloat y, GLfloat z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLuint, SWAPFLOAT(angle) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(x) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(y) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(z) );
	WRITE_OPCODE( pc, CR_ROTATEF_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSampleCoverageARB( GLclampf value, GLboolean invert )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, 16 );
	WRITE_DATA( 4, GLenum, CR_SAMPLECOVERAGEARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLclampf, value );
	WRITE_DATA( 12, GLboolean, invert );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSampleCoverageARBSWAP( GLclampf value, GLboolean invert )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(16) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_SAMPLECOVERAGEARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(value) );
	WRITE_DATA( 12, GLboolean, invert );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackScaled( GLdouble x, GLdouble y, GLdouble z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DOUBLE( 0, x );
	WRITE_DOUBLE( 8, y );
	WRITE_DOUBLE( 16, z );
	WRITE_OPCODE( pc, CR_SCALED_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackScaledSWAP( GLdouble x, GLdouble y, GLdouble z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_SWAPPED_DOUBLE( 0, x );
	WRITE_SWAPPED_DOUBLE( 8, y );
	WRITE_SWAPPED_DOUBLE( 16, z );
	WRITE_OPCODE( pc, CR_SCALED_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackScalef( GLfloat x, GLfloat y, GLfloat z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLfloat, x );
	WRITE_DATA( 4, GLfloat, y );
	WRITE_DATA( 8, GLfloat, z );
	WRITE_OPCODE( pc, CR_SCALEF_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackScalefSWAP( GLfloat x, GLfloat y, GLfloat z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLuint, SWAPFLOAT(x) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(y) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(z) );
	WRITE_OPCODE( pc, CR_SCALEF_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackScissor( GLint x, GLint y, GLsizei width, GLsizei height )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, x );
	WRITE_DATA( 4, GLint, y );
	WRITE_DATA( 8, GLsizei, width );
	WRITE_DATA( 12, GLsizei, height );
	WRITE_OPCODE( pc, CR_SCISSOR_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackScissorSWAP( GLint x, GLint y, GLsizei width, GLsizei height )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(x) );
	WRITE_DATA( 4, GLint, SWAP32(y) );
	WRITE_DATA( 8, GLsizei, SWAP32(width) );
	WRITE_DATA( 12, GLsizei, SWAP32(height) );
	WRITE_OPCODE( pc, CR_SCISSOR_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3bEXT( GLbyte red, GLbyte green, GLbyte blue )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.secondaryColor.b3 = data_ptr;
	WRITE_DATA( 0, GLbyte, red );
	WRITE_DATA( 1, GLbyte, green );
	WRITE_DATA( 2, GLbyte, blue );
	WRITE_OPCODE( pc, CR_SECONDARYCOLOR3BEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3bEXTSWAP( GLbyte red, GLbyte green, GLbyte blue )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.secondaryColor.b3 = data_ptr;
	WRITE_DATA( 0, GLbyte, red );
	WRITE_DATA( 1, GLbyte, green );
	WRITE_DATA( 2, GLbyte, blue );
	WRITE_OPCODE( pc, CR_SECONDARYCOLOR3BEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3bvEXT( const GLbyte * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for SecondaryColor3bvEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.secondaryColor.b3 = data_ptr;
	WRITE_DATA( 0, GLbyte, v[0] );
	WRITE_DATA( 1, GLbyte, v[1] );
	WRITE_DATA( 2, GLbyte, v[2] );
	WRITE_OPCODE( pc, CR_SECONDARYCOLOR3BEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3bvEXTSWAP( const GLbyte * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for SecondaryColor3bvEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.secondaryColor.b3 = data_ptr;
	WRITE_DATA( 0, GLbyte, v[0] );
	WRITE_DATA( 1, GLbyte, v[1] );
	WRITE_DATA( 2, GLbyte, v[2] );
	WRITE_OPCODE( pc, CR_SECONDARYCOLOR3BEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3dEXT( GLdouble red, GLdouble green, GLdouble blue )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	pc->current.c.secondaryColor.d3 = data_ptr;
	WRITE_DOUBLE( 0, red );
	WRITE_DOUBLE( 8, green );
	WRITE_DOUBLE( 16, blue );
	WRITE_OPCODE( pc, CR_SECONDARYCOLOR3DEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3dEXTSWAP( GLdouble red, GLdouble green, GLdouble blue )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	pc->current.c.secondaryColor.d3 = data_ptr;
	WRITE_SWAPPED_DOUBLE( 0, red );
	WRITE_SWAPPED_DOUBLE( 8, green );
	WRITE_SWAPPED_DOUBLE( 16, blue );
	WRITE_OPCODE( pc, CR_SECONDARYCOLOR3DEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3dvEXT( const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for SecondaryColor3dvEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 24 );
	pc->current.c.secondaryColor.d3 = data_ptr;
	WRITE_DOUBLE( 0, v[0] );
	WRITE_DOUBLE( 8, v[1] );
	WRITE_DOUBLE( 16, v[2] );
	WRITE_OPCODE( pc, CR_SECONDARYCOLOR3DEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3dvEXTSWAP( const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for SecondaryColor3dvEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 24 );
	pc->current.c.secondaryColor.d3 = data_ptr;
	WRITE_SWAPPED_DOUBLE( 0, v[0] );
	WRITE_SWAPPED_DOUBLE( 8, v[1] );
	WRITE_SWAPPED_DOUBLE( 16, v[2] );
	WRITE_OPCODE( pc, CR_SECONDARYCOLOR3DEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3fEXT( GLfloat red, GLfloat green, GLfloat blue )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.secondaryColor.f3 = data_ptr;
	WRITE_DATA( 0, GLfloat, red );
	WRITE_DATA( 4, GLfloat, green );
	WRITE_DATA( 8, GLfloat, blue );
	WRITE_OPCODE( pc, CR_SECONDARYCOLOR3FEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3fEXTSWAP( GLfloat red, GLfloat green, GLfloat blue )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.secondaryColor.f3 = data_ptr;
	WRITE_DATA( 0, GLuint, SWAPFLOAT(red) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(green) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(blue) );
	WRITE_OPCODE( pc, CR_SECONDARYCOLOR3FEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3fvEXT( const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.secondaryColor.f3 = data_ptr;
	WRITE_DATA( 0, GLfloat, v[0] );
	WRITE_DATA( 4, GLfloat, v[1] );
	WRITE_DATA( 8, GLfloat, v[2] );
	WRITE_OPCODE( pc, CR_SECONDARYCOLOR3FEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3fvEXTSWAP( const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.secondaryColor.f3 = data_ptr;
	WRITE_DATA( 0, GLuint, SWAPFLOAT(v[0]) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(v[1]) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(v[2]) );
	WRITE_OPCODE( pc, CR_SECONDARYCOLOR3FEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3iEXT( GLint red, GLint green, GLint blue )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.secondaryColor.i3 = data_ptr;
	WRITE_DATA( 0, GLint, red );
	WRITE_DATA( 4, GLint, green );
	WRITE_DATA( 8, GLint, blue );
	WRITE_OPCODE( pc, CR_SECONDARYCOLOR3IEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3iEXTSWAP( GLint red, GLint green, GLint blue )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.secondaryColor.i3 = data_ptr;
	WRITE_DATA( 0, GLint, SWAP32(red) );
	WRITE_DATA( 4, GLint, SWAP32(green) );
	WRITE_DATA( 8, GLint, SWAP32(blue) );
	WRITE_OPCODE( pc, CR_SECONDARYCOLOR3IEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3ivEXT( const GLint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for SecondaryColor3ivEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.secondaryColor.i3 = data_ptr;
	WRITE_DATA( 0, GLint, v[0] );
	WRITE_DATA( 4, GLint, v[1] );
	WRITE_DATA( 8, GLint, v[2] );
	WRITE_OPCODE( pc, CR_SECONDARYCOLOR3IEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3ivEXTSWAP( const GLint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for SecondaryColor3ivEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.secondaryColor.i3 = data_ptr;
	WRITE_DATA( 0, GLint, SWAP32(v[0]) );
	WRITE_DATA( 4, GLint, SWAP32(v[1]) );
	WRITE_DATA( 8, GLint, SWAP32(v[2]) );
	WRITE_OPCODE( pc, CR_SECONDARYCOLOR3IEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3sEXT( GLshort red, GLshort green, GLshort blue )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.secondaryColor.s3 = data_ptr;
	WRITE_DATA( 0, GLshort, red );
	WRITE_DATA( 2, GLshort, green );
	WRITE_DATA( 4, GLshort, blue );
	WRITE_OPCODE( pc, CR_SECONDARYCOLOR3SEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3sEXTSWAP( GLshort red, GLshort green, GLshort blue )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.secondaryColor.s3 = data_ptr;
	WRITE_DATA( 0, GLshort, SWAP16(red) );
	WRITE_DATA( 2, GLshort, SWAP16(green) );
	WRITE_DATA( 4, GLshort, SWAP16(blue) );
	WRITE_OPCODE( pc, CR_SECONDARYCOLOR3SEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3svEXT( const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for SecondaryColor3svEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.secondaryColor.s3 = data_ptr;
	WRITE_DATA( 0, GLshort, v[0] );
	WRITE_DATA( 2, GLshort, v[1] );
	WRITE_DATA( 4, GLshort, v[2] );
	WRITE_OPCODE( pc, CR_SECONDARYCOLOR3SEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3svEXTSWAP( const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for SecondaryColor3svEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.secondaryColor.s3 = data_ptr;
	WRITE_DATA( 0, GLshort, SWAP16(v[0]) );
	WRITE_DATA( 2, GLshort, SWAP16(v[1]) );
	WRITE_DATA( 4, GLshort, SWAP16(v[2]) );
	WRITE_OPCODE( pc, CR_SECONDARYCOLOR3SEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3ubEXT( GLubyte red, GLubyte green, GLubyte blue )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.secondaryColor.ub3 = data_ptr;
	WRITE_DATA( 0, GLubyte, red );
	WRITE_DATA( 1, GLubyte, green );
	WRITE_DATA( 2, GLubyte, blue );
	WRITE_OPCODE( pc, CR_SECONDARYCOLOR3UBEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3ubEXTSWAP( GLubyte red, GLubyte green, GLubyte blue )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.secondaryColor.ub3 = data_ptr;
	WRITE_DATA( 0, GLubyte, red );
	WRITE_DATA( 1, GLubyte, green );
	WRITE_DATA( 2, GLubyte, blue );
	WRITE_OPCODE( pc, CR_SECONDARYCOLOR3UBEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3ubvEXT( const GLubyte * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for SecondaryColor3ubvEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.secondaryColor.ub3 = data_ptr;
	WRITE_DATA( 0, GLubyte, v[0] );
	WRITE_DATA( 1, GLubyte, v[1] );
	WRITE_DATA( 2, GLubyte, v[2] );
	WRITE_OPCODE( pc, CR_SECONDARYCOLOR3UBEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3ubvEXTSWAP( const GLubyte * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for SecondaryColor3ubvEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.secondaryColor.ub3 = data_ptr;
	WRITE_DATA( 0, GLubyte, v[0] );
	WRITE_DATA( 1, GLubyte, v[1] );
	WRITE_DATA( 2, GLubyte, v[2] );
	WRITE_OPCODE( pc, CR_SECONDARYCOLOR3UBEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3uiEXT( GLuint red, GLuint green, GLuint blue )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.secondaryColor.ui3 = data_ptr;
	WRITE_DATA( 0, GLuint, red );
	WRITE_DATA( 4, GLuint, green );
	WRITE_DATA( 8, GLuint, blue );
	WRITE_OPCODE( pc, CR_SECONDARYCOLOR3UIEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3uiEXTSWAP( GLuint red, GLuint green, GLuint blue )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.secondaryColor.ui3 = data_ptr;
	WRITE_DATA( 0, GLuint, SWAP32(red) );
	WRITE_DATA( 4, GLuint, SWAP32(green) );
	WRITE_DATA( 8, GLuint, SWAP32(blue) );
	WRITE_OPCODE( pc, CR_SECONDARYCOLOR3UIEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3uivEXT( const GLuint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for SecondaryColor3uivEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.secondaryColor.ui3 = data_ptr;
	WRITE_DATA( 0, GLuint, v[0] );
	WRITE_DATA( 4, GLuint, v[1] );
	WRITE_DATA( 8, GLuint, v[2] );
	WRITE_OPCODE( pc, CR_SECONDARYCOLOR3UIEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3uivEXTSWAP( const GLuint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for SecondaryColor3uivEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.secondaryColor.ui3 = data_ptr;
	WRITE_DATA( 0, GLuint, SWAP32(v[0]) );
	WRITE_DATA( 4, GLuint, SWAP32(v[1]) );
	WRITE_DATA( 8, GLuint, SWAP32(v[2]) );
	WRITE_OPCODE( pc, CR_SECONDARYCOLOR3UIEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3usEXT( GLushort red, GLushort green, GLushort blue )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.secondaryColor.us3 = data_ptr;
	WRITE_DATA( 0, GLushort, red );
	WRITE_DATA( 2, GLushort, green );
	WRITE_DATA( 4, GLushort, blue );
	WRITE_OPCODE( pc, CR_SECONDARYCOLOR3USEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3usEXTSWAP( GLushort red, GLushort green, GLushort blue )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.secondaryColor.us3 = data_ptr;
	WRITE_DATA( 0, GLushort, SWAP16(red) );
	WRITE_DATA( 2, GLushort, SWAP16(green) );
	WRITE_DATA( 4, GLushort, SWAP16(blue) );
	WRITE_OPCODE( pc, CR_SECONDARYCOLOR3USEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3usvEXT( const GLushort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for SecondaryColor3usvEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.secondaryColor.us3 = data_ptr;
	WRITE_DATA( 0, GLushort, v[0] );
	WRITE_DATA( 2, GLushort, v[1] );
	WRITE_DATA( 4, GLushort, v[2] );
	WRITE_OPCODE( pc, CR_SECONDARYCOLOR3USEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSecondaryColor3usvEXTSWAP( const GLushort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for SecondaryColor3usvEXT");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.secondaryColor.us3 = data_ptr;
	WRITE_DATA( 0, GLushort, SWAP16(v[0]) );
	WRITE_DATA( 2, GLushort, SWAP16(v[1]) );
	WRITE_DATA( 4, GLushort, SWAP16(v[2]) );
	WRITE_OPCODE( pc, CR_SECONDARYCOLOR3USEXT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSemaphoreCreateCR( GLuint name, GLuint count )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, 16 );
	WRITE_DATA( 4, GLenum, CR_SEMAPHORECREATECR_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, name );
	WRITE_DATA( 12, GLuint, count );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSemaphoreCreateCRSWAP( GLuint name, GLuint count )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(16) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_SEMAPHORECREATECR_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(name) );
	WRITE_DATA( 12, GLuint, SWAP32(count) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSemaphoreDestroyCR( GLuint name )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, 12 );
	WRITE_DATA( 4, GLenum, CR_SEMAPHOREDESTROYCR_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, name );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSemaphoreDestroyCRSWAP( GLuint name )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(12) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_SEMAPHOREDESTROYCR_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(name) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSemaphorePCR( GLuint name )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, 12 );
	WRITE_DATA( 4, GLenum, CR_SEMAPHOREPCR_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, name );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSemaphorePCRSWAP( GLuint name )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(12) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_SEMAPHOREPCR_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(name) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSemaphoreVCR( GLuint name )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, 12 );
	WRITE_DATA( 4, GLenum, CR_SEMAPHOREVCR_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, name );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSemaphoreVCRSWAP( GLuint name )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(12) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_SEMAPHOREVCR_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(name) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSetFenceNV( GLuint fence, GLenum condition )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, 16 );
	WRITE_DATA( 4, GLenum, CR_SETFENCENV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, fence );
	WRITE_DATA( 12, GLenum, condition );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSetFenceNVSWAP( GLuint fence, GLenum condition )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(16) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_SETFENCENV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(fence) );
	WRITE_DATA( 12, GLenum, SWAP32(condition) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackShadeModel( GLenum mode )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLenum, mode );
	WRITE_OPCODE( pc, CR_SHADEMODEL_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackShadeModelSWAP( GLenum mode )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLenum, SWAP32(mode) );
	WRITE_OPCODE( pc, CR_SHADEMODEL_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackStencilFunc( GLenum func, GLint ref, GLuint mask )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLenum, func );
	WRITE_DATA( 4, GLint, ref );
	WRITE_DATA( 8, GLuint, mask );
	WRITE_OPCODE( pc, CR_STENCILFUNC_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackStencilFuncSWAP( GLenum func, GLint ref, GLuint mask )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLenum, SWAP32(func) );
	WRITE_DATA( 4, GLint, SWAP32(ref) );
	WRITE_DATA( 8, GLuint, SWAP32(mask) );
	WRITE_OPCODE( pc, CR_STENCILFUNC_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackStencilFuncSeparate( GLenum frontfunc, GLenum backfunc, GLint ref, GLuint mask )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, 24 );
	WRITE_DATA( 4, GLenum, CR_STENCILFUNCSEPARATE_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, frontfunc );
	WRITE_DATA( 12, GLenum, backfunc );
	WRITE_DATA( 16, GLint, ref );
	WRITE_DATA( 20, GLuint, mask );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackStencilFuncSeparateSWAP( GLenum frontfunc, GLenum backfunc, GLint ref, GLuint mask )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, SWAP32(24) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_STENCILFUNCSEPARATE_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(frontfunc) );
	WRITE_DATA( 12, GLenum, SWAP32(backfunc) );
	WRITE_DATA( 16, GLint, SWAP32(ref) );
	WRITE_DATA( 20, GLuint, SWAP32(mask) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackStencilMask( GLuint mask )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLuint, mask );
	WRITE_OPCODE( pc, CR_STENCILMASK_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackStencilMaskSWAP( GLuint mask )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLuint, SWAP32(mask) );
	WRITE_OPCODE( pc, CR_STENCILMASK_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackStencilMaskSeparate( GLenum face, GLuint mask )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, 16 );
	WRITE_DATA( 4, GLenum, CR_STENCILMASKSEPARATE_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, face );
	WRITE_DATA( 12, GLuint, mask );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackStencilMaskSeparateSWAP( GLenum face, GLuint mask )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(16) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_STENCILMASKSEPARATE_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(face) );
	WRITE_DATA( 12, GLuint, SWAP32(mask) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackStencilOp( GLenum fail, GLenum zfail, GLenum zpass )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLenum, fail );
	WRITE_DATA( 4, GLenum, zfail );
	WRITE_DATA( 8, GLenum, zpass );
	WRITE_OPCODE( pc, CR_STENCILOP_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackStencilOpSWAP( GLenum fail, GLenum zfail, GLenum zpass )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLenum, SWAP32(fail) );
	WRITE_DATA( 4, GLenum, SWAP32(zfail) );
	WRITE_DATA( 8, GLenum, SWAP32(zpass) );
	WRITE_OPCODE( pc, CR_STENCILOP_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackStencilOpSeparate( GLenum face, GLenum fail, GLenum zfail, GLenum zpass )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, 24 );
	WRITE_DATA( 4, GLenum, CR_STENCILOPSEPARATE_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, face );
	WRITE_DATA( 12, GLenum, fail );
	WRITE_DATA( 16, GLenum, zfail );
	WRITE_DATA( 20, GLenum, zpass );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackStencilOpSeparateSWAP( GLenum face, GLenum fail, GLenum zfail, GLenum zpass )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, SWAP32(24) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_STENCILOPSEPARATE_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(face) );
	WRITE_DATA( 12, GLenum, SWAP32(fail) );
	WRITE_DATA( 16, GLenum, SWAP32(zfail) );
	WRITE_DATA( 20, GLenum, SWAP32(zpass) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSwapBuffers( GLint window, GLint flags )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, 16 );
	WRITE_DATA( 4, GLenum, CR_SWAPBUFFERS_EXTEND_OPCODE );
	WRITE_DATA( 8, GLint, window );
	WRITE_DATA( 12, GLint, flags );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackSwapBuffersSWAP( GLint window, GLint flags )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(16) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_SWAPBUFFERS_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLint, SWAP32(window) );
	WRITE_DATA( 12, GLint, SWAP32(flags) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTestFenceNV( GLuint fence, GLboolean * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_TESTFENCENV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, fence );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTestFenceNVSWAP( GLuint fence, GLboolean * return_value, int * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_TESTFENCENV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(fence) );
	WRITE_NETWORK_POINTER( 12, (void *) return_value );
	WRITE_NETWORK_POINTER( 20, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord1d( GLdouble s )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.d1[0] = data_ptr;
	WRITE_DOUBLE( 0, s );
	WRITE_OPCODE( pc, CR_TEXCOORD1D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord1dSWAP( GLdouble s )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.d1[0] = data_ptr;
	WRITE_SWAPPED_DOUBLE( 0, s );
	WRITE_OPCODE( pc, CR_TEXCOORD1D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord1dv( const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord1dv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.d1[0] = data_ptr;
	WRITE_DOUBLE( 0, v[0] );
	WRITE_OPCODE( pc, CR_TEXCOORD1D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord1dvSWAP( const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord1dv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.d1[0] = data_ptr;
	WRITE_SWAPPED_DOUBLE( 0, v[0] );
	WRITE_OPCODE( pc, CR_TEXCOORD1D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord1f( GLfloat s )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.texCoord.f1[0] = data_ptr;
	WRITE_DATA( 0, GLfloat, s );
	WRITE_OPCODE( pc, CR_TEXCOORD1F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord1fSWAP( GLfloat s )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.texCoord.f1[0] = data_ptr;
	WRITE_DATA( 0, GLuint, SWAPFLOAT(s) );
	WRITE_OPCODE( pc, CR_TEXCOORD1F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord1fv( const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord1fv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.texCoord.f1[0] = data_ptr;
	WRITE_DATA( 0, GLfloat, v[0] );
	WRITE_OPCODE( pc, CR_TEXCOORD1F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord1fvSWAP( const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord1fv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.texCoord.f1[0] = data_ptr;
	WRITE_DATA( 0, GLuint, SWAPFLOAT(v[0]) );
	WRITE_OPCODE( pc, CR_TEXCOORD1F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord1i( GLint s )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.texCoord.i1[0] = data_ptr;
	WRITE_DATA( 0, GLint, s );
	WRITE_OPCODE( pc, CR_TEXCOORD1I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord1iSWAP( GLint s )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.texCoord.i1[0] = data_ptr;
	WRITE_DATA( 0, GLint, SWAP32(s) );
	WRITE_OPCODE( pc, CR_TEXCOORD1I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord1iv( const GLint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord1iv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.texCoord.i1[0] = data_ptr;
	WRITE_DATA( 0, GLint, v[0] );
	WRITE_OPCODE( pc, CR_TEXCOORD1I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord1ivSWAP( const GLint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord1iv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.texCoord.i1[0] = data_ptr;
	WRITE_DATA( 0, GLint, SWAP32(v[0]) );
	WRITE_OPCODE( pc, CR_TEXCOORD1I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord1s( GLshort s )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.texCoord.s1[0] = data_ptr;
	WRITE_DATA( 0, GLshort, s );
	WRITE_OPCODE( pc, CR_TEXCOORD1S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord1sSWAP( GLshort s )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.texCoord.s1[0] = data_ptr;
	WRITE_DATA( 0, GLshort, SWAP16(s) );
	WRITE_OPCODE( pc, CR_TEXCOORD1S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord1sv( const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord1sv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.texCoord.s1[0] = data_ptr;
	WRITE_DATA( 0, GLshort, v[0] );
	WRITE_OPCODE( pc, CR_TEXCOORD1S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord1svSWAP( const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord1sv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.texCoord.s1[0] = data_ptr;
	WRITE_DATA( 0, GLshort, SWAP16(v[0]) );
	WRITE_OPCODE( pc, CR_TEXCOORD1S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord2d( GLdouble s, GLdouble t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	pc->current.c.texCoord.d2[0] = data_ptr;
	WRITE_DOUBLE( 0, s );
	WRITE_DOUBLE( 8, t );
	WRITE_OPCODE( pc, CR_TEXCOORD2D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord2dSWAP( GLdouble s, GLdouble t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	pc->current.c.texCoord.d2[0] = data_ptr;
	WRITE_SWAPPED_DOUBLE( 0, s );
	WRITE_SWAPPED_DOUBLE( 8, t );
	WRITE_OPCODE( pc, CR_TEXCOORD2D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord2dv( const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord2dv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	pc->current.c.texCoord.d2[0] = data_ptr;
	WRITE_DOUBLE( 0, v[0] );
	WRITE_DOUBLE( 8, v[1] );
	WRITE_OPCODE( pc, CR_TEXCOORD2D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord2dvSWAP( const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord2dv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	pc->current.c.texCoord.d2[0] = data_ptr;
	WRITE_SWAPPED_DOUBLE( 0, v[0] );
	WRITE_SWAPPED_DOUBLE( 8, v[1] );
	WRITE_OPCODE( pc, CR_TEXCOORD2D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord2f( GLfloat s, GLfloat t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.f2[0] = data_ptr;
	WRITE_DATA( 0, GLfloat, s );
	WRITE_DATA( 4, GLfloat, t );
	WRITE_OPCODE( pc, CR_TEXCOORD2F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord2fSWAP( GLfloat s, GLfloat t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.f2[0] = data_ptr;
	WRITE_DATA( 0, GLuint, SWAPFLOAT(s) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(t) );
	WRITE_OPCODE( pc, CR_TEXCOORD2F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord2fv( const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord2fv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.f2[0] = data_ptr;
	WRITE_DATA( 0, GLfloat, v[0] );
	WRITE_DATA( 4, GLfloat, v[1] );
	WRITE_OPCODE( pc, CR_TEXCOORD2F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord2fvSWAP( const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord2fv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.f2[0] = data_ptr;
	WRITE_DATA( 0, GLuint, SWAPFLOAT(v[0]) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(v[1]) );
	WRITE_OPCODE( pc, CR_TEXCOORD2F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord2i( GLint s, GLint t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.i2[0] = data_ptr;
	WRITE_DATA( 0, GLint, s );
	WRITE_DATA( 4, GLint, t );
	WRITE_OPCODE( pc, CR_TEXCOORD2I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord2iSWAP( GLint s, GLint t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.i2[0] = data_ptr;
	WRITE_DATA( 0, GLint, SWAP32(s) );
	WRITE_DATA( 4, GLint, SWAP32(t) );
	WRITE_OPCODE( pc, CR_TEXCOORD2I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord2iv( const GLint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord2iv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.i2[0] = data_ptr;
	WRITE_DATA( 0, GLint, v[0] );
	WRITE_DATA( 4, GLint, v[1] );
	WRITE_OPCODE( pc, CR_TEXCOORD2I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord2ivSWAP( const GLint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord2iv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.i2[0] = data_ptr;
	WRITE_DATA( 0, GLint, SWAP32(v[0]) );
	WRITE_DATA( 4, GLint, SWAP32(v[1]) );
	WRITE_OPCODE( pc, CR_TEXCOORD2I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord2s( GLshort s, GLshort t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.texCoord.s2[0] = data_ptr;
	WRITE_DATA( 0, GLshort, s );
	WRITE_DATA( 2, GLshort, t );
	WRITE_OPCODE( pc, CR_TEXCOORD2S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord2sSWAP( GLshort s, GLshort t )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.texCoord.s2[0] = data_ptr;
	WRITE_DATA( 0, GLshort, SWAP16(s) );
	WRITE_DATA( 2, GLshort, SWAP16(t) );
	WRITE_OPCODE( pc, CR_TEXCOORD2S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord2sv( const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord2sv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.texCoord.s2[0] = data_ptr;
	WRITE_DATA( 0, GLshort, v[0] );
	WRITE_DATA( 2, GLshort, v[1] );
	WRITE_OPCODE( pc, CR_TEXCOORD2S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord2svSWAP( const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord2sv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 4 );
	pc->current.c.texCoord.s2[0] = data_ptr;
	WRITE_DATA( 0, GLshort, SWAP16(v[0]) );
	WRITE_DATA( 2, GLshort, SWAP16(v[1]) );
	WRITE_OPCODE( pc, CR_TEXCOORD2S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord3d( GLdouble s, GLdouble t, GLdouble r )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	pc->current.c.texCoord.d3[0] = data_ptr;
	WRITE_DOUBLE( 0, s );
	WRITE_DOUBLE( 8, t );
	WRITE_DOUBLE( 16, r );
	WRITE_OPCODE( pc, CR_TEXCOORD3D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord3dSWAP( GLdouble s, GLdouble t, GLdouble r )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	pc->current.c.texCoord.d3[0] = data_ptr;
	WRITE_SWAPPED_DOUBLE( 0, s );
	WRITE_SWAPPED_DOUBLE( 8, t );
	WRITE_SWAPPED_DOUBLE( 16, r );
	WRITE_OPCODE( pc, CR_TEXCOORD3D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord3dv( const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord3dv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 24 );
	pc->current.c.texCoord.d3[0] = data_ptr;
	WRITE_DOUBLE( 0, v[0] );
	WRITE_DOUBLE( 8, v[1] );
	WRITE_DOUBLE( 16, v[2] );
	WRITE_OPCODE( pc, CR_TEXCOORD3D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord3dvSWAP( const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord3dv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 24 );
	pc->current.c.texCoord.d3[0] = data_ptr;
	WRITE_SWAPPED_DOUBLE( 0, v[0] );
	WRITE_SWAPPED_DOUBLE( 8, v[1] );
	WRITE_SWAPPED_DOUBLE( 16, v[2] );
	WRITE_OPCODE( pc, CR_TEXCOORD3D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord3f( GLfloat s, GLfloat t, GLfloat r )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.texCoord.f3[0] = data_ptr;
	WRITE_DATA( 0, GLfloat, s );
	WRITE_DATA( 4, GLfloat, t );
	WRITE_DATA( 8, GLfloat, r );
	WRITE_OPCODE( pc, CR_TEXCOORD3F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord3fSWAP( GLfloat s, GLfloat t, GLfloat r )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.texCoord.f3[0] = data_ptr;
	WRITE_DATA( 0, GLuint, SWAPFLOAT(s) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(t) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(r) );
	WRITE_OPCODE( pc, CR_TEXCOORD3F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord3fv( const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord3fv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.texCoord.f3[0] = data_ptr;
	WRITE_DATA( 0, GLfloat, v[0] );
	WRITE_DATA( 4, GLfloat, v[1] );
	WRITE_DATA( 8, GLfloat, v[2] );
	WRITE_OPCODE( pc, CR_TEXCOORD3F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord3fvSWAP( const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord3fv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.texCoord.f3[0] = data_ptr;
	WRITE_DATA( 0, GLuint, SWAPFLOAT(v[0]) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(v[1]) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(v[2]) );
	WRITE_OPCODE( pc, CR_TEXCOORD3F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord3i( GLint s, GLint t, GLint r )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.texCoord.i3[0] = data_ptr;
	WRITE_DATA( 0, GLint, s );
	WRITE_DATA( 4, GLint, t );
	WRITE_DATA( 8, GLint, r );
	WRITE_OPCODE( pc, CR_TEXCOORD3I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord3iSWAP( GLint s, GLint t, GLint r )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.texCoord.i3[0] = data_ptr;
	WRITE_DATA( 0, GLint, SWAP32(s) );
	WRITE_DATA( 4, GLint, SWAP32(t) );
	WRITE_DATA( 8, GLint, SWAP32(r) );
	WRITE_OPCODE( pc, CR_TEXCOORD3I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord3iv( const GLint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord3iv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.texCoord.i3[0] = data_ptr;
	WRITE_DATA( 0, GLint, v[0] );
	WRITE_DATA( 4, GLint, v[1] );
	WRITE_DATA( 8, GLint, v[2] );
	WRITE_OPCODE( pc, CR_TEXCOORD3I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord3ivSWAP( const GLint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord3iv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.texCoord.i3[0] = data_ptr;
	WRITE_DATA( 0, GLint, SWAP32(v[0]) );
	WRITE_DATA( 4, GLint, SWAP32(v[1]) );
	WRITE_DATA( 8, GLint, SWAP32(v[2]) );
	WRITE_OPCODE( pc, CR_TEXCOORD3I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord3s( GLshort s, GLshort t, GLshort r )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.s3[0] = data_ptr;
	WRITE_DATA( 0, GLshort, s );
	WRITE_DATA( 2, GLshort, t );
	WRITE_DATA( 4, GLshort, r );
	WRITE_OPCODE( pc, CR_TEXCOORD3S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord3sSWAP( GLshort s, GLshort t, GLshort r )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.s3[0] = data_ptr;
	WRITE_DATA( 0, GLshort, SWAP16(s) );
	WRITE_DATA( 2, GLshort, SWAP16(t) );
	WRITE_DATA( 4, GLshort, SWAP16(r) );
	WRITE_OPCODE( pc, CR_TEXCOORD3S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord3sv( const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord3sv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.s3[0] = data_ptr;
	WRITE_DATA( 0, GLshort, v[0] );
	WRITE_DATA( 2, GLshort, v[1] );
	WRITE_DATA( 4, GLshort, v[2] );
	WRITE_OPCODE( pc, CR_TEXCOORD3S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord3svSWAP( const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord3sv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.s3[0] = data_ptr;
	WRITE_DATA( 0, GLshort, SWAP16(v[0]) );
	WRITE_DATA( 2, GLshort, SWAP16(v[1]) );
	WRITE_DATA( 4, GLshort, SWAP16(v[2]) );
	WRITE_OPCODE( pc, CR_TEXCOORD3S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord4d( GLdouble s, GLdouble t, GLdouble r, GLdouble q )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	pc->current.c.texCoord.d4[0] = data_ptr;
	WRITE_DOUBLE( 0, s );
	WRITE_DOUBLE( 8, t );
	WRITE_DOUBLE( 16, r );
	WRITE_DOUBLE( 24, q );
	WRITE_OPCODE( pc, CR_TEXCOORD4D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord4dSWAP( GLdouble s, GLdouble t, GLdouble r, GLdouble q )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	pc->current.c.texCoord.d4[0] = data_ptr;
	WRITE_SWAPPED_DOUBLE( 0, s );
	WRITE_SWAPPED_DOUBLE( 8, t );
	WRITE_SWAPPED_DOUBLE( 16, r );
	WRITE_SWAPPED_DOUBLE( 24, q );
	WRITE_OPCODE( pc, CR_TEXCOORD4D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord4dv( const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord4dv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 32 );
	pc->current.c.texCoord.d4[0] = data_ptr;
	WRITE_DOUBLE( 0, v[0] );
	WRITE_DOUBLE( 8, v[1] );
	WRITE_DOUBLE( 16, v[2] );
	WRITE_DOUBLE( 24, v[3] );
	WRITE_OPCODE( pc, CR_TEXCOORD4D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord4dvSWAP( const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord4dv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 32 );
	pc->current.c.texCoord.d4[0] = data_ptr;
	WRITE_SWAPPED_DOUBLE( 0, v[0] );
	WRITE_SWAPPED_DOUBLE( 8, v[1] );
	WRITE_SWAPPED_DOUBLE( 16, v[2] );
	WRITE_SWAPPED_DOUBLE( 24, v[3] );
	WRITE_OPCODE( pc, CR_TEXCOORD4D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord4f( GLfloat s, GLfloat t, GLfloat r, GLfloat q )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	pc->current.c.texCoord.f4[0] = data_ptr;
	WRITE_DATA( 0, GLfloat, s );
	WRITE_DATA( 4, GLfloat, t );
	WRITE_DATA( 8, GLfloat, r );
	WRITE_DATA( 12, GLfloat, q );
	WRITE_OPCODE( pc, CR_TEXCOORD4F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord4fSWAP( GLfloat s, GLfloat t, GLfloat r, GLfloat q )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	pc->current.c.texCoord.f4[0] = data_ptr;
	WRITE_DATA( 0, GLuint, SWAPFLOAT(s) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(t) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(r) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(q) );
	WRITE_OPCODE( pc, CR_TEXCOORD4F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord4fv( const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord4fv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	pc->current.c.texCoord.f4[0] = data_ptr;
	WRITE_DATA( 0, GLfloat, v[0] );
	WRITE_DATA( 4, GLfloat, v[1] );
	WRITE_DATA( 8, GLfloat, v[2] );
	WRITE_DATA( 12, GLfloat, v[3] );
	WRITE_OPCODE( pc, CR_TEXCOORD4F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord4fvSWAP( const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord4fv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	pc->current.c.texCoord.f4[0] = data_ptr;
	WRITE_DATA( 0, GLuint, SWAPFLOAT(v[0]) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(v[1]) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(v[2]) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(v[3]) );
	WRITE_OPCODE( pc, CR_TEXCOORD4F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord4i( GLint s, GLint t, GLint r, GLint q )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	pc->current.c.texCoord.i4[0] = data_ptr;
	WRITE_DATA( 0, GLint, s );
	WRITE_DATA( 4, GLint, t );
	WRITE_DATA( 8, GLint, r );
	WRITE_DATA( 12, GLint, q );
	WRITE_OPCODE( pc, CR_TEXCOORD4I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord4iSWAP( GLint s, GLint t, GLint r, GLint q )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	pc->current.c.texCoord.i4[0] = data_ptr;
	WRITE_DATA( 0, GLint, SWAP32(s) );
	WRITE_DATA( 4, GLint, SWAP32(t) );
	WRITE_DATA( 8, GLint, SWAP32(r) );
	WRITE_DATA( 12, GLint, SWAP32(q) );
	WRITE_OPCODE( pc, CR_TEXCOORD4I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord4iv( const GLint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord4iv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	pc->current.c.texCoord.i4[0] = data_ptr;
	WRITE_DATA( 0, GLint, v[0] );
	WRITE_DATA( 4, GLint, v[1] );
	WRITE_DATA( 8, GLint, v[2] );
	WRITE_DATA( 12, GLint, v[3] );
	WRITE_OPCODE( pc, CR_TEXCOORD4I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord4ivSWAP( const GLint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord4iv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	pc->current.c.texCoord.i4[0] = data_ptr;
	WRITE_DATA( 0, GLint, SWAP32(v[0]) );
	WRITE_DATA( 4, GLint, SWAP32(v[1]) );
	WRITE_DATA( 8, GLint, SWAP32(v[2]) );
	WRITE_DATA( 12, GLint, SWAP32(v[3]) );
	WRITE_OPCODE( pc, CR_TEXCOORD4I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord4s( GLshort s, GLshort t, GLshort r, GLshort q )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.s4[0] = data_ptr;
	WRITE_DATA( 0, GLshort, s );
	WRITE_DATA( 2, GLshort, t );
	WRITE_DATA( 4, GLshort, r );
	WRITE_DATA( 6, GLshort, q );
	WRITE_OPCODE( pc, CR_TEXCOORD4S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord4sSWAP( GLshort s, GLshort t, GLshort r, GLshort q )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.s4[0] = data_ptr;
	WRITE_DATA( 0, GLshort, SWAP16(s) );
	WRITE_DATA( 2, GLshort, SWAP16(t) );
	WRITE_DATA( 4, GLshort, SWAP16(r) );
	WRITE_DATA( 6, GLshort, SWAP16(q) );
	WRITE_OPCODE( pc, CR_TEXCOORD4S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord4sv( const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord4sv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.s4[0] = data_ptr;
	WRITE_DATA( 0, GLshort, v[0] );
	WRITE_DATA( 2, GLshort, v[1] );
	WRITE_DATA( 4, GLshort, v[2] );
	WRITE_DATA( 6, GLshort, v[3] );
	WRITE_OPCODE( pc, CR_TEXCOORD4S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTexCoord4svSWAP( const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for TexCoord4sv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.texCoord.s4[0] = data_ptr;
	WRITE_DATA( 0, GLshort, SWAP16(v[0]) );
	WRITE_DATA( 2, GLshort, SWAP16(v[1]) );
	WRITE_DATA( 4, GLshort, SWAP16(v[2]) );
	WRITE_DATA( 6, GLshort, SWAP16(v[3]) );
	WRITE_OPCODE( pc, CR_TEXCOORD4S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTrackMatrixNV( GLenum target, GLuint address, GLenum matrix, GLenum transform )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, 24 );
	WRITE_DATA( 4, GLenum, CR_TRACKMATRIXNV_EXTEND_OPCODE );
	WRITE_DATA( 8, GLenum, target );
	WRITE_DATA( 12, GLuint, address );
	WRITE_DATA( 16, GLenum, matrix );
	WRITE_DATA( 20, GLenum, transform );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTrackMatrixNVSWAP( GLenum target, GLuint address, GLenum matrix, GLenum transform )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, SWAP32(24) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_TRACKMATRIXNV_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLenum, SWAP32(target) );
	WRITE_DATA( 12, GLuint, SWAP32(address) );
	WRITE_DATA( 16, GLenum, SWAP32(matrix) );
	WRITE_DATA( 20, GLenum, SWAP32(transform) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTranslated( GLdouble x, GLdouble y, GLdouble z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 24, GL_TRUE );
	WRITE_DOUBLE( 0, x );
	WRITE_DOUBLE( 8, y );
	WRITE_DOUBLE( 16, z );
	WRITE_OPCODE( pc, CR_TRANSLATED_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTranslatedSWAP( GLdouble x, GLdouble y, GLdouble z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 24, GL_TRUE );
	WRITE_SWAPPED_DOUBLE( 0, x );
	WRITE_SWAPPED_DOUBLE( 8, y );
	WRITE_SWAPPED_DOUBLE( 16, z );
	WRITE_OPCODE( pc, CR_TRANSLATED_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTranslatef( GLfloat x, GLfloat y, GLfloat z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 12, GL_TRUE );
	WRITE_DATA( 0, GLfloat, x );
	WRITE_DATA( 4, GLfloat, y );
	WRITE_DATA( 8, GLfloat, z );
	WRITE_OPCODE( pc, CR_TRANSLATEF_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackTranslatefSWAP( GLfloat x, GLfloat y, GLfloat z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER_NO_BEGINEND_FLUSH( pc, 12, GL_TRUE );
	WRITE_DATA( 0, GLuint, SWAPFLOAT(x) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(y) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(z) );
	WRITE_OPCODE( pc, CR_TRANSLATEF_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackUniform1f( GLint location, GLfloat v0 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, 16 );
	WRITE_DATA( 4, GLenum, CR_UNIFORM1F_EXTEND_OPCODE );
	WRITE_DATA( 8, GLint, location );
	WRITE_DATA( 12, GLfloat, v0 );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackUniform1fSWAP( GLint location, GLfloat v0 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(16) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_UNIFORM1F_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLint, SWAP32(location) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(v0) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackUniform1i( GLint location, GLint v0 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, 16 );
	WRITE_DATA( 4, GLenum, CR_UNIFORM1I_EXTEND_OPCODE );
	WRITE_DATA( 8, GLint, location );
	WRITE_DATA( 12, GLint, v0 );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackUniform1iSWAP( GLint location, GLint v0 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(16) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_UNIFORM1I_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLint, SWAP32(location) );
	WRITE_DATA( 12, GLint, SWAP32(v0) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackUniform2f( GLint location, GLfloat v0, GLfloat v1 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 20 );
	WRITE_DATA( 0, GLint, 20 );
	WRITE_DATA( 4, GLenum, CR_UNIFORM2F_EXTEND_OPCODE );
	WRITE_DATA( 8, GLint, location );
	WRITE_DATA( 12, GLfloat, v0 );
	WRITE_DATA( 16, GLfloat, v1 );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackUniform2fSWAP( GLint location, GLfloat v0, GLfloat v1 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 20 );
	WRITE_DATA( 0, GLint, SWAP32(20) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_UNIFORM2F_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLint, SWAP32(location) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(v0) );
	WRITE_DATA( 16, GLuint, SWAPFLOAT(v1) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackUniform2i( GLint location, GLint v0, GLint v1 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 20 );
	WRITE_DATA( 0, GLint, 20 );
	WRITE_DATA( 4, GLenum, CR_UNIFORM2I_EXTEND_OPCODE );
	WRITE_DATA( 8, GLint, location );
	WRITE_DATA( 12, GLint, v0 );
	WRITE_DATA( 16, GLint, v1 );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackUniform2iSWAP( GLint location, GLint v0, GLint v1 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 20 );
	WRITE_DATA( 0, GLint, SWAP32(20) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_UNIFORM2I_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLint, SWAP32(location) );
	WRITE_DATA( 12, GLint, SWAP32(v0) );
	WRITE_DATA( 16, GLint, SWAP32(v1) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackUniform3f( GLint location, GLfloat v0, GLfloat v1, GLfloat v2 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, 24 );
	WRITE_DATA( 4, GLenum, CR_UNIFORM3F_EXTEND_OPCODE );
	WRITE_DATA( 8, GLint, location );
	WRITE_DATA( 12, GLfloat, v0 );
	WRITE_DATA( 16, GLfloat, v1 );
	WRITE_DATA( 20, GLfloat, v2 );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackUniform3fSWAP( GLint location, GLfloat v0, GLfloat v1, GLfloat v2 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, SWAP32(24) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_UNIFORM3F_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLint, SWAP32(location) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(v0) );
	WRITE_DATA( 16, GLuint, SWAPFLOAT(v1) );
	WRITE_DATA( 20, GLuint, SWAPFLOAT(v2) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackUniform3i( GLint location, GLint v0, GLint v1, GLint v2 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, 24 );
	WRITE_DATA( 4, GLenum, CR_UNIFORM3I_EXTEND_OPCODE );
	WRITE_DATA( 8, GLint, location );
	WRITE_DATA( 12, GLint, v0 );
	WRITE_DATA( 16, GLint, v1 );
	WRITE_DATA( 20, GLint, v2 );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackUniform3iSWAP( GLint location, GLint v0, GLint v1, GLint v2 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, SWAP32(24) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_UNIFORM3I_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLint, SWAP32(location) );
	WRITE_DATA( 12, GLint, SWAP32(v0) );
	WRITE_DATA( 16, GLint, SWAP32(v1) );
	WRITE_DATA( 20, GLint, SWAP32(v2) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackUniform4f( GLint location, GLfloat v0, GLfloat v1, GLfloat v2, GLfloat v3 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_UNIFORM4F_EXTEND_OPCODE );
	WRITE_DATA( 8, GLint, location );
	WRITE_DATA( 12, GLfloat, v0 );
	WRITE_DATA( 16, GLfloat, v1 );
	WRITE_DATA( 20, GLfloat, v2 );
	WRITE_DATA( 24, GLfloat, v3 );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackUniform4fSWAP( GLint location, GLfloat v0, GLfloat v1, GLfloat v2, GLfloat v3 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_UNIFORM4F_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLint, SWAP32(location) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(v0) );
	WRITE_DATA( 16, GLuint, SWAPFLOAT(v1) );
	WRITE_DATA( 20, GLuint, SWAPFLOAT(v2) );
	WRITE_DATA( 24, GLuint, SWAPFLOAT(v3) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackUniform4i( GLint location, GLint v0, GLint v1, GLint v2, GLint v3 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, 28 );
	WRITE_DATA( 4, GLenum, CR_UNIFORM4I_EXTEND_OPCODE );
	WRITE_DATA( 8, GLint, location );
	WRITE_DATA( 12, GLint, v0 );
	WRITE_DATA( 16, GLint, v1 );
	WRITE_DATA( 20, GLint, v2 );
	WRITE_DATA( 24, GLint, v3 );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackUniform4iSWAP( GLint location, GLint v0, GLint v1, GLint v2, GLint v3 )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	WRITE_DATA( 0, GLint, SWAP32(28) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_UNIFORM4I_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLint, SWAP32(location) );
	WRITE_DATA( 12, GLint, SWAP32(v0) );
	WRITE_DATA( 16, GLint, SWAP32(v1) );
	WRITE_DATA( 20, GLint, SWAP32(v2) );
	WRITE_DATA( 24, GLint, SWAP32(v3) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackUnlockArraysEXT( void )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLint, 8 );
	WRITE_DATA( 4, GLenum, CR_UNLOCKARRAYSEXT_EXTEND_OPCODE );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackUnlockArraysEXTSWAP( void )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLint, SWAP32(8) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_UNLOCKARRAYSEXT_EXTEND_OPCODE) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackUseProgram( GLuint program )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, 12 );
	WRITE_DATA( 4, GLenum, CR_USEPROGRAM_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, program );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackUseProgramSWAP( GLuint program )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(12) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_USEPROGRAM_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(program) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackValidateProgram( GLuint program )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, 12 );
	WRITE_DATA( 4, GLenum, CR_VALIDATEPROGRAM_EXTEND_OPCODE );
	WRITE_DATA( 8, GLuint, program );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackValidateProgramSWAP( GLuint program )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(12) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_VALIDATEPROGRAM_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAP32(program) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex2d( GLdouble x, GLdouble y )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DOUBLE( 0, x );
	WRITE_DOUBLE( 8, y );
	WRITE_OPCODE( pc, CR_VERTEX2D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex2dSWAP( GLdouble x, GLdouble y )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_SWAPPED_DOUBLE( 0, x );
	WRITE_SWAPPED_DOUBLE( 8, y );
	WRITE_OPCODE( pc, CR_VERTEX2D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex2dv( const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex2dv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DOUBLE( 0, v[0] );
	WRITE_DOUBLE( 8, v[1] );
	WRITE_OPCODE( pc, CR_VERTEX2D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex2dvSWAP( const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex2dv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_SWAPPED_DOUBLE( 0, v[0] );
	WRITE_SWAPPED_DOUBLE( 8, v[1] );
	WRITE_OPCODE( pc, CR_VERTEX2D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex2f( GLfloat x, GLfloat y )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLfloat, x );
	WRITE_DATA( 4, GLfloat, y );
	WRITE_OPCODE( pc, CR_VERTEX2F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex2fSWAP( GLfloat x, GLfloat y )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLuint, SWAPFLOAT(x) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(y) );
	WRITE_OPCODE( pc, CR_VERTEX2F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex2fv( const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex2fv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLfloat, v[0] );
	WRITE_DATA( 4, GLfloat, v[1] );
	WRITE_OPCODE( pc, CR_VERTEX2F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex2fvSWAP( const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex2fv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLuint, SWAPFLOAT(v[0]) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(v[1]) );
	WRITE_OPCODE( pc, CR_VERTEX2F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex2i( GLint x, GLint y )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLint, x );
	WRITE_DATA( 4, GLint, y );
	WRITE_OPCODE( pc, CR_VERTEX2I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex2iSWAP( GLint x, GLint y )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLint, SWAP32(x) );
	WRITE_DATA( 4, GLint, SWAP32(y) );
	WRITE_OPCODE( pc, CR_VERTEX2I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex2iv( const GLint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex2iv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLint, v[0] );
	WRITE_DATA( 4, GLint, v[1] );
	WRITE_OPCODE( pc, CR_VERTEX2I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex2ivSWAP( const GLint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex2iv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLint, SWAP32(v[0]) );
	WRITE_DATA( 4, GLint, SWAP32(v[1]) );
	WRITE_OPCODE( pc, CR_VERTEX2I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex2s( GLshort x, GLshort y )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLshort, x );
	WRITE_DATA( 2, GLshort, y );
	WRITE_OPCODE( pc, CR_VERTEX2S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex2sSWAP( GLshort x, GLshort y )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLshort, SWAP16(x) );
	WRITE_DATA( 2, GLshort, SWAP16(y) );
	WRITE_OPCODE( pc, CR_VERTEX2S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex2sv( const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex2sv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLshort, v[0] );
	WRITE_DATA( 2, GLshort, v[1] );
	WRITE_OPCODE( pc, CR_VERTEX2S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex2svSWAP( const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex2sv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 4 );
	WRITE_DATA( 0, GLshort, SWAP16(v[0]) );
	WRITE_DATA( 2, GLshort, SWAP16(v[1]) );
	WRITE_OPCODE( pc, CR_VERTEX2S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex3d( GLdouble x, GLdouble y, GLdouble z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DOUBLE( 0, x );
	WRITE_DOUBLE( 8, y );
	WRITE_DOUBLE( 16, z );
	WRITE_OPCODE( pc, CR_VERTEX3D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex3dSWAP( GLdouble x, GLdouble y, GLdouble z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_SWAPPED_DOUBLE( 0, x );
	WRITE_SWAPPED_DOUBLE( 8, y );
	WRITE_SWAPPED_DOUBLE( 16, z );
	WRITE_OPCODE( pc, CR_VERTEX3D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex3dv( const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex3dv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DOUBLE( 0, v[0] );
	WRITE_DOUBLE( 8, v[1] );
	WRITE_DOUBLE( 16, v[2] );
	WRITE_OPCODE( pc, CR_VERTEX3D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex3dvSWAP( const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex3dv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_SWAPPED_DOUBLE( 0, v[0] );
	WRITE_SWAPPED_DOUBLE( 8, v[1] );
	WRITE_SWAPPED_DOUBLE( 16, v[2] );
	WRITE_OPCODE( pc, CR_VERTEX3D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex3f( GLfloat x, GLfloat y, GLfloat z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLfloat, x );
	WRITE_DATA( 4, GLfloat, y );
	WRITE_DATA( 8, GLfloat, z );
	WRITE_OPCODE( pc, CR_VERTEX3F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex3fSWAP( GLfloat x, GLfloat y, GLfloat z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLuint, SWAPFLOAT(x) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(y) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(z) );
	WRITE_OPCODE( pc, CR_VERTEX3F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex3fv( const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex3fv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLfloat, v[0] );
	WRITE_DATA( 4, GLfloat, v[1] );
	WRITE_DATA( 8, GLfloat, v[2] );
	WRITE_OPCODE( pc, CR_VERTEX3F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex3fvSWAP( const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex3fv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLuint, SWAPFLOAT(v[0]) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(v[1]) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(v[2]) );
	WRITE_OPCODE( pc, CR_VERTEX3F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex3i( GLint x, GLint y, GLint z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, x );
	WRITE_DATA( 4, GLint, y );
	WRITE_DATA( 8, GLint, z );
	WRITE_OPCODE( pc, CR_VERTEX3I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex3iSWAP( GLint x, GLint y, GLint z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(x) );
	WRITE_DATA( 4, GLint, SWAP32(y) );
	WRITE_DATA( 8, GLint, SWAP32(z) );
	WRITE_OPCODE( pc, CR_VERTEX3I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex3iv( const GLint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex3iv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, v[0] );
	WRITE_DATA( 4, GLint, v[1] );
	WRITE_DATA( 8, GLint, v[2] );
	WRITE_OPCODE( pc, CR_VERTEX3I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex3ivSWAP( const GLint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex3iv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(v[0]) );
	WRITE_DATA( 4, GLint, SWAP32(v[1]) );
	WRITE_DATA( 8, GLint, SWAP32(v[2]) );
	WRITE_OPCODE( pc, CR_VERTEX3I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex3s( GLshort x, GLshort y, GLshort z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLshort, x );
	WRITE_DATA( 2, GLshort, y );
	WRITE_DATA( 4, GLshort, z );
	WRITE_OPCODE( pc, CR_VERTEX3S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex3sSWAP( GLshort x, GLshort y, GLshort z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLshort, SWAP16(x) );
	WRITE_DATA( 2, GLshort, SWAP16(y) );
	WRITE_DATA( 4, GLshort, SWAP16(z) );
	WRITE_OPCODE( pc, CR_VERTEX3S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex3sv( const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex3sv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLshort, v[0] );
	WRITE_DATA( 2, GLshort, v[1] );
	WRITE_DATA( 4, GLshort, v[2] );
	WRITE_OPCODE( pc, CR_VERTEX3S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex3svSWAP( const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex3sv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLshort, SWAP16(v[0]) );
	WRITE_DATA( 2, GLshort, SWAP16(v[1]) );
	WRITE_DATA( 4, GLshort, SWAP16(v[2]) );
	WRITE_OPCODE( pc, CR_VERTEX3S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex4d( GLdouble x, GLdouble y, GLdouble z, GLdouble w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DOUBLE( 0, x );
	WRITE_DOUBLE( 8, y );
	WRITE_DOUBLE( 16, z );
	WRITE_DOUBLE( 24, w );
	WRITE_OPCODE( pc, CR_VERTEX4D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex4dSWAP( GLdouble x, GLdouble y, GLdouble z, GLdouble w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_SWAPPED_DOUBLE( 0, x );
	WRITE_SWAPPED_DOUBLE( 8, y );
	WRITE_SWAPPED_DOUBLE( 16, z );
	WRITE_SWAPPED_DOUBLE( 24, w );
	WRITE_OPCODE( pc, CR_VERTEX4D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex4dv( const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex4dv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DOUBLE( 0, v[0] );
	WRITE_DOUBLE( 8, v[1] );
	WRITE_DOUBLE( 16, v[2] );
	WRITE_DOUBLE( 24, v[3] );
	WRITE_OPCODE( pc, CR_VERTEX4D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex4dvSWAP( const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex4dv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_SWAPPED_DOUBLE( 0, v[0] );
	WRITE_SWAPPED_DOUBLE( 8, v[1] );
	WRITE_SWAPPED_DOUBLE( 16, v[2] );
	WRITE_SWAPPED_DOUBLE( 24, v[3] );
	WRITE_OPCODE( pc, CR_VERTEX4D_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex4f( GLfloat x, GLfloat y, GLfloat z, GLfloat w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLfloat, x );
	WRITE_DATA( 4, GLfloat, y );
	WRITE_DATA( 8, GLfloat, z );
	WRITE_DATA( 12, GLfloat, w );
	WRITE_OPCODE( pc, CR_VERTEX4F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex4fSWAP( GLfloat x, GLfloat y, GLfloat z, GLfloat w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLuint, SWAPFLOAT(x) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(y) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(z) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(w) );
	WRITE_OPCODE( pc, CR_VERTEX4F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex4fv( const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex4fv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLfloat, v[0] );
	WRITE_DATA( 4, GLfloat, v[1] );
	WRITE_DATA( 8, GLfloat, v[2] );
	WRITE_DATA( 12, GLfloat, v[3] );
	WRITE_OPCODE( pc, CR_VERTEX4F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex4fvSWAP( const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex4fv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLuint, SWAPFLOAT(v[0]) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(v[1]) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(v[2]) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(v[3]) );
	WRITE_OPCODE( pc, CR_VERTEX4F_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex4i( GLint x, GLint y, GLint z, GLint w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, x );
	WRITE_DATA( 4, GLint, y );
	WRITE_DATA( 8, GLint, z );
	WRITE_DATA( 12, GLint, w );
	WRITE_OPCODE( pc, CR_VERTEX4I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex4iSWAP( GLint x, GLint y, GLint z, GLint w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(x) );
	WRITE_DATA( 4, GLint, SWAP32(y) );
	WRITE_DATA( 8, GLint, SWAP32(z) );
	WRITE_DATA( 12, GLint, SWAP32(w) );
	WRITE_OPCODE( pc, CR_VERTEX4I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex4iv( const GLint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex4iv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, v[0] );
	WRITE_DATA( 4, GLint, v[1] );
	WRITE_DATA( 8, GLint, v[2] );
	WRITE_DATA( 12, GLint, v[3] );
	WRITE_OPCODE( pc, CR_VERTEX4I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex4ivSWAP( const GLint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex4iv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(v[0]) );
	WRITE_DATA( 4, GLint, SWAP32(v[1]) );
	WRITE_DATA( 8, GLint, SWAP32(v[2]) );
	WRITE_DATA( 12, GLint, SWAP32(v[3]) );
	WRITE_OPCODE( pc, CR_VERTEX4I_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex4s( GLshort x, GLshort y, GLshort z, GLshort w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLshort, x );
	WRITE_DATA( 2, GLshort, y );
	WRITE_DATA( 4, GLshort, z );
	WRITE_DATA( 6, GLshort, w );
	WRITE_OPCODE( pc, CR_VERTEX4S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex4sSWAP( GLshort x, GLshort y, GLshort z, GLshort w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLshort, SWAP16(x) );
	WRITE_DATA( 2, GLshort, SWAP16(y) );
	WRITE_DATA( 4, GLshort, SWAP16(z) );
	WRITE_DATA( 6, GLshort, SWAP16(w) );
	WRITE_OPCODE( pc, CR_VERTEX4S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex4sv( const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex4sv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLshort, v[0] );
	WRITE_DATA( 2, GLshort, v[1] );
	WRITE_DATA( 4, GLshort, v[2] );
	WRITE_DATA( 6, GLshort, v[3] );
	WRITE_OPCODE( pc, CR_VERTEX4S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertex4svSWAP( const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for Vertex4sv");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	WRITE_DATA( 0, GLshort, SWAP16(v[0]) );
	WRITE_DATA( 2, GLshort, SWAP16(v[1]) );
	WRITE_DATA( 4, GLshort, SWAP16(v[2]) );
	WRITE_DATA( 6, GLshort, SWAP16(v[3]) );
	WRITE_OPCODE( pc, CR_VERTEX4S_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib1dARB( GLuint index, GLdouble x )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.vertexAttrib.d1[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, index );
	WRITE_DOUBLE( 4, x );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1DARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib1dARBSWAP( GLuint index, GLdouble x )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.vertexAttrib.d1[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_SWAPPED_DOUBLE( 4, x );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1DARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib1dvARB( GLuint index, const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib1dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.vertexAttrib.d1[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, index );
	WRITE_DOUBLE( 4, v[0] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1DARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib1dvARBSWAP( GLuint index, const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib1dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.vertexAttrib.d1[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_SWAPPED_DOUBLE( 4, v[0] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1DARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib1fARB( GLuint index, GLfloat x )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.vertexAttrib.f1[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLfloat, x );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1FARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib1fARBSWAP( GLuint index, GLfloat x )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.vertexAttrib.f1[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(x) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1FARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib1fvARB( GLuint index, const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib1fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.vertexAttrib.f1[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLfloat, v[0] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1FARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib1fvARBSWAP( GLuint index, const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib1fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.vertexAttrib.f1[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(v[0]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1FARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib1sARB( GLuint index, GLshort x )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.vertexAttrib.s1[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLshort, x );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1SARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib1sARBSWAP( GLuint index, GLshort x )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.vertexAttrib.s1[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLshort, SWAP16(x) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1SARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib1svARB( GLuint index, const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib1svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.vertexAttrib.s1[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLshort, v[0] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1SARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib1svARBSWAP( GLuint index, const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib1svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.vertexAttrib.s1[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLshort, SWAP16(v[0]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB1SARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib2dARB( GLuint index, GLdouble x, GLdouble y )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 20 );
	pc->current.c.vertexAttrib.d2[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, index );
	WRITE_DOUBLE( 4, x );
	WRITE_DOUBLE( 12, y );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2DARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib2dARBSWAP( GLuint index, GLdouble x, GLdouble y )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 20 );
	pc->current.c.vertexAttrib.d2[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_SWAPPED_DOUBLE( 4, x );
	WRITE_SWAPPED_DOUBLE( 12, y );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2DARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib2dvARB( GLuint index, const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib2dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 20 );
	pc->current.c.vertexAttrib.d2[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, index );
	WRITE_DOUBLE( 4, v[0] );
	WRITE_DOUBLE( 12, v[1] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2DARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib2dvARBSWAP( GLuint index, const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib2dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 20 );
	pc->current.c.vertexAttrib.d2[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_SWAPPED_DOUBLE( 4, v[0] );
	WRITE_SWAPPED_DOUBLE( 12, v[1] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2DARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib2fARB( GLuint index, GLfloat x, GLfloat y )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.vertexAttrib.f2[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLfloat, x );
	WRITE_DATA( 8, GLfloat, y );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2FARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib2fARBSWAP( GLuint index, GLfloat x, GLfloat y )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.vertexAttrib.f2[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(x) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(y) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2FARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib2fvARB( GLuint index, const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib2fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.vertexAttrib.f2[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLfloat, v[0] );
	WRITE_DATA( 8, GLfloat, v[1] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2FARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib2fvARBSWAP( GLuint index, const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib2fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.vertexAttrib.f2[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(v[0]) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(v[1]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2FARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib2sARB( GLuint index, GLshort x, GLshort y )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.vertexAttrib.s2[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLshort, x );
	WRITE_DATA( 6, GLshort, y );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2SARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib2sARBSWAP( GLuint index, GLshort x, GLshort y )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.vertexAttrib.s2[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLshort, SWAP16(x) );
	WRITE_DATA( 6, GLshort, SWAP16(y) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2SARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib2svARB( GLuint index, const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib2svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.vertexAttrib.s2[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLshort, v[0] );
	WRITE_DATA( 6, GLshort, v[1] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2SARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib2svARBSWAP( GLuint index, const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib2svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.vertexAttrib.s2[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLshort, SWAP16(v[0]) );
	WRITE_DATA( 6, GLshort, SWAP16(v[1]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB2SARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib3dARB( GLuint index, GLdouble x, GLdouble y, GLdouble z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	pc->current.c.vertexAttrib.d3[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, index );
	WRITE_DOUBLE( 4, x );
	WRITE_DOUBLE( 12, y );
	WRITE_DOUBLE( 20, z );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3DARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib3dARBSWAP( GLuint index, GLdouble x, GLdouble y, GLdouble z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 28 );
	pc->current.c.vertexAttrib.d3[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_SWAPPED_DOUBLE( 4, x );
	WRITE_SWAPPED_DOUBLE( 12, y );
	WRITE_SWAPPED_DOUBLE( 20, z );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3DARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib3dvARB( GLuint index, const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib3dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 28 );
	pc->current.c.vertexAttrib.d3[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, index );
	WRITE_DOUBLE( 4, v[0] );
	WRITE_DOUBLE( 12, v[1] );
	WRITE_DOUBLE( 20, v[2] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3DARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib3dvARBSWAP( GLuint index, const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib3dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 28 );
	pc->current.c.vertexAttrib.d3[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_SWAPPED_DOUBLE( 4, v[0] );
	WRITE_SWAPPED_DOUBLE( 12, v[1] );
	WRITE_SWAPPED_DOUBLE( 20, v[2] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3DARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib3fARB( GLuint index, GLfloat x, GLfloat y, GLfloat z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	pc->current.c.vertexAttrib.f3[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLfloat, x );
	WRITE_DATA( 8, GLfloat, y );
	WRITE_DATA( 12, GLfloat, z );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3FARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib3fARBSWAP( GLuint index, GLfloat x, GLfloat y, GLfloat z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	pc->current.c.vertexAttrib.f3[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(x) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(y) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(z) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3FARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib3fvARB( GLuint index, const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib3fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	pc->current.c.vertexAttrib.f3[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLfloat, v[0] );
	WRITE_DATA( 8, GLfloat, v[1] );
	WRITE_DATA( 12, GLfloat, v[2] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3FARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib3fvARBSWAP( GLuint index, const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib3fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	pc->current.c.vertexAttrib.f3[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(v[0]) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(v[1]) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(v[2]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3FARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib3sARB( GLuint index, GLshort x, GLshort y, GLshort z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.vertexAttrib.s3[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLshort, x );
	WRITE_DATA( 6, GLshort, y );
	WRITE_DATA( 8, GLshort, z );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3SARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib3sARBSWAP( GLuint index, GLshort x, GLshort y, GLshort z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.vertexAttrib.s3[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLshort, SWAP16(x) );
	WRITE_DATA( 6, GLshort, SWAP16(y) );
	WRITE_DATA( 8, GLshort, SWAP16(z) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3SARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib3svARB( GLuint index, const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib3svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.vertexAttrib.s3[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLshort, v[0] );
	WRITE_DATA( 6, GLshort, v[1] );
	WRITE_DATA( 8, GLshort, v[2] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3SARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib3svARBSWAP( GLuint index, const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib3svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.vertexAttrib.s3[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLshort, SWAP16(v[0]) );
	WRITE_DATA( 6, GLshort, SWAP16(v[1]) );
	WRITE_DATA( 8, GLshort, SWAP16(v[2]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB3SARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib4NubARB( GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.vertexAttrib.ub4[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLubyte, x );
	WRITE_DATA( 5, GLubyte, y );
	WRITE_DATA( 6, GLubyte, z );
	WRITE_DATA( 7, GLubyte, w );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4NUBARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib4NubARBSWAP( GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 8 );
	pc->current.c.vertexAttrib.ub4[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLubyte, x );
	WRITE_DATA( 5, GLubyte, y );
	WRITE_DATA( 6, GLubyte, z );
	WRITE_DATA( 7, GLubyte, w );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4NUBARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib4dARB( GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 36 );
	pc->current.c.vertexAttrib.d4[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, index );
	WRITE_DOUBLE( 4, x );
	WRITE_DOUBLE( 12, y );
	WRITE_DOUBLE( 20, z );
	WRITE_DOUBLE( 28, w );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4DARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib4dARBSWAP( GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 36 );
	pc->current.c.vertexAttrib.d4[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_SWAPPED_DOUBLE( 4, x );
	WRITE_SWAPPED_DOUBLE( 12, y );
	WRITE_SWAPPED_DOUBLE( 20, z );
	WRITE_SWAPPED_DOUBLE( 28, w );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4DARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib4dvARB( GLuint index, const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib4dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 36 );
	pc->current.c.vertexAttrib.d4[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, index );
	WRITE_DOUBLE( 4, v[0] );
	WRITE_DOUBLE( 12, v[1] );
	WRITE_DOUBLE( 20, v[2] );
	WRITE_DOUBLE( 28, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4DARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib4dvARBSWAP( GLuint index, const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib4dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 36 );
	pc->current.c.vertexAttrib.d4[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_SWAPPED_DOUBLE( 4, v[0] );
	WRITE_SWAPPED_DOUBLE( 12, v[1] );
	WRITE_SWAPPED_DOUBLE( 20, v[2] );
	WRITE_SWAPPED_DOUBLE( 28, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4DARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib4fARB( GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 20 );
	pc->current.c.vertexAttrib.f4[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLfloat, x );
	WRITE_DATA( 8, GLfloat, y );
	WRITE_DATA( 12, GLfloat, z );
	WRITE_DATA( 16, GLfloat, w );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4FARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib4fARBSWAP( GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 20 );
	pc->current.c.vertexAttrib.f4[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(x) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(y) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(z) );
	WRITE_DATA( 16, GLuint, SWAPFLOAT(w) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4FARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib4fvARB( GLuint index, const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib4fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 20 );
	pc->current.c.vertexAttrib.f4[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLfloat, v[0] );
	WRITE_DATA( 8, GLfloat, v[1] );
	WRITE_DATA( 12, GLfloat, v[2] );
	WRITE_DATA( 16, GLfloat, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4FARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib4fvARBSWAP( GLuint index, const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib4fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 20 );
	pc->current.c.vertexAttrib.f4[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLuint, SWAPFLOAT(v[0]) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(v[1]) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(v[2]) );
	WRITE_DATA( 16, GLuint, SWAPFLOAT(v[3]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4FARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib4sARB( GLuint index, GLshort x, GLshort y, GLshort z, GLshort w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.vertexAttrib.s4[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLshort, x );
	WRITE_DATA( 6, GLshort, y );
	WRITE_DATA( 8, GLshort, z );
	WRITE_DATA( 10, GLshort, w );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4SARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib4sARBSWAP( GLuint index, GLshort x, GLshort y, GLshort z, GLshort w )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.vertexAttrib.s4[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLshort, SWAP16(x) );
	WRITE_DATA( 6, GLshort, SWAP16(y) );
	WRITE_DATA( 8, GLshort, SWAP16(z) );
	WRITE_DATA( 10, GLshort, SWAP16(w) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4SARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib4svARB( GLuint index, const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib4svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.vertexAttrib.s4[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, index );
	WRITE_DATA( 4, GLshort, v[0] );
	WRITE_DATA( 6, GLshort, v[1] );
	WRITE_DATA( 8, GLshort, v[2] );
	WRITE_DATA( 10, GLshort, v[3] );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4SARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackVertexAttrib4svARBSWAP( GLuint index, const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for VertexAttrib4svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	pc->current.c.vertexAttrib.s4[index] = data_ptr + 12;
	pc->current.attribsUsedMask |= (1 << index);
	WRITE_DATA( 0, GLuint, SWAP32(index) );
	WRITE_DATA( 4, GLshort, SWAP16(v[0]) );
	WRITE_DATA( 6, GLshort, SWAP16(v[1]) );
	WRITE_DATA( 8, GLshort, SWAP16(v[2]) );
	WRITE_DATA( 10, GLshort, SWAP16(v[3]) );
	WRITE_OPCODE( pc, CR_VERTEXATTRIB4SARB_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackViewport( GLint x, GLint y, GLsizei width, GLsizei height )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, x );
	WRITE_DATA( 4, GLint, y );
	WRITE_DATA( 8, GLsizei, width );
	WRITE_DATA( 12, GLsizei, height );
	WRITE_OPCODE( pc, CR_VIEWPORT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackViewportSWAP( GLint x, GLint y, GLsizei width, GLsizei height )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(x) );
	WRITE_DATA( 4, GLint, SWAP32(y) );
	WRITE_DATA( 8, GLsizei, SWAP32(width) );
	WRITE_DATA( 12, GLsizei, SWAP32(height) );
	WRITE_OPCODE( pc, CR_VIEWPORT_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowDestroy( GLint window )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, 12 );
	WRITE_DATA( 4, GLenum, CR_WINDOWDESTROY_EXTEND_OPCODE );
	WRITE_DATA( 8, GLint, window );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowDestroySWAP( GLint window )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(12) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_WINDOWDESTROY_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLint, SWAP32(window) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos2dARB( GLdouble x, GLdouble y )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, 24 );
	WRITE_DATA( 4, GLenum, CR_WINDOWPOS2DARB_EXTEND_OPCODE );
	WRITE_DOUBLE( 8, x );
	WRITE_DOUBLE( 16, y );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos2dARBSWAP( GLdouble x, GLdouble y )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, SWAP32(24) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_WINDOWPOS2DARB_EXTEND_OPCODE) );
	WRITE_SWAPPED_DOUBLE( 8, x );
	WRITE_SWAPPED_DOUBLE( 16, y );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos2dvARB( const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for WindowPos2dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, 24 );
	WRITE_DATA( 4, GLenum, CR_WINDOWPOS2DARB_EXTEND_OPCODE );
	WRITE_DOUBLE( 8, v[0] );
	WRITE_DOUBLE( 16, v[1] );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos2dvARBSWAP( const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for WindowPos2dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 24 );
	WRITE_DATA( 0, GLint, SWAP32(24) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_WINDOWPOS2DARB_EXTEND_OPCODE) );
	WRITE_SWAPPED_DOUBLE( 8, v[0] );
	WRITE_SWAPPED_DOUBLE( 16, v[1] );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos2fARB( GLfloat x, GLfloat y )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, 16 );
	WRITE_DATA( 4, GLenum, CR_WINDOWPOS2FARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLfloat, x );
	WRITE_DATA( 12, GLfloat, y );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos2fARBSWAP( GLfloat x, GLfloat y )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(16) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_WINDOWPOS2FARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(x) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(y) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos2fvARB( const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for WindowPos2fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, 16 );
	WRITE_DATA( 4, GLenum, CR_WINDOWPOS2FARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLfloat, v[0] );
	WRITE_DATA( 12, GLfloat, v[1] );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos2fvARBSWAP( const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for WindowPos2fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(16) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_WINDOWPOS2FARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(v[0]) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(v[1]) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos2iARB( GLint x, GLint y )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, 16 );
	WRITE_DATA( 4, GLenum, CR_WINDOWPOS2IARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLint, x );
	WRITE_DATA( 12, GLint, y );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos2iARBSWAP( GLint x, GLint y )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(16) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_WINDOWPOS2IARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLint, SWAP32(x) );
	WRITE_DATA( 12, GLint, SWAP32(y) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos2ivARB( const GLint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for WindowPos2ivARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, 16 );
	WRITE_DATA( 4, GLenum, CR_WINDOWPOS2IARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLint, v[0] );
	WRITE_DATA( 12, GLint, v[1] );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos2ivARBSWAP( const GLint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for WindowPos2ivARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(16) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_WINDOWPOS2IARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLint, SWAP32(v[0]) );
	WRITE_DATA( 12, GLint, SWAP32(v[1]) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos2sARB( GLshort x, GLshort y )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, 12 );
	WRITE_DATA( 4, GLenum, CR_WINDOWPOS2SARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLshort, x );
	WRITE_DATA( 10, GLshort, y );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos2sARBSWAP( GLshort x, GLshort y )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(12) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_WINDOWPOS2SARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLshort, SWAP16(x) );
	WRITE_DATA( 10, GLshort, SWAP16(y) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos2svARB( const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for WindowPos2svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, 12 );
	WRITE_DATA( 4, GLenum, CR_WINDOWPOS2SARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLshort, v[0] );
	WRITE_DATA( 10, GLshort, v[1] );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos2svARBSWAP( const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for WindowPos2svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 12 );
	WRITE_DATA( 0, GLint, SWAP32(12) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_WINDOWPOS2SARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLshort, SWAP16(v[0]) );
	WRITE_DATA( 10, GLshort, SWAP16(v[1]) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos3dARB( GLdouble x, GLdouble y, GLdouble z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_WINDOWPOS3DARB_EXTEND_OPCODE );
	WRITE_DOUBLE( 8, x );
	WRITE_DOUBLE( 16, y );
	WRITE_DOUBLE( 24, z );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos3dARBSWAP( GLdouble x, GLdouble y, GLdouble z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_WINDOWPOS3DARB_EXTEND_OPCODE) );
	WRITE_SWAPPED_DOUBLE( 8, x );
	WRITE_SWAPPED_DOUBLE( 16, y );
	WRITE_SWAPPED_DOUBLE( 24, z );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos3dvARB( const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for WindowPos3dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, 32 );
	WRITE_DATA( 4, GLenum, CR_WINDOWPOS3DARB_EXTEND_OPCODE );
	WRITE_DOUBLE( 8, v[0] );
	WRITE_DOUBLE( 16, v[1] );
	WRITE_DOUBLE( 24, v[2] );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos3dvARBSWAP( const GLdouble * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for WindowPos3dvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 32 );
	WRITE_DATA( 0, GLint, SWAP32(32) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_WINDOWPOS3DARB_EXTEND_OPCODE) );
	WRITE_SWAPPED_DOUBLE( 8, v[0] );
	WRITE_SWAPPED_DOUBLE( 16, v[1] );
	WRITE_SWAPPED_DOUBLE( 24, v[2] );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos3fARB( GLfloat x, GLfloat y, GLfloat z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 20 );
	WRITE_DATA( 0, GLint, 20 );
	WRITE_DATA( 4, GLenum, CR_WINDOWPOS3FARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLfloat, x );
	WRITE_DATA( 12, GLfloat, y );
	WRITE_DATA( 16, GLfloat, z );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos3fARBSWAP( GLfloat x, GLfloat y, GLfloat z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 20 );
	WRITE_DATA( 0, GLint, SWAP32(20) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_WINDOWPOS3FARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(x) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(y) );
	WRITE_DATA( 16, GLuint, SWAPFLOAT(z) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos3fvARB( const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for WindowPos3fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 20 );
	WRITE_DATA( 0, GLint, 20 );
	WRITE_DATA( 4, GLenum, CR_WINDOWPOS3FARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLfloat, v[0] );
	WRITE_DATA( 12, GLfloat, v[1] );
	WRITE_DATA( 16, GLfloat, v[2] );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos3fvARBSWAP( const GLfloat * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for WindowPos3fvARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 20 );
	WRITE_DATA( 0, GLint, SWAP32(20) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_WINDOWPOS3FARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLuint, SWAPFLOAT(v[0]) );
	WRITE_DATA( 12, GLuint, SWAPFLOAT(v[1]) );
	WRITE_DATA( 16, GLuint, SWAPFLOAT(v[2]) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos3iARB( GLint x, GLint y, GLint z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 20 );
	WRITE_DATA( 0, GLint, 20 );
	WRITE_DATA( 4, GLenum, CR_WINDOWPOS3IARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLint, x );
	WRITE_DATA( 12, GLint, y );
	WRITE_DATA( 16, GLint, z );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos3iARBSWAP( GLint x, GLint y, GLint z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 20 );
	WRITE_DATA( 0, GLint, SWAP32(20) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_WINDOWPOS3IARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLint, SWAP32(x) );
	WRITE_DATA( 12, GLint, SWAP32(y) );
	WRITE_DATA( 16, GLint, SWAP32(z) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos3ivARB( const GLint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for WindowPos3ivARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 20 );
	WRITE_DATA( 0, GLint, 20 );
	WRITE_DATA( 4, GLenum, CR_WINDOWPOS3IARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLint, v[0] );
	WRITE_DATA( 12, GLint, v[1] );
	WRITE_DATA( 16, GLint, v[2] );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos3ivARBSWAP( const GLint * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for WindowPos3ivARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 20 );
	WRITE_DATA( 0, GLint, SWAP32(20) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_WINDOWPOS3IARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLint, SWAP32(v[0]) );
	WRITE_DATA( 12, GLint, SWAP32(v[1]) );
	WRITE_DATA( 16, GLint, SWAP32(v[2]) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos3sARB( GLshort x, GLshort y, GLshort z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, 16 );
	WRITE_DATA( 4, GLenum, CR_WINDOWPOS3SARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLshort, x );
	WRITE_DATA( 10, GLshort, y );
	WRITE_DATA( 12, GLshort, z );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos3sARBSWAP( GLshort x, GLshort y, GLshort z )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(16) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_WINDOWPOS3SARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLshort, SWAP16(x) );
	WRITE_DATA( 10, GLshort, SWAP16(y) );
	WRITE_DATA( 12, GLshort, SWAP16(z) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos3svARB( const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for WindowPos3svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, 16 );
	WRITE_DATA( 4, GLenum, CR_WINDOWPOS3SARB_EXTEND_OPCODE );
	WRITE_DATA( 8, GLshort, v[0] );
	WRITE_DATA( 10, GLshort, v[1] );
	WRITE_DATA( 12, GLshort, v[2] );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPos3svARBSWAP( const GLshort * v )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
    if (!v) {
        crDebug("App passed NULL as v for WindowPos3svARB");
        return;
    }
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(16) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_WINDOWPOS3SARB_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLshort, SWAP16(v[0]) );
	WRITE_DATA( 10, GLshort, SWAP16(v[1]) );
	WRITE_DATA( 12, GLshort, SWAP16(v[2]) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPosition( GLint window, GLint x, GLint y )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 20 );
	WRITE_DATA( 0, GLint, 20 );
	WRITE_DATA( 4, GLenum, CR_WINDOWPOSITION_EXTEND_OPCODE );
	WRITE_DATA( 8, GLint, window );
	WRITE_DATA( 12, GLint, x );
	WRITE_DATA( 16, GLint, y );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowPositionSWAP( GLint window, GLint x, GLint y )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 20 );
	WRITE_DATA( 0, GLint, SWAP32(20) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_WINDOWPOSITION_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLint, SWAP32(window) );
	WRITE_DATA( 12, GLint, SWAP32(x) );
	WRITE_DATA( 16, GLint, SWAP32(y) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowShow( GLint window, GLint flag )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, 16 );
	WRITE_DATA( 4, GLenum, CR_WINDOWSHOW_EXTEND_OPCODE );
	WRITE_DATA( 8, GLint, window );
	WRITE_DATA( 12, GLint, flag );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowShowSWAP( GLint window, GLint flag )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(16) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_WINDOWSHOW_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLint, SWAP32(window) );
	WRITE_DATA( 12, GLint, SWAP32(flag) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowSize( GLint window, GLint w, GLint h )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 20 );
	WRITE_DATA( 0, GLint, 20 );
	WRITE_DATA( 4, GLenum, CR_WINDOWSIZE_EXTEND_OPCODE );
	WRITE_DATA( 8, GLint, window );
	WRITE_DATA( 12, GLint, w );
	WRITE_DATA( 16, GLint, h );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWindowSizeSWAP( GLint window, GLint w, GLint h )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 20 );
	WRITE_DATA( 0, GLint, SWAP32(20) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_WINDOWSIZE_EXTEND_OPCODE) );
	WRITE_DATA( 8, GLint, SWAP32(window) );
	WRITE_DATA( 12, GLint, SWAP32(w) );
	WRITE_DATA( 16, GLint, SWAP32(h) );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWriteback( GLint * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, 16 );
	WRITE_DATA( 4, GLenum, CR_WRITEBACK_EXTEND_OPCODE );
	WRITE_NETWORK_POINTER( 8, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

void PACK_APIENTRY crPackWritebackSWAP( GLint * writeback )
{
	CR_GET_PACKER_CONTEXT(pc);
	unsigned char *data_ptr;
	(void) pc;
	CR_GET_BUFFERED_POINTER( pc, 16 );
	WRITE_DATA( 0, GLint, SWAP32(16) );
	WRITE_DATA( 4, GLenum, SWAP32(CR_WRITEBACK_EXTEND_OPCODE) );
	WRITE_NETWORK_POINTER( 8, (void *) writeback );
	WRITE_OPCODE( pc, CR_EXTEND_OPCODE );
	CR_UNLOCK_PACKER_CONTEXT(pc);
}

